<?php
/**
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package BrowserCRM
 */

// this page will require authentication, so if a user
// hasn't logged in yet they'll need to post a username & password
// to this page.

// this must come AFTER the login and all params have been processed above
// if fresh login, do header() call to create a non _POSTed page so that refreshing the browser
// does not repost (and display browser repost message)
if ($_POST) {
	$form_address = ($_SERVER['PHP_SELF'] ? $_SERVER['PHP_SELF'] : '');
	$form_address = str_replace('index.php', '', $form_address);  //show clean url; just dir
	
	//append query string as in login.inc.php, but probably is never set once you arrive here
	$query_str = $_SERVER['QUERY_STRING'];
	$form_address .= ($query_str ? '?' . $query_str : '');
	
	header('Location: ' . $form_address); 
	exit();
}

// Phil - use correct charset
$config =& $SERVICES->getService('Config');
$charset = $config->lookup('charset');
if (!$charset) { $charset = 'iso-8859-1'; }
@ini_set('default_charset', $charset);

// 'url' determines the initial contentFrame URL
if (!isset($url)) {
	$SERVICES->getService('Modules');
	$front =& $SERVICES->modules->getModule('Front');
	if (is_object($front) && method_exists($front, 'getDefaultRedirect')) {
		$url = $front->getDefaultRedirect();
	}
}

// User must have at least read access to the front module
$ua =& $SERVICES->getService('Authentication');
$ua->readRestrict('Front');

$output =& $SERVICES->getService('Output', 'header');

// if($output->skin_config['menuFrameHeight'] == null)
	// {$frameHeight = 102;}
// else
// {$frameHeight = $output->skin_config['menuFrameHeight'];}//Alows the Header/Menu Frame Height to be adjusted
$header_height = 74; //72

$page_title = $L['ApplicationTitle'] . ' 5!';
			
includeModule('Front', 'inc/front_manager.inc');
if (!is_object($manager = new FrontMenuManager())) {
	print '<html><body>Error loading menu. Please try again or contact your administrator.</body></html>';
	exit();
}

$show_getting_started = false;
$users =& $SERVICES->getService('Users');
if ($users->getShowWelcomePage()) {
	$show_getting_started = true;
}

$do_redirect = $ua->checkLicence('__unknown__');
$do_redirect = false;

// Phil - used in several places
$has_license = false;
if ($SERVICES->isLicenceFileExisting()) {
	if (!$SERVICES->isExpired()) {
		$has_license = true;
	}
}

$website_url = $SERVICES->getNewsUrl('app/index');
//$help_url = $manager->getHelpLink();
$help_url = $SERVICES->getNewsUrl('app/help');

?><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Frameset//EN" "http://www.w3.org/TR/html4/frameset.dtd">
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html;charset=<?php echo $charset; ?>" />
	<meta http-equiv="Content-Language" content="en-us" />
	<link rel="Shortcut Icon" href="<?php echo $USER['skin_web_path']; ?>favicon.ico" />
	<title><?php echo $page_title; ?></title>
	<link href="<?php echo $USER['base_skin_web_path']; ?>css/header.css" rel="stylesheet" type="text/css" />
	<link rel="stylesheet" type="text/css" href="external/ext/resources/css/ext-all.css" />
	<?php if ($USER['ext_theme']) { 
	echo '
	<link rel="stylesheet" type="text/css" href="external/ext/resources/css/xtheme-' . $USER['ext_theme'] . '.css" />';
	}
	?>
	<!-- Ext ux accordion files -->
	<link rel="stylesheet" type="text/css" href="external/ext-ux/accordion/accordion.css">
	<style>#loading{position:absolute;left:45%;top:40%;border:1px solid #B2D0F7;background:white;padding:10px;font:bold 14px verdana,tahoma,helvetica;color:#003366;width:160px;text-align:center;}.loading-indicator {font-size:8pt;background-image:url('<?php echo $USER['skin_web_path']; ?>img/loading.gif');background-repeat: no-repeat;background-position:top left;padding-left:50px;padding-top:7px;height:24px;text-align:left;}</style>
</head>

<body>
<div id="loading">
	<div class="loading-indicator"><?php print $L['LabelLoading']; ?></div>
</div>
<!-- include everything after the loading indicator -->
<!-- ext base -->   
<script type="text/javascript" src="external/ext/adapter/ext/ext-base.js"></script>     
<script type="text/javascript" src="external/ext/ext-all.js"></script>
<!-- query -->   
<script type="text/javascript" src="external/jquery/jquery.js"></script>
<!-- Ext ux accordion libs -->
<script type="text/javascript" src="external/ext-ux/accordion/Ext.ux.InfoPanel.js"></script>
<script type="text/javascript" src="external/ext-ux/accordion/Ext.ux.Accordion.js"></script>
<!-- ENDLIBS -->

<!-- west region container -->
<div id="west-body"></div>
<!-- center region container -->
<div id ="container">
	<div id="north" class="x-layout-inactive-content">
		<!-- previously Front menu -->
		<?php require_once('menu.inc.php');?>
		<div id="mainmenu"></div>
	</div>
</div>
<!-- MENU -->
<script type="text/javascript">
Ext.BLANK_IMAGE_URL = 'external/ext/resources/images/default/s.gif';

var MainMenu = function(){
	var mainmenu;
	return {
		init : function(){
			Ext.QuickTips.init();
			mainmenu = new Ext.Toolbar('mainmenu');
			<?php
			echo $manager->getMenu();
			?>
			
			<?php
			echo $manager->getMenuButtonFunctions();
			?>
		},
		setAlerts : function(id, value) {
			system_alerts = new Ext.data.Store({
				proxy: new Ext.data.HttpProxy({url: 'modules/Front/refresh.php'}),
				reader: new Ext.data.JsonReader({},['mod', 'alerts']),
				remoteSort: false
			});
			
			system_alerts.on('load', function() {
				i = 0;
				while (system_alerts.getAt(i)) {
					if (mod_data = system_alerts.getAt(i).data) {
						try {
							if (mod_data.alerts) {
								if (mainmenu.items.get('mainmenuItem' + mod_data.mod).getEl(0)) {
									mainmenu.items.get('mainmenuItem' + mod_data.mod).getEl(0).replaceClass('x-btn-text-icon alert-off', 'x-btn-text-icon alert');
								} 
							} else {
								mainmenu.items.get('mainmenuItem' + mod_data.mod).getEl(0).replaceClass('x-btn-text-icon alert', 'x-btn-text-icon alert-off');
							}
						} catch (exception) {
						}
					} else {
						break;
					}
					i++;
				}
			});
			
			system_alerts.load();
			
			<?php
			global $SERVICES;
			$refresh_interval = false;
			if (is_object($SERVICES->getService('Preferences'))) {
				$refresh_interval = intVal($SERVICES->preferences->getUserPref('frontRefresh'));
			}
			if (intVal($refresh_interval) > 0) {
				$refresh_milliseconds = (int)$refresh_interval * 1000;
				?>
			
			timeout = <?php print $refresh_milliseconds; ?>;
			var t = setTimeout(MainMenu.setAlerts, timeout);
				<?php
			}
			?>
			
		}
	};
}();

Ext.onReady(function(){
	// Handle top search functionality
	var searchbtn;
    
    function search(){
		$('#searchForm').submit();
		// window.Layout.showSearch();
    };
    
    searchbtn = new Ext.Button('searchbutton', {
	    text: "<?php echo $L['frontSearchGo'];?>",
		handler: search
	});
	// --
	Ext.EventManager.onDocumentReady(MainMenu.init, MainMenu, true);
	// TODO // 
	Ext.EventManager.onDocumentReady(MainMenu.setAlerts, MainMenu, true);
	
});

Layout = function(){
	var layout, webformDlg, licenceDlg;
	return {
		init : function(){
		   layout = new Ext.BorderLayout(document.body, {
				hideOnLayout: true,
				north: {
					split:false,
					initialSize: <?php echo $header_height; ?>,
					titlebar: false
				},
				west: {
					split:true,
					// initialSize: <?php echo ($show_getting_started ? '300' : '220');?>,
					initialSize: 240,
					minSize: 140,
					maxSize: 600,
					titlebar: true,
					collapsible: true,
					animate: true,
					collapsed: <?php echo ($show_getting_started ? 'false' : 'true');?>,
					tabPosition: 'bottom'					
				},
				center: {
					titlebar: false	,
					autoScroll:false,
					closeOnTab: true,
					//preferredTabWidth: 160,
					//resizeTabs: true,
					alwaysShowTabs: true,
					tabPosition: 'top'					
				}
			});

			layout.beginUpdate();
			layout.add('north', new Ext.ContentPanel('north', 'North'));
			
			// Phil - display west region using Accordian layout
			var acc = new Ext.ux.Accordion('west-body', { 
				//title: '<?php print ($L['PanelsTitle'] ? $L['PanelsTitle'] : '&nbsp;'); ?>'
				title: '&nbsp;'
				, body: 'west-body'
				, fitContainer: true 
				, fitToFrame: true 
				, useShadow: true
			});
			
			// create panels
			
			// Getting Started
			var panel_welcome = acc.add(new Ext.ux.InfoPanel({
				title:'<?php print $L['frontGettingStarted']; ?>'
				, icon: '<?php echo $USER['skin_web_path']; ?>/img/wizard.png'
				, id:'panel-welcome'
				, collapsed: <?php print ( (isset($show_getting_started) && $show_getting_started) ? 'false' : 'true') ?>
				, autoCreate: {
					tag:'div'
				}
			}));
			var panel_welcome_el = panel_welcome.getEl();
			panel_welcome_el.load("modules/Front/getting_started.php");
			
//			// create bottom toolbar for panel 1
//			var panel_welcome_toolbar = panel_welcome.createToolbar([], true);
//			
//			// add greedy spacer to align button right
//			Ext.fly(panel_welcome_toolbar.addSpacer().getEl().parentNode).setStyle('width', '100%');
//			
//			panel_welcome_toolbar.add([{
//				cls: 'x-btn-text'
//				, text: 'Button'
//				, scope: this
//				, handler: function() {
//					alert('You clicked me');
//				}
//			}]);
			
			// Search
			var panel_search = acc.add(new Ext.ux.InfoPanel({
				title:'<?php print $L['LabelSearch']; ?>'
				, icon: '<?php echo $USER['skin_web_path']; ?>/img/search.png'
				, id:'panel-search'
				, autoCreate: {
					tag:'div'
				}
			}));
			var panel_search_el = panel_search.getEl();
			panel_search_el.load("modules/Search/index.php?sidebar=1");
			
			<?php
			// Bookmarks
			global $SERVICES;
			$show_bookmarks = false;
			if (is_object($SERVICES->getService('Preferences'))) {
				$show_bookmarks = intVal($SERVICES->preferences->getUserPref('systemBookmarksShowInPages'));
			} 
			if ($show_bookmarks) {
				?>
			
			var panel_bookmarks = acc.add(new Ext.ux.InfoPanel({
				title:'<?php print $L['LabelBookmarks']; ?>'
				, icon: '<?php echo $USER['skin_web_path']; ?>/img/bookmarks.png'
				, id:'panel-bookmarks'
				, autoCreate: {
					tag:'div'
				}
			}));
			// set content for panel bookmarks
			var panel_bookmarks_el = panel_bookmarks.getEl();
			// panel_bookmarks_el.load("modules/SystemBookmarks/menu.php");
			panel_bookmarks_el.load("modules/Front/bookmarks.php");
			
				<?php
			}
			
			global $SERVICES;
			$show_recent = false;
			if (is_object($SERVICES->getService('Preferences'))) {
				$_last_viewed_scope = intVal($SERVICES->preferences->getUserPref('lastViewedScope'));
				$show_recent = ($_last_viewed_scope == 3 ? false : true);
			} 
			if ($show_recent) {
				?>
			
			// Recent Items
			var panel_recent = acc.add(new Ext.ux.InfoPanel({
				title:'<?php print $L['LabelLastViewed']; ?>'
				, icon: '<?php echo $USER['skin_web_path']; ?>/img/recent.png'
				, id:'panel-recent'
				, autoCreate: {
					tag:'div'
				}
			}));
			// set content for panel recent
			var panel_recent_el = panel_recent.getEl();
			panel_recent_el.load("modules/Front/recent.php");
			
				<?php
			}
			?>
			
			layout.add('west', acc);
			
			<?php
			
			if ($show_getting_started) {
				echo "layout.getRegion('west').showPanel('gettingstarted_panel');
					";
			} else {
//				echo "//layout.getRegion('west').showPanel('search_panel');
//					  //layout.getRegion('west').collapse();
//					";
			}
			?>
			
			// center region
			layout.add('center', new Ext.ContentPanel('content_panel', 
				{
					title: '<?php print $L['LabelDesktop']; ?> &nbsp; &nbsp; &nbsp;',
					fitToFrame: true,
					autoCreate: {
						tag: 'iframe', 
						src: '<?php echo $url; ?>', 
						name: 'contentframe', 
						frameborder: 'no'
					}
				}));
			
			layout.getRegion('center').showPanel('content_panel');
			
			<?php
			if ($show_getting_started) {
				//load help in background tab
				/*echo "
				this.showHelp();
				this.focusContentPanel();
				";
				*/
			}
			?>
			
			layout.endUpdate();
			
			<?php
			// Reload recent and bookmarks panels every 'x' seconds
			global $SERVICES;
			$refresh_interval = false;
			if (is_object($SERVICES->getService('Preferences'))) {
				$refresh_interval = intVal($SERVICES->preferences->getUserPref('frontRefresh'));
			}
			if (intVal($refresh_interval) > 0) {
				$refresh_interval = intVal($refresh_interval);
				?>
				<?php
			if ($show_recent) {
				?>
			if (panel_recent_el) {
				var refresh_interval = <?php print max(60, $refresh_interval); ?>;
				panel_recent_el.getUpdateManager().startAutoRefresh(refresh_interval, 'modules/Front/recent.php');
			}	
				<?php
			}
			?>
			<?php
			if ($show_bookmarks) {
				?>
			if (panel_bookmarks_el) {
				var refresh_interval = <?php print max(60, $refresh_interval); ?>;
				// panel_bookmarks_el.getUpdateManager().startAutoRefresh(refresh_interval, 'modules/SystemBookmarks/menu.php');
				panel_bookmarks_el.getUpdateManager().startAutoRefresh(refresh_interval, 'modules/Front/bookmarks.php');
			}	
				<?php
			}
			?>
			
				<?php
			} 
			?>
		},
		
		showHelp : function(){
			var center = layout.getRegion('center');
			if(center.hasPanel('help_panel')){
				center.showPanel('help_panel');
			} else {
				layout.add('center', new Ext.ContentPanel('help_panel', 
				{
					title: '<?php print $L['Help']; ?>',
					closable: true,
					fitToFrame:true, 
					autoCreate: {
						tag: 'iframe', 
						src: '<?php echo $help_url; ?>', 
						name: 'helpframe', 
						frameborder: 'no'
					}
				}));
			}
		},
		
		showWebsite : function(){
			var center = layout.getRegion('center');
			if(center.hasPanel('website_panel')){
				center.showPanel('website_panel');
			} else {
				layout.add('center', new Ext.ContentPanel('website_panel', 
				{
					title: 'BrowserCRM.com',
					closable: true,
					fitToFrame:true, 
					autoCreate: {
						tag: 'iframe', 
						src: '<?php echo $website_url; ?>', 
						name: 'helpframe', 
						frameborder: 'no'
					}
				}));
			}
		},
		
		
		addTab : function(url, title){
			var center = layout.getRegion('center');
			layout.add('center', new Ext.ContentPanel('', 
			{
				title: title,
				closable: true,
				fitToFrame:true, 
				autoCreate: {
						tag: 'iframe', 
						src: url, 
						name: 'frame', 
						frameborder: 'no'
						}
			}));
		},
		
		updateContentPanelTitle : function(title, name) {
			var center = layout.getRegion('center');
			center.getActivePanel().setTitle(title+ ' &nbsp; &nbsp; &nbsp;');
		},
		
		
		showWebform : function(){
            if(!webformDlg){ // lazy initialize the dialog and only create it once
                webformDlg = new Ext.BasicDialog("webform-dlg", { 
                        autoTabs:true,
                        width:500,
                        height:300,
                        shadow:true,
                        minWidth:300,
                        minHeight:250,
                        proxyDrag: true
                });
                webformDlg.addKeyListener(27, webformDlg.hide, webformDlg);
                webformDlg.addButton('Submit', webformDlg.hide, webformDlg).disable();
                webformDlg.addButton('Close', webformDlg.hide, webformDlg);
            }
            //webformDlg.show(showBtn.dom);
            webformDlg.show();
        },		
		
		showLicence : function(){
            if(!licenceDlg){ // lazy initialize the licenceDlg and only create it once
                licenceDlg = new Ext.LayoutDialog("licence-dlg", { 
                        //modal:true,
						modal:false,
                        width:640,
                        height:520,
                        shadow:true,
                        minWidth:300,
                        minHeight:300,
                        proxyDrag: true,
                       
	                    center: {
	                        autoScroll:true,
							//showTabs: false,
	                        tabPosition: 'top',
	                        closeOnTab: true,
	                        alwaysShowTabs: true
	                    }
                });
                licenceDlg.addKeyListener(27, licenceDlg.hide, licenceDlg);
                licenceDlg.addButton('Close', licenceDlg.hide, licenceDlg);
                
                var lic_layout = licenceDlg.getLayout();
                lic_layout.beginUpdate();
				
				lic_layout.add('center', new Ext.ContentPanel('licence_panel', 
				{
					title: 'License',
					closable: false,
					fitToFrame:true, 
					autoCreate: {
						tag: 'iframe', 
						src: 'licence/index.php?framed=1', 
						name: 'helpframe', 
						frameborder: 'no'
					}
				}));
                
				lic_layout.endUpdate();
				
            }
            licenceDlg.show();
        },
		
		collapseWest : function() {
			layout.getRegion('west').collapse();
		},
		
		loadWebform : function(btn) {
			if (btn == 'yes') {
				window.location.replace("pub/contact.php");
			}
		},
		
		focusContentPanel : function() {
			var center = layout.getRegion('center');
			if(center.hasPanel('content_panel')){
				center.showPanel('content_panel');
				// center.getPanel('content_panel').activate();
			}
		}
	};
}();
Ext.EventManager.onDocumentReady(Layout.init, Layout, true);
<?php
// Phil - show if there is no license.
// After this, need to ensure the active panel is the content_panel (see below)
// to handle page title update
if (!$has_license) {
	?>
Ext.EventManager.onDocumentReady(Layout.showLicence, Layout, true);
	<?php
}

if ($SERVICES->showPromoMessages()) { 
	?>
Ext.EventManager.onDocumentReady(Layout.showWebsite, Layout, true);
	<?php
}
?>
Ext.EventManager.onDocumentReady(Layout.focusContentPanel, Layout, true);
</script>

<div id="webform-dlg" style="visibility:hidden;position:absolute;top:0px;">
<div class="x-dlg-hd">Dialog</div>
<div class="x-dlg-bd">
	<!-- Auto create tab 1 -->
	<div class="x-dlg-tab" title="Webform">
		<!-- Nested "inner-tab" to safely add padding -->
		<div class="inner-tab">
			 will be webform prompt...<br><br><br>
		</div>
	</div>
	</div>
</div>

<div id="licence-dlg" style="visibility:hidden;">
	<div class="x-dlg-hd">License Setup</div>
	<div class="x-dlg-bd">
		<div id="center" class="x-layout-active-content" style="padding:2px;">
			<p></p>
			<p></p>
			<p></p>
		</div>
	</div>
</div>

</body>
</html>