<?php
/**
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @spelling: We will spell licence properly: licence is the noun, to license is the verb  :-) 
 * @author Matt
 * @package LicenceManager
 */


function ioncube_event_handler($err_code, $params) {
	$licence_manager = new licenceManager;
	$licence_manager->main($err_code, $params);
}

if (file_exists('txt/licence.txt')) {
	DEFINE('LICENCE_FILE', true);
} else {
	DEFINE('LICENCE_FILE', false);
}
define('MESSAGE_SHOW_HELP', false);

//this file can be included directly by ioncube for an event
//or from /licence/index.php, so path will vary

//$prepend_path = '../';
$prepend_path = '';
$i = 0; $max = 4;
while (!file_exists($prepend_path . 'prepend.inc')) {
	if ($i > $max) {
	// error
	}
	$prepend_path = '../' . $prepend_path;
	$i++;
}

//if (!$config) {  //if not logged in
/*
if (file_exists($prepend_path . 'config.inc.php')) {
	include_once($prepend_path . 'config.inc.php');
} elseif (file_exists($prepend_path . 'default.config.inc.php')) {
	include_once($prepend_path . 'default.config.inc.php');	
}
*/

//load $config for skin
if (!$config['login']['lang']) {
	$config['login']['lang'] = 'en';
}

include_once($prepend_path . 'lang/en/_Global.inc');
include_once($prepend_path . 'lang/' . $config['login']['lang'] . '/_Global.inc');

include_once($prepend_path . 'lang/en/Licence.inc');
include_once($prepend_path . 'lang/' . $config['login']['lang'] . '/Licence.inc');



/**
 * @spelling: We will spell licence properly: licence is the noun, to license is the verb  :-) 
 * @access private
 */
class licenceManager {
	/**
	 * @access private
	 */
	var $content = '';
	
	/**
	 * @access private
	 */
	var $licence_file = 'txt/licence.txt';
	
	function main($code, $params) {
		// echo '<p>code: ' . $code;
		// echo '<p>params: ';
		// print_r($params);
		// echo '<p>';	
		
		if ($_POST['submit_licence_text'] || $_POST['submit_licence_file']) {
			$this->doPostHandler();
		} else {
		
			switch($code){
				case 'ION_LICENSE_NOT_FOUND':
					$this->getOptions();
					break;
				case 'ION_LICENSE_EXPIRED':
				
					$this->getOptions();
					break;
				
				case 'index':
				default:
					$this->getOptions();
				
			}
		}
		
		//$this->updateData();
		$this->printMessage();
	}

	/** 
	 * @access private
	 */
	function writeNewLicence($string) {
		global $L, $prepend_path;
		// echo '<p>writing ' .$prepend_path . $this->licence_file;echo '<p>'	;
		
		if (file_exists($prepend_path . 'licence/' . $this->licence_file) && is_readable($prepend_path . 'licence/' . $this->licence_file)) {
			//TODO backup
			@copy($prepend_path . 'licence/' . $this->licence_file, $prepend_path . 'licence/' . time() . '_' . $this->licence_file);
			//delete
			if (is_writable($prepend_path . 'licence/' . $this->licence_file)) {
				@unlink($prepend_path . 'licence/' . $this->licence_file);
			}
		}
		
		//stripSlashes 
		$string = stripSlashes($string);
		
		//elementary validation to prevent script upload attacks
		$string = str_replace('<?', '', $string);
		$string = str_replace('?>', '', $string);
		
		//stripSlashes 
		$string = strip_tags($string);
		
		//write
		$handle = @fopen($prepend_path . 'licence/' . $this->licence_file, 'w');
		if ($handle) {
			fwrite($handle, $string);
			fclose($handle);
			return true;
		} else {
			$this->content = '<b>' . $L['FileSystemErrorWritingToFile'] . '</b>';
			
			// Phil 20061204 Lets find out why
			$this->content .= '<div>&nbsp;</div>';
			
			clearstatcache();
			$dir_exists = false;
			$dir_writable = false;
			$file_exists = false;
			$file_writable = false;
			
			// The real licence directory ($this->licence_file may contain sub directories)
			$licence_dir = $prepend_path . 'licence/' . substr($this->licence_file, 0, strpos($this->licence_file, '/'));
			// $this->content .= '<div>[licence directory: ' . $licence_dir . ']</div>';
			
			if (file_exists($licence_dir) && is_dir($licence_dir)) {
				$dir_exists = true;
				
				$this->content .= '<div>[licence directory exists]</div>';
				
				if ( strpos($_SERVER["SERVER_SOFTWARE"], 'IIS') === false) { // IIS returns false positives
				
					if (is_writable($licence_dir)) {
						$dir_writable = true;
						$this->content .= '<div>[licence directory is writeable]</div>';
					} else {
						$dir_writable = false;
						$this->content .= '<div>[licence directory is not writeable]</div>';
						$dir_perms = fileperms($licence_dir);
						$dir_perms_octal = substr(sprintf('%o', $dir_perms), -4);
						$this->content .= '<div>[licence dir permissions: ' . $dir_perms_octal . ' ]</div>';
					}
					
					if (file_exists($licence_dir . '/' . $this->licence_file)) {
						$file_exists = true;
						$this->content .= '<div>[licence file exists]</div>';
						if (is_writable($licence_dir . '/' . $this->licence_file)) {
							$file_writable = true;
							$this->content .= '<div>[licence file is writeable]</div>';
						} else {
							$file_writable = false;
							$this->content .= '<div>>[licence file is not writeable]</div>';
						}
					} else {
						$file_exists = false; // Not necessarily a problem
						$this->content .= '<div>[licence file does not exist]</div>';
					}
					
					// Either way, see if we can write to the file
					$handle = @fopen($prepend_path . 'licence/' . $this->licence_file, 'w');
					if ($handle) {
						$this->content .= '<div>[licence file is writable. Try uploading again.]</div>';
						fclose($handle);
					}
				
				}
				
			} else {
				$this->content .= '<div>[licence directory does not exist]</div>';
				$dir_exists = false;
			}
			
			return false;
		}
	}

	/**
 	 * @access private
	 */
	function doPostHandler() {
		global $L, $prepend_path;
		
		//print_r($_POST);
		
		if ($_POST['submit_licence_text']) {
			
			if (!empty($_POST['licence_text'])) {
				if ($this->writeNewLicence($_POST['licence_text'])) {
					$this->upload_success = true;
					return true;
				} else {
					//$this->content = '<b>ERROR: Failed to upload licence key.</b>';
					//echo '<b>ERROR: Failed to upload licence key.</b>';
					return false;	
				}
			} else {
			 	$this->upload_success = false;
				$this->error_message = $L['licenceInvalidLicenceKey'];
				return false;
			}
		}
		
		if ($_POST['submit_licence_file']) {

			//get current lic
			/*
			if (file_exists($this->licence_file)) { 
				$current_lic = file_get_contents($this->licence_file);
				$data_lic = explode(":", implode(":", explode("\r\n", $current_lic)));
				$current_lic_expiry_date = strtotime("$data_lic[3]");
			} else {
				echo ' no current lic';
			}
			*/
			
			//$uploadDir = '/home/sai/temp/browsercrm/';
			$temp_upload_file = $_FILES['file']['tmp_name'] . '.new';

			//if (move_uploaded_file($_FILES['file']['tmp_name'], $temp_upload_file)) {
			if (is_uploaded_file($_FILES['file']['tmp_name'])) {
				$new_lic = file_get_contents($_FILES['file']['tmp_name']);
				/*
				$data_lic = explode(":", implode(":", explode("\r\n", $new_lic)));
				$new_lic_expiry_date = strtotime("$data_lic[3]");
				*/
				// Licence Validation check for for expiry date and file size	
				//if ($current_lic_expiry_date > $new_lic_expiry_date || $_FILES['file']['size'] > 1000) {
				if ($_FILES['file']['size'] > 1000) {
					unlink($_FILES['file']['tmp_name']);
					$this->content = '<p class="head">' . $L['licenceInvalidLicenceKey'] . '</p>';
					//$this->content .= '<br><a href=upload.php">Click to Retry.</a>';					include('../message.inc.php');
					return false;
				}

				//Takes backup of the current installed licence key.
				//if ($_POST['backup'] == 1) {
					//$src_file = $upload_dir.'txt/licence.txt';
					//$dest_file = $upload_dir . date("Ymd_Gis") . '_txt/licence.txt';
					$src_file = 'txt/licence.txt';
					
					//ok, this is a security flaw - attacker could load the server with 1000s of backups and fill the disk
					$dest_file = 'txt/' . date("Ymd_Gis") . '_licence.txt';
					if (file_exists($src_file)) {
						if (!@copy($src_file, $dest_file)) {
							$this->content = $L['licenceBackupFailed'];
							return false;
						}
					}
				//}

				//test $new_lic, is it a valid lic?
				
				
				//if (rename($temp_upload_file, $upload_dir."$licence_file")) {
				if ($this->writeNewLicence($new_lic)) {
					$this->upload_success = true;
					return true;
				} else {
					//$this->content = '<b>ERROR: Failed to upload licence key.</b>';
					return false;	
				}
			} else {
				$this->upload_success = false;
				$this->error_message = $L['licenceInvalidLicenceKey'];
				return false;
			}
		}
	}
	
	/**
 	 * @access private
	 */
	function updateData() {
		global $L;
	}

	/** 
	 * @access private
	 */
	function getOptions() {
		global $L, $prepend_path;
		//test
		if (!file_exists($prepend_path . 'licence/' . $this->licence_file)) {
			$this->content .= '<p>' . $L['licenceNoLicenceFile'] . '. ';
			if (!LICENCE_FILE) {
				$this->content .= '<a href="http://www.browsercrm.com/app_redirect.php?fn=buy" target="_blank">' . $L['licenceGetNewKey'] . '</a>';
			} 
			$this->content .= '</p><p>&nbsp;</p>';
		} else {
			$this->content .= '<p><a href="' . $prepend_path . 'licence/view.php?framed=' . $_GET['framed'] . '">' . $L['licenceViewCurrent'] . ' &gt</a></p>';
			$this->content .= '<p>&nbsp;</p>';
		}
	
		//handle upgardes within app
		// else {
			// $this->content .= '<p><a href="http://www.browsercrm.com/app_redirect.php?fn=upgrade" target="_blank">' . $L['licenceGetUpgrade'] . '</a></p>';
		// }
		//$this->content .= '<p>&nbsp;</p>';
		//$this->content .= '<p>&nbsp;</p>';
		
		$this->content .= '<table border="0" cellpadding="4" cellspacing="4" width="100%"><tr><td valign="top">';
		
		$this->content .= '<form method="post" action="' . $prepend_path . 'licence/?framed=' . $_GET['framed'] . '" enctype="multipart/form-data">';
		//$this->content .= '<input type="hidden" name="framed" value="' . $_GET['framed'] . '">';
		$this->content .= '<p class="head">' . $L['licenceUploadKeyLabel'] . ':</p>';
		$this->content .= '<input type="file" name="file" /><br><br>';
		//$this->content .= '<input type="checkbox" name="backup" CHECKED value="1">&nbsp;Backup current licence key:<br><br>';
		$this->content .= '<input type="submit" name="submit_licence_file" value="' . $L['licenceButtonUploadFile'] . '" />';
		$this->content .= '</form>';
		
		$this->content .= '</td><td style="width:20px"></td><td valign="top">';
		
		// $this->content .= '<p>&nbsp;</p>';
		// $this->content .= '<div style="padding-left:100px"> --- ' . $L['licenceOr'] . '--- </div>';
		// $this->content .= '<p>&nbsp;</p>';
		
		$this->content .= '<form method="post" action="' . $prepend_path . 'licence/?framed=' . $_GET['framed'] . '" enctype="multipart/form-data">';
		//$this->content .= '<input type="hidden" name="framed" value="' . $_GET['framed'] . '">';
		$this->content .= '<p class="head">' . $L['licenceCopyPasteKeyLabel'] . ':</p>';
		$this->content .= '<textarea rows="6" style="width:240px" name="licence_text"></textarea><br>&nbsp;<br><input type="submit" name="submit_licence_text" value="' . $L['licenceButtonUploadKey'] . '"/>';
		$this->content .= '</form>';
		
		$this->content .= '</table>';
	}
	
	/** 
	 * @access private
	 */
	function testLicenceWithTestFile() {
	
	}
	
	/** 
	 * @access private
	 */
	function getLicenceValidationMessage() {
		global $L, $prepend_path;
		
		if ($this->testLicenceWithTestFile()) {
			$message_body .= '<p class="head">' . $L['licenceLicenceKeyInstalledSuccesfully'] . '</p>';
			$message_body .= '<p>&nbsp;</p>';
			$message_body .= '<p><a href="' . $prepend_path . 'licence/view.php?framed=' . $_GET['framed'] . '">' . $L['licenceViewCurrent'] . ' &gt</a></p>';
		} else {
			$message_body .= '<p class="head">' . $L['licenceLicenceKeyInstalledNotVerified'] . '</p>';
			$message_body .= '<p>&nbsp;</p>';
			$message_body .= '<p><a href="' . $prepend_path . 'licence/view.php?framed=' . $_GET['framed'] . '">' . $L['licenceViewCurrent'] . ' &gt</a></p>';
		}
		$message_body .= '<p>&nbsp;</p>';
		$message_body .= '<p>&nbsp;</p>';
		
		return $message_body;
	}
	
	/** 
	 * @access private
	 */
	function printMessage() {
		global $L, $prepend_path;
		
		$message_title = $L['licenceUploadLicence'];
		$message_body = $this->content;
		
		if ($this->upload_success) {
			
			$message_body .= $this->getLicenceValidationMessage();
			
			if (!$_GET['framed']) {
				$message_body .= '<div class="eButtTxt" align="center"><div>';
				$message_body .= '<p class="continue"><a href="' . $prepend_path . '">' . $L['licenceStart'] . ' &gt</a></p>';
				$message_body .= '</div></div>';
				$message_body .= '<p>&nbsp;</p>';
			}
		} elseif ($this->upload_success === false) {
			$message_body .= '<p class="head">' . $L['licenceLicenceKeyNotInstalled'] . '</p>';
			$message_body .= '<p class="head">' . $L['licenceLicenceKeyNotInstalledHelp'] . '</p>';
			$message_body .= '<p>&nbsp;</p>';
			$message_body .= $this->error_message;
			$message_body .= '<p>&nbsp;</p>';
		}
		
		include($prepend_path . 'message.inc.php');
		exit();

	}
	
	/** 
	 * @access private
	 */
	function getIoncubeFileProperties() {
		if (function_exists('ioncube_file_properties')) {
			//echo 'returning';
			return ioncube_file_properties();
		} else {
			return false;
		}
	}
	
	/** 
	 * @access private
	 */
	function getIoncubeFileInfo() {
		if (function_exists('ioncube_file_info')) {
			//echo 'returning';
			return ioncube_file_info();
		} else {
			return false;
		}
	}
}
?>