<?php
require_once("prepend.inc");
/**
 * Display the menu frame
 *
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 Limited
 * @link http://www.browsercrm.com/
 * @package Front
 */

// ------------------------------------------------------

//flush upsets ext; menu will be AJAX
//ob_start(); // Phil: Buffer output so we can explicitly flush before checking alerts

includeModule('Front', 'inc/front_manager.inc');

if (!is_object($manager = new FrontMenuManager())) {
	print '<html><body>Error loading menu. Please try again or contact your administrator.</body></html>';
	exit();
}

global $SERVICES, $USER;
$output =& $SERVICES->getService('Output', 'header');

// todo put into skin config
$showcurve = $output->skin_config['showMenuTitleCurve'];
// -----
$menuLeftPad = $output->skin_config['menuLeftPad'];

//it is a violation of the terms of the licence agreement to alter or modify the
//user count reporting
$skin_path = $USER['skin_web_path'];
$js_path = $USER['js_web_path'];

$trial_message = 'expires in xxx buy now';

$help_link = $manager->getHelpLink();

$help_options = array(
	'window_name' => 'helpw',
	'save_to' => 'helpw',
	'vars' => array('helpid', 'ref'),
	'url' => $help_link . '?id=%helpid%&r=%ref%',
	'window_name' => 'help',
	'height' => 500,
	'width' => 880,
	'top' => 80,
	'left' => 80,
	'menubar' => true,
	'scrollbars' => true,
	'resizable' => true,
	'controls' => true
);
$output->addJSPopup('loadhelp', $help_options);

//$output->getLinkHelp();  //triggers the loadhelp script


// ----------- Output -----------------------------------------------------
echo $output->getJsLangVars();

//not needed?? - menu is ext 
//<script language="JavaScript" type="text/javascript" src="' . $js_path . 'menu.js"></script>

//removed as it conflicts with ext; causes a ghost box to show on load
//<script language="JavaScript" type="text/javascript" src="' . $js_path . 'browser.js"></script>

//removed text title
//<span id="logoTxt" style="visibility: hidden;"> ' . $manager->getApplicationTitle() . '</span>

echo '
<script language="JavaScript" type="text/javascript" src="' . $skin_path . 'js/variables.js"></script>
<script language="JavaScript" type="text/javascript">
	' . implode('', $output->js_pop_ups) .'
</script>

<div id="header-full">
<table width="100%" border="0" cellspacing="0" cellpadding="0" id="header-full-tbl">
<tr id="header-row">
 <td id="logoCell">
	<a href="' . $SERVICES->getContactUrl('home') . '" target="_blank">
	<span id="mainLogo"><img src="' . $skin_path . 'img/logo.png" 
	border="0" alt="' . $manager->getApplicationTitle() . ' Logo" /></span></a>
 </td>
 <td style="padding-top:3px;">
  <div id="promo">
	' . $manager->getPromoText() . '
  </div>
 </td>
 <td>
	<table width="100%" border="0" cellspacing="0" cellpadding="0" class="full-height">
		<tr>
		 <td id="title-links">
			<!--<button onClick="Layout.updateContentPanelTitle(\'test\');;return false;">test</button>-->
			' . $manager->getLinks('../../') . '
		 </td>
		</tr>
		<tr>
		 <td align="right">
			<div id="search-bar">' . $manager->getTopSearchForm() . '
			</div>
		 </td>
		</tr>
		
	</table>
 </td>
</tr>
</table>
</div>
';

// Phil 20070528 - removed from below the getLinks row
// <tr>
// <td id="SearchBar">' . $manager->getSearchForm() . '</td>
// </tr>

//MCR see above comment re flush
// Phil: Flush all output before checking alerts (and emails)
//ob_flush();
//flush();

//@todo reimplement this for ext menu

// Phil 20060119 - Adding Call to process alerts (and emails)
global $SERVICES;
$SERVICES->getService('Modules');
//includeModule('Front', 'inc/alert_processor.inc');

// if (is_object($processor = new AlertProcessor())) {
	// // force refresh (no cache), dont output complete html page (appends to the already sent page)
	// $processor->run(true, false);
// }
?>