<?php
require_once("../../prepend.inc");
/**
 * Create new data options.
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Admin
 * @author Phil Calder
 */
 
/**
 * Select a table, and option 'type' (ie a unique name... 'list', 'edit', etc)
 */

global $SERVICES;
$ua =& $SERVICES->getService('Authentication');
$ua->adminRestrict();

$add =& $SERVICES->getService('DataDefinition', '', 'AdminDataDefinition');

$SERVICES->getService('Language');
$SERVICES->language->getLanguage('Admin');

$SERVICES->getService('Config');

$output =& $SERVICES->getService('Output');

function getFormFields($item) {
	global $L, $add;
	
	// $available_fields = $add->getField($item['field_table']);
	$available_tables = array_flip($add->db->getTables());
	foreach ($available_tables as $k => $v) {
		$available_tables[$k] = $k;
	}
	// print '<p>available fields:'; print_r($available_fields); print '</p>';
	
	$fields = array();
	
	$fields['id']           = array('label'=>'', 'field_key'=>'id', 'type'=>'hidden');
	$fields['field_table']  = array('label'=>$L['adminCustomFieldsTableName'], 'field_key'=>'field_table', 'type'=>'dropdown', 'dropdown_values'=>$available_tables, 'notnull'=>1);
	$fields['type']         = array('label'=>$L['adminCustomFieldsType'], 'field_key'=>'type', 'type'=>'text', 'explanation'=>$L['adminDataOptionsTypeExplanation'] );
	
	foreach ($fields as $k => $v) {
		if ( ($k == 'field_table') && (!in_array($item[$v['field_key']], $available_tables)) ) {
			$fields[$k]['value'] = strtolower($item[$v['field_key']]); // Some installations (eg Windows) have lowercase MySQL table names
		} else {
			$fields[$k]['value'] = $item[$v['field_key']];
		}
	}
	
	return $fields;
}


function doSubmit() {
	global $SERVICES, $PHP_SELF, $L, $mod, $output, $add;
	
	$item = $_POST['item'];
	// print_r($item); print_r($_POST); exit();
	
	if (isset($_POST['submit']) && $_POST['submit']) {
		//server-side data validation goes here
		$fields = getFormFields($item);	//get field definitions
		$output->validateFields($item, $fields, $error_msg); //validate $item based on the definitions in $fields; $item values will get updated
		
		if (is_array($error_msg)) {		//if server-side validation errors, return to form
			main( $item['id'], $item, $error_msg);
			exit();
		}		
		
		if (isset($item['field_table']) && $item['field_table'] && isset($item['type']) && $item['type']) {
			$url = $SERVICES->config->lookup('modules.Admin.module_edit.data_options_edit.link') . '?table=' . $item['field_table'] . '&type=' . $item['type'];
			doRedirect($url);
			exit();
		} else {
			// print '<p>setItem returned false</p>';
			$content = $output->getBeginTable();
			$content .= $output->getTextRow($L['adminDataOptionsCannotAddDataOptions']);
			$content .= $output->getTextRow('<a href="' . $SERVICES->config->lookup('modules.Admin.module_edit.data_options_index.link')  . '">' . $L['Back'] . '</a>');
			$content = $output->getEndTable();
			quickPage($content);
			exit();
		}
	}
} //doSubmit

function doRedirect($url = '') {
	global $SERVICES;
	if (!empty($url)) {
		header('Location: ' .  $url);
	} else {
		header('Location: ' .  $SERVICES->config->lookup('modules.Admin.module_edit.data_options_index.link'));
	}
	exit();
}

function main() {
	global $SERVICES, $output, $L, $id, $type, $table, $add, $PHP_SELF;
	// 'New' field
	$item = array(
		'field_table' => (empty($table) ? '' : $table),
		'type' => ''
	);	
	
	$index_link = $SERVICES->config->lookup('modules.Admin.module_edit.data_options_index.link');
	$index_label = $SERVICES->config->lookup('modules.Admin.module_edit.data_options_index.label');
	
	$content = '';
	$content .= $output->getBeginTable('viewTbl');
	
	$title_menu = array(
		$output->getLinkHref(
			array(
				'href' => $index_link, 
				'text' => ($L[$index_label] ? $L[$index_label] : $index_label), 
			)
		)
	);
	
	$output->toolbar_link_mode = true;
	$output->setActionLinksMenu($title_menu);
	$output->toolbar_link_mode = false;
	
	// $content .= $output->getTitleRow($L['adminDataOptionsCreateLabel'], $title_menu);
	
	$content .= $output->getBeginForm($PHP_SELF);
	$content .= $output->getBeginNestedEditTable();
	
	foreach (getFormFields($item) as $k => $v) {
		$content .= $output->getHtmlFieldRow($v, $error_msg[$v['field_key']]);
	}
	
	$content .= $output->getSubmitRow();
	$content .= $output->getEndNestedTable();
	$content .= $output->getEndForm();
	$content .= $output->getEndTable();
	
	$title_text = $L['adminDataOptionsCreateLabel'];
	$padding = true;
	
	$window_layout = $output->getBeginTable('mainTbl', true);
	$window_layout .= $output->getTitleRow($title_text);
	// $window_layout .= $output->getMenuRow($title_menu);
	$window_layout .= $output->getBeginRow('', true) . '<td id="bodyCell"' . ($padding ? 'style="padding: 10px"' : '') . '>';
	$window_layout .= $content;
	$window_layout .= '</td>' . $output->getEndRow(true);
	$window_layout .= $output->getEndTable(true);
	
	$output->addToBody($window_layout);
	$output->display();
	exit();
}

if (isset($_POST['submit'])) {
	doSubmit();
}

main();
?>