<?php
require_once("../../prepend.inc");
/**
 * Displays links to various functions
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Admin
 * @author Phil Calder
 */

$ua =& $SERVICES->getService('Authentication');
$ua->adminRestrict('Admin');

$output =& $SERVICES->getService('Output');

$config =& $SERVICES->getService('Config');
$lang =& $SERVICES->getService('Language');
$lang->getLanguage('Admin');

$db =& $SERVICES->getService('Database');

function doSubmit() {
	global $config, $lang, $db, $PHP_SELF;
	if (isset($_GET['action']) && $_GET['action']) {
		if ($_GET['action'] == 'cache') {
			// print '<div>rebuild cache</div>';
			// $config->rebuildConfig();
			$config->removeCachedConfig();
			$lang->removeCache();
			$db->rebuildCache();
			header('Location: ' . $PHP_SELF);
			exit();
		}
	}
}

/**
 * Displays module editor links
 */
function main() {
	doSubmit();
	global $SERVICES, $ua, $USER, $output, $config, $L, $PHP_SELF, $lang;
	
	$content = '';
	$content .= $output->getBeginTable('viewTbl');	
	$content .= $output->getTextRow($L['adminManageInstallation']);
	$content .= $output->getBeginNestedViewTable();
	

	$config_links = (array)$config->lookup('modules.Admin.admin_manage_installation');
	foreach ($config_links as $k => $v) {
		if (is_array($v) && isset($v['link']) && $v['link']) {
			$label = ($L[$v['label']] ? $L[$v['label']]: $lang->getLanguageText($v['label'], $v['module']));
			if (!strlen($label)) {
				$label = $v['label'];
			}
			$link = '<a href="' . $v['link'] . '">' . $label . '</a>';
			$explanation = ( (isset($v['explanation']) && $v['explanation']) ? $lang->getLanguageText($v['explanation'], $v['module']) : '');
			$content .= $output->getTableRow(array($link, $explanation));
		}
	}
	
	$content .= $output->getEndNestedTable();
	$content .= $output->getEndTable();	
	
	$title = $L['adminManageInstallation'];
	
	$window_layout = $output->getBeginTable('mainTbl', true);
	$window_layout .= $output->getTitleRow($title);
	$window_layout .= $output->getBeginRow('', true) . '<td id="bodyCell"' . ($padding ? 'style="padding: 10px"' : '') . '>';
	$window_layout .= $content;
	$window_layout .= '</td>' . $output->getEndRow(true);
	$window_layout .= $output->getEndTable(true);
	
	$output->addToBody($window_layout);
	$output->display();
	exit();
}
main();
?>
