<?php
require_once("../../prepend.inc");
/**
 * Administrators can create a new module from a template.
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Admin
 * @author Phil Calder
 */

$ua =& $SERVICES->getService('Authentication');
$ua->adminRestrict();

$SERVICES->getService('Config');
$SERVICES->getService('Database');
$SERVICES->getService('Preferences');
$SERVICES->getService('Modules');
$SERVICES->getService('Language');

function doSubmit() {
	global $SERVICES, $USER, $L, $output, $submit, $PHP_SELF;
	
	$output =& $SERVICES->getService('Output');
	
	$item = $_POST['item'];

	if ($submit && !empty($item['module_name'])  && !is_numeric($item['module_name'])) {
		//submit stuff
		
		//get src and dest basedir
		$src_basedir = $SERVICES->config->lookup('modules.basedir');
		if (!$item['is_custom'] && $SERVICES->config->lookup('site.development')) {
			$dest_dir = $src_dir; // Standard module
		} else {
			$dest_dir = $SERVICES->config->lookup('modules.custom_basedir'); // Custom module
		}
		
		$admin =& $SERVICES->modules->getModule('Admin');
		$item['module_name'] = $admin->processModuleName($item['module_name']);
		
		//echo "$src_basedir, $dest_dir";
		
		$msgs = $admin->runNewModuleChecks($item, $src_basedir, $dest_dir);
		
		if (is_array($msgs) && sizeof($msgs)) {
			quickPage( $L['adminModuleEditorError'] . ':<br>' . implode('<br>', $msgs));
			exit();
		}
		
		// print '<div>admin module create:</div>'; print_r($item); print '<hr>'; exit();
		
		$admin_id = $admin->getAdminGroupId();
		//echo 'admin_id: ' . $admin_id;
		
		//we need to insert a new module into the System__Modules table
		//we need to get that module id and insert into the System__Module_Group and give the admin privs to it.
		
		//echo 'module_name: ' . $item['module_name'];
		
		$admin->addModuleToDatabase($item, $admin_id);
		
		// print '<div>admin module create:</div>'; print_r($item); print '<hr>'; exit();
		
		$file_info = $admin->createModuleFileStructure(
			$item, 
			$admin->getTemplateModuleName() . '__'
		);    
		
		
		// Phil 20060925 Rebuild cache
		$SERVICES->config->removeCachedConfig();
		$SERVICES->language->removeCache();
		
		/////////////////////////////////////
		
		if ($item['table_structure_option'] == 1) { // copy tables
			
			$table_info = $admin->copyDefaultTables($admin->getTemplateModuleName() . '__', $item['module_name'] . '__');
			
		} else if ($item['table_structure_option'] == 2) { // build standard tables (user defined)
			
			$table_info = $admin->buildModuleTables($item);
			
		} else { // dont create tables for this module
			
			$table_info = $L['adminModuleCreateCopyNoDbTablesCreated'];
			
		}
		
		// Phil 20070312 Rebuild db cache
		if (is_object($admin->db) && method_exists($admin->db, 'rebuildCache')) {
			$admin->db->rebuildCache();
		}
		/////////////////////////////////////
		
		//we are done.
		
		$content = '';
		$content .= $output->getBeginTable('viewTbl');
		// $content .= $output->getTitleRow($L['adminModuleLabelCreateModule']);
		// $content .= $output->getSpacerRow();
		$content .= $output->getTextRow($L['adminModuleLabelNewModuleCreated'] . ' <strong>' . $item['module_name'] . '</strong>');
		$content .= $output->getFieldSpacerRow();
		$content .= $output->getTextRow($file_info);
		$content .= $output->getFieldSpacerRow();
		$content .= $output->getTextRow($table_info);
		$content .= $output->getFieldSpacerRow();
		$content .= $output->getTextRow($L['adminModuleLabelAdjustNewModuleSettings']);
		
		$padding = true;
		$window_layout = $output->getBeginTable('mainTbl', true);
		$window_layout .= $output->getTitleRow($L['adminModuleLabelCreateModule']);
		$window_layout .= $output->getBeginRow('', true) . '<td id="bodyCell"' . ($padding ? 'style="padding: 10px"' : '') . '>';
		$window_layout .= $content;
		$window_layout .= '</td>' . $output->getEndRow(true);
		$window_layout .= $output->getEndTable(true);
		
		$output->addToBody($window_layout);
		$output->display();
		exit();
	}	
}

function main() {
	global $SERVICES, $USER, $L, $output, $submit;
	$admin =& $SERVICES->modules->getModule('Admin');
	
	$output =& $SERVICES->getService('Output');
	
	$content = '';
	
	if (empty($_POST['module_name'])) {
		
		$content = '';
		$content .= $output->getBeginTable('viewTbl');
		// $content .= $output->getTitleRow($L['adminModuleLabelCreateModule']);
		// $content .= $output->getSpacerRow();
		$content .= $output->getTextRow($L['adminModuleNewModuleAdminGroupMsg']);
		$content .= $output->getTextRow($L['adminModuleNewModulePermissionsMsg']);
		
		$content .= $output->getFieldSpacerRow();
		
		//nested data table ------------------
		$content .= $output->getBeginNestedEditTable();
		
		//form
		$content .= $output->getBeginForm($PHP_SELF);  
		
		
		// Removing option to deselect is custom option unless this site is a development server.
		$module_is_custom = array(
			'label'=>'Custom', 
			'type'=>'checkbox', 
			'field_key'=>'is_custom', 
			'value' => 1, 
			'explanation' => '
				Only development servers can create non-custom (standard) modules.
				<br>
				<b>Note</b>: Check paths in the module.config file 
				(which may be hardcoded to modules_custom directory).
			'
		);
		
		if (!$SERVICES->config->lookup('site.development')) { // in most cases:
			$module_is_custom['explanation'] = '';
			$module_is_custom['label'] = '';
			$module_is_custom['hidden'] = 1;
		}
		
		// --
		$module_is_custom = $output->getHtmlFieldRow(
			$module_is_custom
		);
		
		$content .= $module_is_custom;
		// --
		
		$content .= $output->getHtmlFieldRow(
			array(
				'label'     => $L['adminModuleCreateModuleName'], 
				'type'      => 'text', 
				'field_key' => 'module_name'
			)
		);
		
		$content .= $output->getHtmlFieldRow(
			array(
				'label'    => $L['adminModuleCreateCopyTables'], 
				'type'     =>'dropdown', 
				'field_key'=>'table_structure_option', 
				'value'    => 2, 
				'notnull'  =>1,
				'dropdown_values'=>array(
					'0' => $L['adminModuleCreateCopyNoDb'], 
					'1' => $L['adminModuleCreateCopyDefault'], 
					'2' => $L['adminModuleCreateCopyDynamic']
				)
			)
		);
		
		$content .= $output->getFieldSpacerRow();
		
		$content .= $output->getSubmitRow();
		
		$content .= $output->getEndForm();
		//end form
		
		
		$content .= $output->getEndNestedTable();
		//end nested data table ------------------ 
		
		$content .= $output->getEndTable();
			
	}
	
	$title = $L['adminModuleLabelCreateModule'];
	$padding = true;
	
	$window_layout = $output->getBeginTable('mainTbl', true);
	$window_layout .= $output->getTitleRow($title);
	$window_layout .= $output->getBeginRow('', true) . '<td id="bodyCell"' . ($padding ? 'style="padding: 10px"' : '') . '>';
	$window_layout .= $content;
	$window_layout .= '</td>' . $output->getEndRow(true);
	$window_layout .= $output->getEndTable(true);
	
	$output->addToBody($window_layout);
	$output->display();
	exit();
}

doSubmit();
main();
?>