<?php
require_once("../../prepend.inc");
/**
 * Edit a given dropdown table.
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Admin
 * @author Phil Calder
 */

global $SERVICES;
$ua =& $SERVICES->getService('Authentication');
$ua->adminRestrict();

$add =& $SERVICES->getService('DataDefinition', '', 'AdminDataDefinition');

$SERVICES->getService('Language');
$SERVICES->language->getLanguage('Admin');

$SERVICES->getService('Config');

$output =& $SERVICES->getService('Output');

function doSubmit() {
	global $SERVICES, $PHP_SELF, $L, $mod, $add, $output, $table;

	$submit = $_POST['submit'];
	$item = $_POST['item'];
	$delete = $_GET['delete'];
	
	if ($submit) {
		//server-side data validation
		$item['priority'] = intval($item['priority']);
		
		if($item['priority'] <= 0 || $item['priority'] > 999) {
			$item['priority'] = 100;
		}
			
		if (!$item['name']) {
			$error_msg['name'] = 'A value is required for this field.';
		}
			
		if (is_array($error_msg)) {
			edit($item['id'], $item, $error_msg);
			exit();
		}
		//
		
		$add->setDropdownValue($item, $table);

		header('Location:' . $PHP_SELF . '?table=' . $table);
		exit();

	} elseif ($delete) {
		
		$add->deleteDropdownValue($delete, $table);
		
		header('Location:' . $PHP_SELF . '?table=' . $table);
		exit();
	}
} // doSubmit


function edit($id, $item = '', $error_msg = '') {
	global $SERVICES, $L, $PHP_SELF, $add, $table, $output;
	
	if ( !$item ) { //item could be passed back from server-side data validation failure
		if ($id == -1) {
			//set defaults
			unset( $id ); //this is just a flag for 'new'
			$item['priority'] = 100;
		}
		
		if ($id) {
			$item = $add->getDropdownValue($id, $table);
			// print_r($item);
		}
	}
	
	$content = '';
	$content .= $output->getBeginTable('viewTbl');
	
	$content .= $output->getBeginForm($PHP_SELF);
	
	$module = substr($table, 0, strpos($table, '__'));
	// print '<p>module: ' . $module . '</p>';
	
	$title_menu = array(
		$output->getLinkHref(
			array(
				'href' => $SERVICES->config->lookup('modules.Admin.modulelink.module_editor_index.link'), 
				'text' => $SERVICES->config->lookup('modules.Admin.modulelink.module_editor_index.label')
			)
		), 
		$output->getLinkHref(
			array(
				'href' => $SERVICES->config->lookup('modules.Admin.module_edit.table_select.link') . $output->updateQueryString(array('module'=>$module)), 
				'text' => $SERVICES->config->lookup('modules.Admin.module_edit.table_select.label')
			)
		), 
		$output->getLinkHref(
			array(
				'href' => $SERVICES->config->lookup('modules.Admin.module_edit.dropdown_edit.link') . $output->updateQueryString(array()), 
				'text' => $SERVICES->config->lookup('modules.Admin.module_edit.dropdown_edit.label')
			)
		)
		
	);		
	
	// $content .= $output->getTitleRow($L['adminCustomFieldsDropdownEditLabel'], $title_menu);
	
	$content .= $output->getTextRow($table);
	$content .= $output->getFieldSpacerRow();
	$content .= $output->getBeginNestedEditTable();
	
	$fields = array(
		array('label'=>'', 'field_key'=>'id', 'type'=>'hidden', 'value'=>$item['id']), 
		array('label'=>'', 'field_key'=>'table', 'type'=>'hidden', 'value'=>$table), 
		array('label'=>$L['adminCustomFieldsName'], 'field_key'=>'name', 'type'=>'text', 'value'=>$item['name']), 
		array('label'=>$L['adminCustomFieldsPriority'], 'field_key'=>'priority', 'type'=>'integer', 'value'=>$item['priority'], 'min'=>100, 'max'=>999)
	);
	
	foreach($fields as $k => $v) {
		$content .= $output->getHtmlFieldRow($v);	
	}
	
	$content .= $output->getSubmitRow();
	$content .= $output->getEndNestedTable();
	$content .= $output->getEndForm();
	$content .= $output->getEndTable();
	
	$output->toolbar_link_mode = true;
	$output->setActionLinksMenu($title_menu);
	$output->toolbar_link_mode = false;
	
	$title_text = $L['adminCustomFieldsDropdownEditLabel'];
	$padding = true;
	
	$window_layout = $output->getBeginTable('mainTbl', true);
	$window_layout .= $output->getTitleRow($title_text);
	// $window_layout .= $output->getMenuRow($title_menu);
	$window_layout .= $output->getBeginRow('', true) . '<td id="bodyCell"' . ($padding ? 'style="padding: 10px"' : '') . '>';
	$window_layout .= $content;
	$window_layout .= '</td>' . $output->getEndRow(true);
	$window_layout .= $output->getEndTable(true);
	
	$output->addToBody($window_layout);
	$output->display();
	exit();
	
	// quickPage($content);
	// exit();
} // edit

function main() {
	global $SERVICES, $ua, $USER, $output, $L, $table, $PHP_SELF, $add;
	
	$content = '';
	$content .= $output->getBeginTable();
	
	$module = substr($table, 0, strpos($table, '__'));
	// print '<p>module: ' . $module . '</p>';
	
	$title_menu = array(
		$output->getLinkHref(
			array(
				'href' => $SERVICES->config->lookup('modules.Admin.modulelink.module_editor_index.link'), 
				'text' => $SERVICES->config->lookup('modules.Admin.modulelink.module_editor_index.label')
			)
		), 
		$output->getLinkHref(
			array(
				'href' => $SERVICES->config->lookup('modules.Admin.module_edit.table_select.link') . $output->updateQueryString(array('module'=>$module)), 
				'text' => $SERVICES->config->lookup('modules.Admin.module_edit.table_select.label')
			)
		), 
		$output->getLinkHref(
			array(
				'href' => $SERVICES->config->lookup('modules.Admin.module_edit.dropdown_edit.link') . $output->updateQueryString(array('id'=>-1)), 
				'text' => $L['LinkNew']
			)
		)
		
	);
	
	// $content .= $output->getTitleRow($L['adminCustomFieldsDropdownEditLabel'], $title_menu);
	
	$real_table_name = $add->getDropdownTableName($table);
	// print '<p>--- real_table_name: ' . $real_table_name . ' ---</p>';
	$content .= $output->getTextRow($real_table_name);
	
	$content .= $output->getFieldSpacerRow();
	$content .= $output->getHeaderRow(
		array(
			'value' => array('label' => $L['DropDownValue']), 
			'edit' => array('label' => $L['LinkEdit']), 
			'delete' => array('label' => $L['LinkDelete'])
		)
	);
	
	$values = $add->getDropdownValues($table);

	if (!sizeof($values)) {
		$content .= $output->getTextRow($L['adminCustomFieldsNoDropdownTableValues']);
	} else {	
		foreach ($values as $k => $val) {
			$label = $SERVICES->language->getLanguageText(bcrm_htmlspecialchars(stripslashes($val)), $module);
			$content .= $output->getTableRow(
				array(
					$label, 
					'<a href="' . $PHP_SELF . '' . $output->updateQueryString(array('id'=>$k)) . '">' . $L['LinkEdit'] . '</a>', 
					'<a href="javascript:if (confirm(\'' . $L['DeleteAreYouSure'] . '\')) { window.location.replace(\'' . $PHP_SELF . '' . $output->updateQueryString(array('delete'=>$k)) . '\');}">' . $L['LinkDelete'] . '</a>'
				)
			);
			
		}
	}
	
	$content .= $output->getEndTable();
	
	$output->toolbar_link_mode = true;
	$output->setActionLinksMenu($title_menu);
	$output->toolbar_link_mode = false;
	
	$title_text = $L['adminCustomFieldsDropdownEditLabel'];
	$padding = true;
	
	$window_layout = $output->getBeginTable('mainTbl', true);
	$window_layout .= $output->getTitleRow($title_text);
	// $window_layout .= $output->getMenuRow($title_menu);
	$window_layout .= $output->getBeginRow('', true) . '<td id="bodyCell"' . ($padding ? 'style="padding: 10px"' : '') . '>';
	$window_layout .= $content;
	$window_layout .= '</td>' . $output->getEndRow(true);
	$window_layout .= $output->getEndTable(true);
	
	$output->addToBody($window_layout);
	$output->display();
	exit();
	
	// quickPage($content);
	// exit();	
}

function init() {
	global $SERVICES, $L, $table, $add, $item, $output;
	
	if ($_POST['item']) {
		$item = $_POST['item'];
	}
	// print_r($item);
	
	if (is_array($item)) {
		extract($item);
	}
	
	if (empty($table)) {
		// print '<p>No table</p>';
		$content = '';
		$content .= $output->getBeginTable('viewTbl');
		$content .= $output->getTextRow($L['adminCustomFieldsNoTableSpecified']);
		$content .= $output->getTextRow('<a href="admin_module_index.php">' . $L['adminModuleEditIndexLabel'] . '</a>');
		$content .= $output->getEndTable();
		
		quickPage($content);
		exit();
	}
	
	$table_full = $table; // before we process the table name
	// print '<p>table: ' . $table . '</p>';
	$table = $add->getDropdownTableName($table);
	// print '<p>table: ' . $table . '</p>';
	
	if (in_array($table, $add->getSystemDropdowns()) || in_array($table_full, $add->getSystemDropdowns())) {
		$content = '';
		$content .= $output->getBeginTable('viewTbl');
		$content .= $output->getTextRow($L['adminCustomFieldsSystemDropdownMessage']);
		// $content .= $output->getTextRow('<a href="module_editor_index.php">' . $L['adminCustomFieldsIndexLink'] . '</a>');
		$content .= $output->getTextRow(
			$output->getLinkHref(
				array(
					'href'=>$SERVICES->config->lookup('modules.Admin.modulelink.module_editor_index.link'), 
					'text'=>$SERVICES->config->lookup('modules.Admin.modulelink.module_editor_index.label')
				) 
			) . ' | ' .  
			$output->getLinkBack()
		);
		$content .= $output->getEndTable();
		
		quickPage($content);
		exit();
	}	
} // init

init();

if (isset($_POST['submit']) || isset($_GET['delete'])) {
	doSubmit();
}

if (isset($_GET['id'])) {
	edit( $_GET['id'] );
}

main();
?>