<?php
require_once("../../prepend.inc");
/**
 * Select a field type for a new custom field.
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Admin
 * @author Phil Calder
 */

global $SERVICES;

$ua =& $SERVICES->getService('Authentication');
$ua->adminRestrict();

$SERVICES->getService('Modules');
$mod =& $SERVICES->modules->getModule('Admin');

$add =& $SERVICES->getservice('DataDefinition', '', 'AdminDataDefinition');

$output =& $SERVICES->getService('Output');

$SERVICES->getService('Config');

function doRedirect($nextpage) {
	global $SERVICES, $module, $table;
	
	if ($nextpage =='back') {
		header( 'Location: ' . $SERVICES->config->lookup('modules.Admin.module_edit.field_create.link') . '?module=' . $module . '&table=' . $table);
	} else {
		header( 'Location: ' . $SERVICES->config->lookup('modules.Admin.module_edit.table_edit.link') . '?module=' . $module . '&table=' . $table);
	}
	exit();
}


function main($id = '', $item = '', $error_msg = '') {
	global $PHP_SELF, $mod, $contact_id; //, $returnpage;
	global $SERVICES, $output, $L, $module, $table, $type, $add;
	
	if (!$type) {  
		doRedirect('back');
	}
			
	if (empty($table)) {
		header('Location: ' . $SERVICES->config->lookup('modules.Admin.modulelink.module_editor_index.link'));
		exit();
	}
	
	$module = substr($table, 0, strpos($table, '__'));
	// print $module . '<hr>';
	
	$dropdown_tables = $add->getDropdownTables($module);
	// print_r($dropdown_tables);
	
	$content = '';
	$content .= $output->getBeginTable();
	
	$title_menu = array(
		$output->getLinkHref(
			array(
				'href' => $SERVICES->config->lookup('modules.Admin.modulelink.module_editor_index.link'), 
				'text' => $SERVICES->config->lookup('modules.Admin.modulelink.module_editor_index.label')
			)
		), 
		$output->getLinkHref(
			array(
				'href' => $SERVICES->config->lookup('modules.Admin.module_edit.table_select.link') . $output->updateQueryString(array('type'=>'')), 
				'text' => $SERVICES->config->lookup('modules.Admin.module_edit.table_select.label')
			)
		), 
		$output->getLinkHref(
			array(
				'href' => $SERVICES->config->lookup('modules.Admin.module_edit.table_edit.link') . $output->updateQueryString(array('type'=>'')), 
				'text' => $SERVICES->config->lookup('modules.Admin.module_edit.table_edit.label')
			)
		), 
		$output->getLinkHref(
			array(
				'href' => $SERVICES->config->lookup('modules.Admin.module_edit.dropdown_create.link') . $output->updateQueryString(array()), 
				'text' => $L['LinkNew']
			)
		)
		
	);	
	
	// $content .= $output->getTitleRow($L['adminCustomFieldsDropdownSelectLabel'], $title_menu);
	$content .= $output->getTextRow($L['adminCustomFieldsSelectDropdownTable']);
	
	//nested data table ------------------
	$content .= $output->getBeginNestedListTable();
	$content .= $output->getHeaderRow(
		array(
			'table' => array('label' => $L['adminCustomFieldsTableName']), 
			'fields' => array('label' => $L['adminCustomFieldsSelect'])
		)
	);
	
	if (!is_array($dropdown_tables) || !sizeof($dropdown_tables)) {
		$content .= $output->getTextRow($L['adminCustomFieldsNoDropdownTables']);
	} else {
		foreach ($dropdown_tables as $k => $v) {
			$row = array();
			$row[] = $v;
			$row[] = '<a href="' . $SERVICES->config->lookup('modules.Admin.module_edit.field_edit.link') . $output->updateQueryString(array('dropdown_table'=>$v)) . '">' . $L['adminCustomFieldsSelect'] .'</a>';
			$content .= $output->getTableRow($row);
		}
	}

	$content .= $output->getEndNestedTable();
	//end nested data table ------------------
	$content .= $output->getEndTable();
	//
	
	$title_text = $L['adminCustomFieldsDropdownSelectLabel'];
	$padding = true;
	
	$window_layout = $output->getBeginTable('mainTbl', true);
	$window_layout .= $output->getTitleRow($title_text);
	$window_layout .= $output->getMenuRow($title_menu);
	$window_layout .= $output->getBeginRow('', true) . '<td id="bodyCell"' . ($padding ? 'style="padding: 10px"' : '') . '>';
	$window_layout .= $content;
	$window_layout .= '</td>' . $output->getEndRow(true);
	$window_layout .= $output->getEndTable(true);
	
	$output->addToBody($window_layout);
	$output->display();
	exit();
	
} // main

if (isset($_POST['submit']) || isset($_GET['delete'])) {
	doSubmit();
}

main();
?>
