<?php
require_once("../../prepend.inc");
/**
 * Select a table from the given module to edit.
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Admin
 * @author Phil Calder
 */

global $SERVICES;

$ua =& $SERVICES->getService('Authentication');
$ua->adminRestrict();

$SERVICES->getService('Language');
$SERVICES->language->getLanguage('Admin');

$SERVICES->getService('Config');

$output =& $SERVICES->getService('Output');

function filterTablesByModule($module, $table_arr) {
	switch ($module) {
	case 'Contact':
		foreach ($table_arr as $k => $v) {
			if ($v == 'Contact__view_dropdown') {
				bcrm_unset($table_arr, $k);
			}
		}
		break;
	case 'ContactImport':
		foreach ($table_arr as $k => $v) {
			if (strstr($v, 'ContactImport__data') !== false) {
				bcrm_unset($table_arr, $k);
			}
		}
		break;
	default:
		break;
	}
	return (array)$table_arr;
}


function main() {
	global $SERVICES, $ua, $USER, $output, $L, $module;
	
	if (empty($module)) {
		// header('Location: admin_module_editor_index.php');
		header('Location: ' . $SERVICES->config->lookup('modules.Admin.modulelink.module_editor_index.link'));
		exit();
	}
		
	$add =& $SERVICES->getService('DataDefinition', '', 'AdminDataDefinition');
	
	$item_tables = $add->getStandardTables($module . '__'); // any table that is not a dropdown, custom, or custom definition table
	$item_tables = filterTablesByModule($module, $item_tables);
	
	$dropdown_tables = $add->getDropdownTables($module . '__'); // any dropdown table (ie ends in dropdown)
	$dropdown_tables = filterTablesByModule($module, $dropdown_tables);
	
	
	$title_menu = array(
		$output->getLinkHref(array(
				'href' => $SERVICES->config->lookup('modules.Admin.modulelink.module_editor_index.link'), 
				'text' => ($L[$SERVICES->config->lookup('modules.Admin.modulelink.module_editor_index.label')] ? $L[$SERVICES->config->lookup('modules.Admin.modulelink.module_editor_index.label')] : $SERVICES->config->lookup('modules.Admin.modulelink.module_editor_index.label')), 
			)
		)
	);
	
	$header = array(
		'table' => array('label' => $L['adminCustomFieldsStandardTable']), 
		'edit' => array('label' => $L['LinkEdit'])
	);
	
	$title = $L['adminCustomFieldsTableSelectLabel'] . ': ' . $module; 
	
	$content = '';
	$content .= $output->getBeginTable();
	// $content .= $output->getTitleRow($L['adminCustomFieldsTableSelectLabel'] . ': ' . $module, $menu);
	$content .= $output->getBeginNestedListTable();
	$content .= $output->getHeaderRow($header);
	
	foreach ($item_tables as $k => $v) {
		$row = array();
		$row[] = $v;
		$row[] = $output->getLinkHref(array(
				'href' => $SERVICES->config->lookup('modules.Admin.module_edit.table_edit.link')  . '?table=' . $v,
				'text' => $L['LinkEdit']
			)
		);
		$content .= $output->getTableRow($row);
	}
	
	// Dropdown tables
	$content .= $output->getFieldSpacerRow();
	
	$header = array(
		'dd' => array('label' => $L['adminCustomFieldsDropdownTable']), 
		'edit' => array('label' => $L['LinkEdit'])
	);
	
	$content .= $output->getHeaderRow($header);
	
	foreach ($dropdown_tables as $k => $v) {
		$row = array();
		$row[] = $v;
		$row[] = $output->getLinkHref(array(
				'href' => $SERVICES->config->lookup('modules.Admin.module_edit.dropdown_edit.link') . '?table=' . $v,
				'text' => $L['LinkEdit']
			)
		);
		$content .= $output->getTableRow($row);
	}
	
	$content .= $output->getEndNestedTable();
	
	
	$extra_link = $output->getLinkHref(
		array(
			'href' => $SERVICES->config->lookup('modules.Admin.module_edit.dropdown_create.link') . $output->updateQueryString(array()), 
			'text' => $SERVICES->config->lookup('modules.Admin.module_edit.dropdown_create.label')
		)
	);
	
	// $content .= $output->getFieldSpacerRow();
	// $content .= $output->getTitleRow('', array('back'=>'off', 'refresh'=>'off', 'help'=>-1, 'bookmark'=>'off', 'print' => '0'), $extra_link);
	// $content .= $output->getTextRow($extra_link);
	$content .= $output->getEndTable();
	
	
	$output->toolbar_link_mode = true;
	$output->setActionLinksMenu($title_menu);
	$output->toolbar_link_mode = false;
	
	$output->toolbar_link_mode = true;
	$output->setActionLinksMenu((array)$extra_link);
	$output->toolbar_link_mode = false;
	
	$window_layout = $output->getBeginTable('mainTbl', true);
	$window_layout .= $output->getTitleRow($title);
	$window_layout .= $output->getBeginRow('', true) . '<td id="bodyCell"' . ($padding ? 'style="padding: 10px"' : '') . '>';
	$window_layout .= $content;
	$window_layout .= '</td>' . $output->getEndRow(true);
	$window_layout .= $output->getEndTable(true);
	
	$output->addToBody($window_layout);
	$output->display();
	exit();
}

main();

?>