<?php
/**
 * Contains the User Preferences name and details
 *
 * Use this file to set up Company / User Preferences which are configured from 
 * Admin. This file is included by Front/preferences.php for User Preferences 
 * and UserAdmin/preferences.php for Company Preferences.
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Calendar
 */

global $SERVICES, $L;
	
$mod =& $SERVICES->modules->getModule("Calendar");
$prefs_items = array();

//
$options = array(
	'' => '', 
	'5' => '5', 
	'10' => '10', 
	'20' => '20', 
	'30' => '30', 
	'50' => '50', 
	'100' => '100', 
	'All' => $L['ListAll']
);

$prefs_items['calendarindexListSize'] = dropDown(
	array(
		'type' => $options, 
		'name' => "data[calendarindexListSize]", 
		'value' => getPref('calendarindexListSize'), 
		'size' => 32, 
		'label' => $L['calendarListSize']
	)
);

// --
$view_type_options = array(
	''  => '',
	'0' => $L['calendarLinkViewAll'], 
	'1' => $L['calendarLinkDay'], 
	'2' => $L['calendarLinkWeek'], 
	'3' => $L['calendarLinkMonth'], 
	'4' => $L['calendarLinkYear']
);
$prefs_items['calendarDefaultViewType'] = dropDown(
	array(
		'type' => $view_type_options, 
		'name' => "data[calendarDefaultViewType]", 
		'value' => getPref('calendarDefaultViewType'), 
		'size' => 32, 
		'label' => $L['calendarDefaultViewType']
	)
);

//
$color_options = array(
	'AliceBlue' => '#F0F8FF',
	'AntiqueWhite' => '#FAEBD7',
	'Aqua' => '#00FFFF',
	'Aquamarine' => '#7FFFD4',
	'Azure' => '#F0FFFF',
	'Beige' => '#F5F5DC',
	'Bisque' => '#FFE4C4',
	'Black' => '#000000',
	'BlanchedAlmond' => '#FFEBCD',
	'Blue' => '#0000FF',
	'BlueViolet' => '#8A2BE2',
	'Brown' => '#A52A2A',
	'BurlyWood' => '#DEB887',
	'CadetBlue' => '#5F9EA0',
	'Chartreuse' => '#7FFF00',
	'Chocolate' => '#D2691E',
	'Coral' => '#FF7F50',
	'CornflowerBlue' => '#6495ED',
	'Cornsilk' => '#FFF8DC',
	'Crimson' => '#DC143C',
	'Cyan' => '#00FFFF',
	'DarkBlue' => '#00008B',
	'DarkCyan' => '#008B8B',
	'DarkGoldenRod' => '#B8860B',
	'DarkGray' => '#A9A9A9',
	'DarkGreen' => '#006400',
	'DarkKhaki' => '#BDB76B',
	'DarkMagenta' => '#8B008B',
	'DarkOliveGreen' => '#556B2F',
	'Darkorange' => '#FF8C00',
	'DarkOrchid' => '#9932CC',
	'DarkRed' => '#8B0000',
	'DarkSalmon' => '#E9967A',
	'DarkSeaGreen' => '#8FBC8F',
	'DarkSlateBlue' => '#483D8B',
	'DarkSlateGray' => '#2F4F4F',
	'DarkTurquoise' => '#00CED1',
	'DarkViolet' => '#9400D3',
	'DeepPink' => '#FF1493',
	'DeepSkyBlue' => '#00BFFF',
	'DimGray' => '#696969',
	'DodgerBlue' => '#1E90FF',
	'Feldspar' => '#D19275',
	'FireBrick' => '#B22222',
	'FloralWhite' => '#FFFAF0',
	'ForestGreen' => '#228B22',
	'Fuchsia' => '#FF00FF',
	'Gainsboro' => '#DCDCDC',
	'GhostWhite' => '#F8F8FF',
	'Gold' => '#FFD700',
	'GoldenRod' => '#DAA520',
	'Gray' => '#808080',
	'Green' => '#008000',
	'GreenYellow' => '#ADFF2F',
	'HoneyDew' => '#F0FFF0',
	'HotPink' => '#FF69B4',
	'IndianRed ' => '#CD5C5C',
	'Indigo ' => '#4B0082',
	'Ivory' => '#FFFFF0',
	'Khaki' => '#F0E68C',
	'Lavender' => '#E6E6FA',
	'LavenderBlush' => '#FFF0F5',
	'LawnGreen' => '#7CFC00',
	'LemonChiffon' => '#FFFACD',
	'LightBlue' => '#ADD8E6',
	'LightCoral' => '#F08080',
	'LightCyan' => '#E0FFFF',
	'LightGoldenRodYellow' => '#FAFAD2',
	'LightGrey' => '#D3D3D3',
	'LightGreen' => '#90EE90',
	'LightPink' => '#FFB6C1',
	'LightSalmon' => '#FFA07A',
	'LightSeaGreen' => '#20B2AA',
	'LightSkyBlue' => '#87CEFA',
	'LightSlateBlue' => '#8470FF',
	'LightSlateGray' => '#778899',
	'LightSteelBlue' => '#B0C4DE',
	'LightYellow' => '#FFFFE0',
	'Lime' => '#00FF00',
	'LimeGreen' => '#32CD32',
	'Linen' => '#FAF0E6',
	'Magenta' => '#FF00FF',
	'Maroon' => '#800000',
	'MediumAquaMarine' => '#66CDAA',
	'MediumBlue' => '#0000CD',
	'MediumOrchid' => '#BA55D3',
	'MediumPurple' => '#9370D8',
	'MediumSeaGreen' => '#3CB371',
	'MediumSlateBlue' => '#7B68EE',
	'MediumSpringGreen' => '#00FA9A',
	'MediumTurquoise' => '#48D1CC',
	'MediumVioletRed' => '#C71585',
	'MidnightBlue' => '#191970',
	'MintCream' => '#F5FFFA',
	'MistyRose' => '#FFE4E1',
	'Moccasin' => '#FFE4B5',
	'NavajoWhite' => '#FFDEAD',
	'Navy' => '#000080',
	'OldLace' => '#FDF5E6',
	'Olive' => '#808000',
	'OliveDrab' => '#6B8E23',
	'Orange' => '#FFA500',
	'OrangeRed' => '#FF4500',
	'Orchid' => '#DA70D6',
	'PaleGoldenRod' => '#EEE8AA',
	'PaleGreen' => '#98FB98',
	'PaleTurquoise' => '#AFEEEE',
	'PaleVioletRed' => '#D87093',
	'PapayaWhip' => '#FFEFD5',
	'PeachPuff' => '#FFDAB9',
	'Peru' => '#CD853F',
	'Pink' => '#FFC0CB',
	'Plum' => '#DDA0DD',
	'PowderBlue' => '#B0E0E6',
	'Purple' => '#800080',
	'Red' => '#FF0000',
	'RosyBrown' => '#BC8F8F',
	'RoyalBlue' => '#4169E1',
	'SaddleBrown' => '#8B4513',
	'Salmon' => '#FA8072',
	'SandyBrown' => '#F4A460',
	'SeaGreen' => '#2E8B57',
	'SeaShell' => '#FFF5EE',
	'Sienna' => '#A0522D',
	'Silver' => '#C0C0C0',
	'SkyBlue' => '#87CEEB',
	'SlateBlue' => '#6A5ACD',
	'SlateGray' => '#708090',
	'Snow' => '#FFFAFA',
	'SpringGreen' => '#00FF7F',
	'SteelBlue' => '#4682B4',
	'Tan' => '#D2B48C',
	'Teal' => '#008080',
	'Thistle' => '#D8BFD8',
	'Tomato' => '#FF6347',
	'Turquoise' => '#40E0D0',
	'Violet' => '#EE82EE',
	'VioletRed' => '#D02090',
	'Wheat' => '#F5DEB3',
	'White' => '#FFFFFF',
	'WhiteSmoke' => '#F5F5F5',
	'Yellow' => '#FFFF00',
	'YellowGreen' => '#9ACD32'
);

$prefs_items['calendarColorPicker'] = dropDown(
	array(
		'type' => array_flip($color_options), 
		'name' => "data[calendarColorPicker]", 
		'value' => getPref('calendarColorPicker'), 
		'size' => 32, 
		'label' => $L['calendarColorPicker']
	)
);
//

//define prefs alert properties
$default_alert_time = $mod->getSharedVars('alert_in_advance');


$prefs_items['calendarDefaultAlertAdvance'] = dropDown(
	array(
		'type' => $default_alert_time, 
		'name' => "data[calendarDefaultAlertAdvance]", 
		'value' => getPref('calendarDefaultAlertAdvance'), 
		'size' => 32, 
		'label' => $L['calendarDefaultAlertTimeInAdvance'] 
	)
);

//
$default_alert_length = $mod->getSharedVars('alert_end');

$prefs_items['calendarDefaultAlertEnd'] = dropDown(
	array(
		'type' => $default_alert_length, 
		'name' => "data[calendarDefaultAlertEnd]", 
		'value' => getPref('calendarDefaultAlertEnd'), 
		'size' => 32, 
		'label' => $L['calendarAlertLengthAfterStartTime']
	)
);

// Phil 200702
// calendarWeekStartDay
$calendarWeekStartDay_options = array(
	''  => '', 
	'1' => $L['DaysFullMonday'],
	'2' => $L['DaysFullTuesday'],
	'3' => $L['DaysFullWednesday'],
	'4' => $L['DaysFullThursday'],
	'5' => $L['DaysFullFriday'],
	'6' => $L['DaysFullSaturday'],
	'7' => $L['DaysFullSunday']
);
$prefs_items['calendarWeekStartDay'] = dropDown(
	array(
		'type' => $calendarWeekStartDay_options, 
		'name' => "data[calendarWeekStartDay]", 
		'value' => getPref('calendarWeekStartDay'), 
		'size' => 32, 
		'label' => $L['calendarWeekStartDay']
	)
);

// Phil 200702
// calendarYearStartMonth
$calendarYearStartMonth_options = array(
	''  => '', 
	'1' => $L['MonthsFullJanuary'],
	'2' => $L['MonthsFullFebruary'],
	'3' => $L['MonthsFullMarch'],
	'4' => $L['MonthsFullApril'],
	'5' => $L['MonthsFullMay'],
	'6' => $L['MonthsFullJune'],
	'7' => $L['MonthsFullJuly'],
	'8' => $L['MonthsFullAugust'],
	'9' => $L['MonthsFullSeptember'],
	'10'=> $L['MonthsFullOctober'],
	'11'=> $L['MonthsFullNovember'],
	'12'=> $L['MonthsFullDecember']
);
$prefs_items['calendarYearStartMonth'] = dropDown(
	array(
		'type' => $calendarYearStartMonth_options, 
		'name' => "data[calendarYearStartMonth]", 
		'value' => getPref('calendarYearStartMonth'), 
		'size' => 32, 
		'label' => $L['calendarYearStartMonth']
	)
);



// calendarShowMultipleContactPhNumbers
$boolean_options = array(
	// '' => '', 
	'0' => $L['No'], 
	'1' => $L['Yes']
);

$prefs_items['calendarShowMultipleContactPhNumbers'] = dropDown(
	array(
		'type' => $boolean_options, 
		'name' => "data[calendarShowMultipleContactPhNumbers]", 
		'value' => getPref('calendarShowMultipleContactPhNumbers'), 
		'size' => 32, 
		'label' => $L['calendarShowMultipleContactPhNumbers']
	)
);

//add calendar rows array to global prefs_rows array
$pref_rows['Calendar'] = $prefs_items;

?>