<?php
/**
 * 
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 */
 
/**
 * Used to display info from the module in a dashboard view
 * 
 * @package Calendar
 * @author Phil Calder
 */
class CalendarAppointmentWebMATBookmarkDashboard extends WebMATBookmarkDashboard {
	
	function setTitleText($text = '') {
		
		if (empty($text)) {
			
			global $SERVICES, $L;
			$SERVICES->getService('Language');
			$SERVICES->language->getLanguage($module);
			
			$text = $L[$this->mod->getModuleNameLower() . 'Appointment' . 'EventNamePlural'];
			
		}
			
		$this->title_text = $text;
		
	}
	
	function getCalendarLink($text = '') {
		
		if (($link = $this->getFileSetHref('calendar_view')) && ($this->getContentDisplayMode() == 2)) {
			$href = $this->getModulePath() . str_replace('%id%', '', (str_replace('%contact_id%', $this->getContactId() ,$link)) );
		} else {
			$href = '#';
		}
		
		$calendar_icon = 'calendar_view.gif';
		
		$link = array(
			'href' => $href,
			'title' => $text,
			'icon' => 'icons_dash/' . $calendar_icon,
		);
		return $this->output->getLinkDashIcon($link);
		
	}
	
	/**
	 * Overridden to handle Appointments alert filtering, which is non-standard
	 *
	 * @param string type - The query type (eg alert)
	 * @param boolean incl_questionmark Whether to prepend the return value with a questionmark
	 * @return string containing the necessary qtype filter to use in a query string (eg ?filter=f1)
	 * @author Phil Calder, 20050714
	 */
	function getQtypeFilterQueryString($type = 'alert', $incl_questionmark = false) {
		if (empty($type)) {
			$type = 'alert';	
		}
		
		$str = '';
		
		if ($type == 'alert') {
			$str = 'filter=f1';
		}
		
		return ($incl_questionmark ? '?' : '') . $str;
	}

}

?>