<?php
/**
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Calendar
 */

class CalendarCommonWebMATList extends WebMATList {
	
	/**
	 * Disabled
	 */
	function setFilters() {}
	
	/**
	 * Forces list to NOT use an iterator for getItems
	 *
	 * ie process and return the entire items array
	 * Added 200512xx. This modules list page relies on bulk processing 
	 * of items in the {@link afterGetItems} method
	 *
	 * @return boolean false
	 * @author Phil Calder
	 */
	function useGetItemsIterator() {
		return false;
	}
	
	/**
	 * @deprecated
	 * @see getCheckboxMenuContent
	 */
	function getCheckboxMenuRow() {
		return $this->getCheckboxMenuContent();
	}
	
	/**
	 *
	 * @author Phil Calder
	 */
	function getUsersPreferredWeekStart() {
		global $SERVICES;
		$prefs =& $SERVICES->getService('Preferences');
		$start_day = (int)$prefs->getUserPref('calendarWeekStartDay');
		
		if ( ($start_day < 0) || ($start_day > 6) ) {
			$start_day = 0; // Sunday
		}
		// print '<p>' . get_class($this) . ' week start day: ' . $start_day . '</p>';
		return $start_day;
	}
	
	/**
	 *
	 * @author Phil Calder
	 */
	function getUsersPreferredYearStart() {
		global $SERVICES;
		$prefs =& $SERVICES->getService('Preferences');
		$start_month = (int)$prefs->getUserPref('calendarYearStartMonth');
		
		if (!$start_month) {
			$start_month = 1; // January
		}
		// print '<p>' . get_class($this) . ' year start month: ' . $start_month . '</p>';
		return $start_month;
	}
}
?>