<?php
/**
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Calendar
 */
includeModule('Calendar', 'inc/common_list.inc');
/**
 * View all appointments
 */
class CalendarFilters extends WebMATFilters {
	
	/**
	 * @deprecated version 4.160
	 * @see setConfigFilterInfo
	 */
	function setFilterInfo() {
		return $this->setConfigFilterInfo();
	}
	
	function setConfigFilterInfo() {
		global $SERVICES, $USER;
		parent::setConfigFilterInfo();
		if ($this->filter_info) {
			global $SERVICES;
			$SERVICES->getService('DateLib');
			$cur_time =time();
			// $current_date = $SERVICES->offsetTimeZoneForWrite(mktime(0, 0, 0, date('m', $cur_time), date('d', $cur_time), date('Y', $cur_time)));
			// $current_date = $SERVICES->offsetTimeZoneForRead(mktime(0, 0, 0, date('m', $cur_time), date('d', $cur_time), date('Y', $cur_time)));
			// Phil 20060327 Corrected date calculation for user
			$current_date = $SERVICES->offsetTimeZoneForRead($cur_time);
			// Phil 20060327 Testing date calculation for user
			// $current_date = $SERVICES->datelib->getUserPrefDateFromTimestamp($SERVICES->offsetTimeZoneForRead($cur_time));
			// print '<div>current date: ' . $current_date . '</div>';
			foreach ($this->filter_info['options'] as $key =>$info) {
				if ($info['label'] == 'calendarViewAlertingApp') {
					$this->filter_info['options'][$key]['where'] = str_replace('%current_time%', $cur_time, $this->filter_info['options'][$key]['where']);
					$this->filter_info['options'][$key]['where'] = str_replace('%user_id%', $USER['id'], $this->filter_info['options'][$key]['where']);
					continue;
				}
				
				if ($info['label'] == 'calendarViewUnSeenApp') {
					continue;
				}
				$this->filter_info['options'][$key]['where'] = str_replace('%current_date%', $current_date, $this->filter_info['options'][$key]['where']);
			}
		}
	}
}

/**
 * Main calendar list page class
 */
class CalendarItemWebMATList extends CalendarCommonWebMATList {
	
	function init($module, $data_option, $post = false, $get = false, $table_name = false, $language_overwrite = false) {
		parent::init($module, $data_option, $post, $get, $table_name, $language_overwrite);
		$this->db_functions->selected_users_only = true;
	}
	
	function setFilters() {
		global $SERVICES;
		if (!$this->no_filters) {
			// Phil 20060525 Alert filtering handled as a 'Main Filter' in Calendar
			if (isset($this->form_values['qfilter']) && ($this->form_values['qfilter'] == 'alert')) {
				$this->form_values['filter'] = 'f1';
			}
			$this->filters = new CalendarFilters($this->module_name, $this->form_values, $this->table_name, $this->dd, $this->db_functions);
		}
		$this->filters->show_qfilters = false; // Phil 20061016
	}
	
	/**
	 * Overridden to calculate user_id field
	 * @author Bosco 20051129
	 */
	function calculateValues(& $dd_item, $item) {
		global $SERVICES, $L, $USER;
		// print '<div>calculateValues for item[id]: ' . $item['id'] . '</div>';
		$output =& $SERVICES->getService('Output');
		$unseen_flag = $output->getFlagUnseenByOther();


		
		$ua =& $SERVICES->getService('Authentication');
		// $all_users = $ua->users->getUsersList(false, false, true); // include deleted users
		$all_users = $ua->users->getAllUsersList(); // Phil 20070130 include deleted users and resources
		$SERVICES->getService('Preferences');
		
		$num_users_to_display = $SERVICES->preferences->getUserPref('calendarUsersLength', 5);
		$user_list_length = $SERVICES->preferences->getUserPref('calendarUsersListDetailLength', 'All');
		$dd_item['user_id']['list_detail_length'] = $user_list_length;

		// $db_functions =& $this->mod->getDatabaseTable('item_seen');
		$db_functions =& $this->mod->getDatabaseTable('item_user'); // Phil 20051208 Use item user table, not item seen
		$users = $db_functions->getItems('', '', 'item_id=' . $item['id']);
		
		if ($users) {
			$count = 1;
			// Bosco 20050706 | Added to remove creator name from users list
			$users_count = count($users);
			foreach ($users as $k => $v) {
				if (($num_users_to_display != 'All') && ($count > $num_users_to_display)) {
					$dd_item['user_id']['value'] .= '...';
					break;
				} 	
				// Bosco 20050706 | Added condition to remove creator Name from recipients list	
				if ($v['user_id'] && !(($users_count != 1) && ($v['user_id'] == $item['creator_id']))) {
					if (!$v['seen']) {
						$dd_item['user_id']['value'] .= $unseen_flag . '';
					}
					$dd_item['user_id']['value'] .= $all_users[$v['user_id']]. ', ';
					
					// Add a line break for every 5 recipients
					// Output adds nowrap to the row because of images (the unseen flag)
					if ( $count && ( $count %5 == 0)) { 
						$dd_item['user_id']['value'] .= '<br>';
					}
					$count++;
				}
				
			}
			$dd_item['user_id']['value'] = trim($dd_item['user_id']['value'], ', ');
			// print '<p>calculate values ' . $dd_item['user_id']['value'] . '</p>';
		}
	}
}
?>