<?php
/**
 * The data definition for the item table
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Calendar
 */

global $SERVICES, $L;
global $USER;
$SERVICES->getService('Preferences');

// Phil 20060525 Using text keys
$role = array(
	'Owner' => $L['calendarRoleOwner'],
	'Attendee' => $L['calendarRoleAttendee'], 
	'NoNeedToAttend' => $L['calendarNoNeedToAttend'] 
);

$alert_on = array(
	-1 => '',
	  0 =>$L['No'], 
	  1 => $L['Yes'],
);

$data_definition = array (
	'fields' => array(
		'id' => array('label'=>'', 'field_key'=>'id', 'type'=>'integer', 'hidden'=>1, 'priority_edit' => 100),
		'user_id' => array('label'=> $L['calendarFieldUser'], 'field_key'=>'user_id', 'type'=>'dropdown', 'dropdown_values'=>'__USERSALL__', 'list_label' => 'Username', 'notnull'=>1, 'size' => 5, 'read_only' =>1, 'priority_edit' => 101),
		'item_id' => array('label'=>'', 'field_key'=>'item_id', 'type'=>'integer', 'hidden'=>1, 'priority_edit' => 102),
		'created' => array('label'=>'', 'field_key'=>'created', 'type'=>'integer_date', 'hidden'=>1, 'priority_edit' => 103),
		'seen' => array('label'=>'', 'field_key'=>'seen', 'type'=>'checkbox', 'list_label' => 'Seen',  'list_values' => array(0 =>$L['No'], 1 => $L['Yes']), 'priority_edit' => 104),
		'role_id' => array('label'=>'', 'field_key'=>'role_id', 'list_label' => $L['calendarStatusRole'],  'type'=>'dropdown', 'dropdown_values'=>$role,  'priority_edit' => 105),
		'status_id' => array('label'=> $L['calendarFieldStatus'], 'field_key'=>'status_id', 'type'=>'dropdown','dropdown_values'=>'__table(Calendar.status_dropdown)__', 'notnull' => 1, 'priority_edit' => 106),// , 'list_label'=>'Seen'),),
		'alert_on' => array('label'=>$L['calendarFieldAlertOn'], 'field_key'=>'alert_on', 'type'=>'checkbox', 'list_values'=> $alert_on, 'priority_edit' => 107),
		'alert_in_advance' => array('label'=>$L['calendarFieldAlertInAdvance'], 'field_key'=>'alert_in_advance', 'type'=>'dropdown', 'notnull' => 1, 'priority_edit' => 108),
		'alert_end' => array('label'=>$L['calendarFieldAlertEnd'], 'field_key'=>'alert_end', 'type'=>'dropdown','notnull' => 1, 'priority_edit' => 109),
		'last_update_user_id' => array('label'=>$L['LastUpdatedBy'], 'field_key'=>'last_update_user_id', 'type'=>'dropdown', 'dropdown_values'=>'__USERSALL__', 'hidden' =>0, 'read_only' => 1, 'priority_edit' => 110),
		'last_update' => array('label'=>'', 'field_key'=>'last_update', 'type'=>'integer_date', 'hidden' =>1),
		'active' => array('label'=>'', 'field_key'=>'active', 'type'=>'integer', 'hidden'=>1),
	),
	
	'data_options' => array(
		'edit' => array(                                                       
			'method' => 'exclude',
			'values' => array('user_id', 'created', 'active'),
			'options' => array('exclude_hidden' => 0, 'dropdown_values' => 0)
			),
		
	'test' => array(
			'method' => 'include',
			'values' => array('alert_in_advance'), 
			'options' => array('exclude_hidden' => 0, 'dropdown_values' => 0)
			),
			
	'status_edit' => array(
			'method' => 'include',
			'values' => array('id', 'user_id', 'alert_on', 'alert_in_advance', 'alert_end', 'status_id', 'item_id', 'last_update_user_id', 'last_update'),
			'options' =>array('exclude_hidden' => 0, 'dropdown_values' => 1)
			),
			
	'list' => array(
			'method' => 'include',
			'values' => array('user_id', 'alert_in_advance', 'alert_end', 'alert_on', 'status_id', 'seen', 'role_id'), 
			'options' =>array('dropdown_values' => 1)
			//'options' => array('change_attributes' => array('change_attributes' => array('label'=>'Alert On', 'field_key'=>'alert_on', 'type'=>'integer', 'list_values'=> $alert_on, 'priority_edit' => 107), 'exclude_hidden' => 0, 'dropdown_values' => 1))
			),
		)
	)
?>