<?php
/**
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 */

includeModule('Contact', 'inc/database_tables.inc');

/**
 * The Contact module class
 * 
 * @package Contact
 * @author Phil Calder
 */
class Contact extends WebMATModule {
	
	/** 
	 * @access private
	 */
	var $addrpost_name_fields = array(
		array('field_key' => 'addrpost1_name', 'separator' => "\n"),
		array('field_key' => 'addrpost1_houseno', 'separator' => ' '),
		array('field_key' => 'addrpost1_housesuffix', 'separator' => ' '),
		array('field_key' => 'addrpost1_street', 'separator' => "\n"),
		array('field_key' => 'addrpost1_line2', 'separator' => "\n"),
		array('field_key' => 'addrpost1_line3', 'separator' => "\n"),
		array('field_key' => 'addrpost1_city', 'separator' => "\n"),
		array('field_key' => 'addrpost1_state', 'separator' => "\n"),
		array('field_key' => 'addrpost1_postcode', 'separator' => "\n"),
		array('field_key' => 'addrpost1_country', 'separator' => "\n")
	);
	
	/** 
	 * @access private
	 */
	var $addrstreet_name_fields = array(
		array('field_key' => 'addrstreet1_name', 'separator' => "\n"),
		array('field_key' => 'addrstreet1_houseno', 'separator' => ' '),
		array('field_key' => 'addrstreet1_housesuffix', 'separator' => ' '),
		array('field_key' => 'addrstreet1_street', 'separator' => "\n"),
		array('field_key' => 'addrstreet1_line2', 'separator' => "\n"),
		array('field_key' => 'addrstreet1_line3', 'separator' => "\n"),
		array('field_key' => 'addrstreet1_city', 'separator' => "\n"),
		array('field_key' => 'addrstreet1_state', 'separator' => "\n"),
		array('field_key' => 'addrstreet1_postcode', 'separator' => "\n"),
		array('field_key' => 'addrstreet1_country', 'separator' => "\n")
	);
	
	/**
	 * @access private
	 */
	var $contacts = '';
		
	/**
	 * @access private
	 * @see getCustomDataDefinition
	 */
	var $has_custom_fields = false;
	
	/**
	 * @access private
	 * @see getDuplicatesQueryLimit
	 */
	var $duplicates_query_limit = false;
	/**
	 * @access private
	 * @see getDuplicatesViewFields
	 */
	var $duplicates_view_fields = false;
	
	/**
	 * Standard module constructor
	 */
	function Contact() {
		global $SERVICES;
		$this->module_name = 'Contact';
		$this->contacts = array();
		$this->WebMATModule();
		$this->db =& $SERVICES->getService('Database');
	}
	
	/**
	 * @author Phil Calder
	 */
	function cleanupData($full_cleanup = false) {
		// TODO: implement $full_cleanup for all methods
		$retval1 = $this->_cleanupDataContactType();
		$retval2 = $this->_cleanupDataContactDisplayName($full_cleanup);
		$retval3 = $this->_cleanupDataAddressDisplayNames();
		
		if ( ($retval1 !== false) && ($retval2 !== false) ) {
			return true;
		}
		return false;
	}
	
	/**
	 * Checks that each contact account has an account record associated with it
	 * @author Phil Calder
	 * @access private
	 * @deprecated version 5
	 */
	function _cleanupDataAccounts() {
		return true; // deprecated
	}
	
	/**
	 * Checks that each contact has a company or Person associated with it
	 * @author Phil Calder
	 * @access private
	 */
	function _cleanupDataContactType() {
		$debug = false;
		global $L;
		$this->default_name = $L['contactNoName'];
		// if ($debug) { print '<p>--- ' . $this->getModuleName() . ' - _cleanupDataContactType ---<br>'; }
		$sql = "
		SELECT count(*) 
		FROM Contact__item _contact 
		LEFT JOIN Person__item _person ON _contact.id = _person.contact_id
		LEFT JOIN Company__item _company ON _contact.id = _company.contact_id
		WHERE 
		_contact.active=1 AND (
			(_person.primary_record IS NULL AND _company.primary_record IS NULL) 
			OR 
			( (_person.active=1 AND _person.primary_record=1) AND (_company.active=1 AND _company.primary_record=1) ) 
			OR 
			( (_person.primary_record IS NULL AND _company.primary_record IS NOT NULL) AND _contact.id <> _contact.contact_company ) 
		)";
		// if ($debug) { print '<div>sql: ' . $sql . '</div>'; }
		$result = @mysql_query($sql);
		$row = @mysql_fetch_assoc($result);
		if (is_array($row)) {
			$count = current($row);
			// if ($debug) { print '<div>count: ' . $count . '</div>'; }
			if ($count > 0) {
				$sql = "
				SELECT _contact.id _contact_id, _person.id _person_id, _company.id _company_id, _contact.contact_company _contact_company
				FROM Contact__item _contact 
				LEFT JOIN Person__item _person ON _contact.id = _person.contact_id
				LEFT JOIN Company__item _company ON _contact.id = _company.contact_id
				WHERE 
				_contact.active=1 AND (
					(_person.primary_record IS NULL AND _company.primary_record IS NULL) 
					OR 
					( (_person.active=1 AND _person.primary_record=1) AND (_company.active=1 AND _company.primary_record=1) ) 
					OR 
					( (_person.primary_record IS NULL AND _company.primary_record IS NOT NULL) AND _contact.id <> _contact.contact_company ) 
				)";
				// if ($debug) { print '<div>sql: ' . $sql . '</div>'; }
				$result = @mysql_query($sql);
				while ($row = @mysql_fetch_assoc($result)) {
					// if ($debug) { print '<div>row</div>'; print_r($row); print '<hr>'; }
					// Checking and fixing:
					// -- has a company and a person 
					if ($row['_person_id'] && $row['_company_id']) {
						// Get the complete Contact (to use as a template for any new contact created here
						$get_sql = "SELECT * FROM Contact__item WHERE id = '" . $row['_contact_id'] . "' LIMIT 1";
						$get_result = mysql_query($get_sql);
						$existing = @mysql_fetch_assoc($result);
						if (!is_array($existing)) {
							$existing = $row;	
						}
						if ($row['_contact_company'] && ($row['_contact_id'] == $row['_contact_company'])) {
							// if ($debug) { print '<div>Has a person and a company. contact id is contact_company</div>'; }
							// create a new contact for the person
							$insert_sql = "
							INSERT INTO Contact__item 
							(id, created, creator_id, 
							view_group_id, edit_group_id, owner_group_id, admin_group_id, lock_permissions, 
							active, subscribed, contact_company) 
							VALUES 
							('', '" . time() . "', '" . $existing['creator_id'] . "', 
							'" . $existing['view_group_id'] . "', '" . $existing['edit_group_id'] . "', '" . $existing['owner_group_id'] . "', '" . $existing['admin_group_id'] . "', '" . $existing['lock_permissions'] . "', 
							'1', '" . $existing['subscribed'] . "', '" . $existing['id'] . "') 
							";
							// if ($debug) { print '<div>insert_sql: ' . $insert_sql . '</div>'; }
							if ($insert_result = @mysql_query($insert_sql)) {
								// if ($debug) { print '<div>insert: ' . @mysql_affected_rows() . '</div>'; }
							}
						} else if ($row['_contact_company'] && !($row['_contact_id'] == $row['_contact_company'])) {
							// if ($debug) { print '<div>Has a person and a company, but is a sub-contact</div>'; }
							// This contact is already a sub-contact (person) for another company
							// See if the other company exists and is active.
							// If it is, leave this contact as a person.
							// Create a new contact to link to the duplicate company
							// If it is not, make this contact a company 
							// by creating a new contact for the person and linking to this contact
							$select_sql = "
							SELECT _contact.id _contact_id, _company.id _company_id
							FROM Contact__item _contact 
							LEFT JOIN Company__item _company ON _contact.id = _company.contact_id 
							WHERE _contact.id = '" . $row['_contact_company'] . "' AND _contact.active=1 
							LIMIT 1";
							$select_result = @mysql_query($select_sql);
							if (is_array($contact_row = @mysql_fetch_assoc($select_result)) && $contact_row['_contact_id']) {
								// If it is, leave this contact as a person.
								// Create a new contact to link to the duplicate company
								// if ($debug) { print '<div>[other company exists - create new contact for company]</div>'; }
								$insert_sql = "
								INSERT INTO Contact__item ( 
									id, created, creator_id, 
									view_group_id, edit_group_id, owner_group_id, admin_group_id, lock_permissions, 
									active, subscribed
								) VALUES ( 
									'', '" . time() . "', '" . $existing['creator_id'] . "', 
									'" . $existing['view_group_id'] . "', '" . $existing['edit_group_id'] . "', '" . $existing['owner_group_id'] . "', '" . $existing['admin_group_id'] . "', '" . $existing['lock_permissions'] . "', 
									'1', '" . $existing['subscribed'] . "'
								) 
								";
								// if ($debug) { print '<div>insert_sql: ' . $insert_sql . '</div>'; }
								if ( ($insert_result = @mysql_query($insert_sql)) && ($new_id = @mysql_insert_id()) ) {
									//update its contact fields
									$update_sql = "
									UPDATE Contact__item SET contact_company = '$new_id' WHERE id = '$new_id' LIMIT 1;
									";
									// if ($debug) { print '<div>update_sql: ' . $update_sql . '</div>'; }
									if ($update_result = @mysql_query($update_sql)) {
										// if ($debug) { print '<div>update: ' . @mysql_affected_rows() . '</div>'; }
										
										// update the company record to point to the new contact
										$update_sql = "
										UPDATE Company__item SET contact_id = '$new_id' WHERE contact_id = '" . $row['_contact_id'] . "' LIMIT 1;
										";
										// if ($debug) { print '<div>update_sql: ' . $update_sql . '</div>'; }
										if ($update_result = @mysql_query($update_sql)) {
											// if ($debug) { print '<div>update: ' . @mysql_affected_rows() . '</div>'; }
										}
									}
								}
								//--
							} else {
								// If it is not, make this contact a company 
								// by creating a new contact for the person and linking the person to this contact
								// then update this contacts company links to point to itself
								// if ($debug) { print '<div>[other company does not exist - create new contact for person]</div>'; }
								$insert_sql = "
								INSERT INTO Contact__item ( 
									id, created, creator_id, 
									view_group_id, edit_group_id, owner_group_id, admin_group_id, lock_permissions, 
									active, subscribed, contact_company
								) VALUES ( 
									'', '" . time() . "', '" . $existing['creator_id'] . "', 
									'" . $existing['view_group_id'] . "', '" . $existing['edit_group_id'] . "', '" . $existing['owner_group_id'] . "', '" . $existing['admin_group_id'] . "', '" . $existing['lock_permissions'] . "', 
									'1', '" . $existing['subscribed'] . "', '" . $existing['id'] . "' 
								) 
								";
								// if ($debug) { print '<div>insert_sql: ' . $insert_sql . '</div>'; }
								if ( ($insert_result = @mysql_query($insert_sql)) && ($new_id = @mysql_insert_id()) ) {
									// if ($debug) { print '<div>insert: ' . @mysql_affected_rows() . '</div>'; }
									// Update original person to point to new contact
									$update_sql = "
									UPDATE Person__item SET contact_id = '$new_id' WHERE id = '" . $row['_person_id'] . "'
									";
									// if ($debug) { print '<div>update_sql: ' . $update_sql . '</div>'; }
									if ($update_result = @mysql_query($update_sql)) {
										// if ($debug) { print '<div>update: ' . @mysql_affected_rows() . '</div>'; }
									}
								}
								$update_sql = "UPDATE Contact__item SET contact_company = '" . $row['_contact_id'] . "' WHERE id = '" . $row['_contact_id'] . "' LIMIT 1";
								// if ($debug) { print '<div>update_sql: ' . $update_sql . '</div>'; }
								if ($update_result = @mysql_query($update_sql)) {
									// if ($debug) { print '<div>update: ' . @mysql_affected_rows() . '</div>'; }
								}
							}
						} else {
							// if ($debug) { print '<div>Has a person and a company, and no contact_company set</div>'; }
							// create a new contact for the company
							// Update the existing contact (via contact_company) to point to the new company
							$insert_sql = "
							INSERT INTO Contact__item 
							(id, created, creator_id, 
							view_group_id, edit_group_id, owner_group_id, admin_group_id, lock_permissions, 
							active, subscribed, contact_company) 
							VALUES 
							('', '" . time() . "', '" . $existing['creator_id'] . "', 
							'" . $existing['view_group_id'] . "', '" . $existing['edit_group_id'] . "', '" . $existing['owner_group_id'] . "', '" . $existing['admin_group_id'] . "', '" . $existing['lock_permissions'] . "', 
							'1', '" . $existing['subscribed'] . "', '') 
							";
							// if ($debug) { print '<div>insert_sql: ' . $insert_sql . '</div>'; }
							if ($insert_result = @mysql_query($insert_sql)) {
								// if ($debug) { print '<div>insert: ' . @mysql_affected_rows() . '</div>'; }
								$new_id = @mysql_insert_id();
								$update_sql = "UPDATE Contact__item SET contact_company = '$new_id' WHERE id = '$new_id' LIMIT 1";
								// if ($debug) { print '<div>update_sql: ' . $update_sql . '</div>'; }
								if ($update_result = @mysql_query($update_sql)) {
									// if ($debug) { print '<div>update: ' . @mysql_affected_rows() . '</div>'; }
								}
								$update_sql = "UPDATE Company__item SET contact_id = '$new_id' WHERE contact_id = '" . $row['_contact_id'] . "'";
								// if ($debug) { print '<div>update_sql: ' . $update_sql . '</div>'; }
								if ($update_result = @mysql_query($update_sql)) {
									// if ($debug) { print '<div>update: ' . @mysql_affected_rows() . '</div>'; }
								}
							}
						}
					} else if (!$row['_person_id'] && !$row['_company_id']) { // -- has no company or person -> add a company or person
						if ($row['_contact_company'] && ($row['_contact_id'] == $row['_contact_company'])) {
							// if ($debug) { print '<div>Has no person and no company, but should be its own company</div>'; }
							// Create a company, linked to this contact
							$default_company_name = ( (isset($existing['display_name']) && $existing['display_name']) ? $existing['display_name'] : $this->default_name);
							$insert_sql = "
							INSERT INTO Company__item 
							(
							id, created, creator_id, 
							active, contact_id, primary_record, display_name, 
							view_group_id, edit_group_id, owner_group_id, admin_group_id) 
							VALUES 
							(
							'', '" . time() . "', '" . $existing['creator_id'] . "', 
							'1', '" . $row['_contact_id'] . "', '1', '" . $default_company_name . "', 
							'" . $existing['view_group_id'] . "', '" . $existing['edit_group_id'] . "', '" . $existing['owner_group_id'] . "', '" . $existing['admin_group_id'] . "'
							)
							";
							// if ($debug) { print '<div>insert_sql: ' . $insert_sql . '</div>'; }
							if ($insert_result = @mysql_query($insert_sql)) {
								// if ($debug) { print '<div>insert: ' . @mysql_affected_rows() . '</div>'; }
							}
							// --
						} else {
							// if ($row['_contact_company']) {
								// if ($debug) { print '<div>Has no person and no company, but has a company link to another contact</div>'; }
							// } else {
								// if ($debug) { print '<div>Has no person and no company, and no company link</div>'; }
							// }
							// Create a person
							$default_person_name = ( (isset($existing['display_name']) && $existing['display_name']) ? $existing['display_name'] : $this->default_name);
							$insert_sql = "
							INSERT INTO Person__item 
							(id, created, creator_id, 
							view_group_id, edit_group_id, owner_group_id, admin_group_id,  
							active, contact_id, primary_record, last_name, display_name) 
							VALUES 
							('', '" . time() . "', '" . $existing['creator_id'] . "', 
							'" . $existing['view_group_id'] . "', '" . $existing['edit_group_id'] . "', '" . $existing['owner_group_id'] . "', '" . $existing['admin_group_id'] . "', 
							'1', '" . $row['_contact_id'] . "', '1', '$default_person_name', '$default_person_name') 
							";
							// if ($debug) { print '<div>insert_sql: ' . $insert_sql . '</div>'; }
							if ($insert_result = @mysql_query($insert_sql)) {
								// if ($debug) { print '<div>insert: ' . @mysql_affected_rows() . '</div>'; }
							}

						}
					} else if ($row['_company_id'] && !$row['_person_id'] && ($row['_contact_company'] != $row['_contact_id'])) {
						// -- has a company, no person, but contact_company is not set correctly -> update contact_company
						// if ($debug) { print '<div>has a company, no person, but contact_company is not set correctly -> update contact_company</div>'; }
						$update_sql = "UPDATE Contact__item SET contact_company = '" . $row['_contact_id'] . "' WHERE id = '" . $row['_contact_id'] . "' LIMIT 1";
						// if ($debug) { print '<div>update_sql: ' . $update_sql . '</div>'; }
						if ($update_result = @mysql_query($update_sql)) {
							// if ($debug) { print '<div>update: ' . @mysql_affected_rows() . '</div>'; }
						}
					}
				}
			}
			return $count;
		}
		return;
	}
	
	/**
	 * Populates display_name if empty, from Person or Company record
	 * @author Phil Calder
	 */
	function _cleanupDataContactDisplayName($full_cleanup = false) {
		$debug = false;
		// if ($debug) { print '<p>--- ' . $this->getModuleName() . ' - _cleanupDataContactDisplayName ---<br>'; }
		// $num_rows = false;
		
		$blank_names_only = ($full_cleanup ? false : true);
		
		if ($blank_names_only) {
			$where = "WHERE display_name = ''";
		} else {
			$where = "WHERE 1";
		}
		$sql = "
		SELECT count(*) 
		FROM Contact__item
		" . $where . "
		";
		if ($debug) { print '<div>sql: ' . $sql . '</div>'; }
		$result = @mysql_query($sql);
		$row = @mysql_fetch_assoc($result);
		if (is_array($row)) {
			$count = current($row);
			if ($debug) { print '<div>count: ' . $count . '</div>'; }
			if ($count > 0) {
				// ------ Person ------------
				// if ($debug) { print '<div>--- Person ---</div>'; }
				$sql = "
				SELECT _person.contact_id, _person.display_name 
				FROM Contact__item _contact LEFT JOIN Person__item _person
				ON _contact.id = _person.contact_id
				WHERE " . ($blank_names_only ? "_contact.display_name = '' AND" : "") . " _person.primary_record = 1 
				";
				if ($debug) { print '<div>sql: ' . $sql . '</div>'; }
				$result = @mysql_query($sql);
				while ($row = @mysql_fetch_assoc($result)) {
					if ($debug) { print '<div>row</div>'; print_r($row); print '<hr>'; }
					if ($row['contact_id'] && $row['display_name']) {
						// $update_sql = "
						// UPDATE Contact__item SET display_name = '" . $row['display_name'] . "' WHERE id = '" . $row['contact_id'] . "'
						// ";
						// if ($debug) { print '<div>update_sql: ' . $update_sql . '</div>'; }
						// $update_result = @mysql_query($update_sql);
						$update_result = $this->db->update(
							'Contact__item', 
							array(
								'display_name' => $row['display_name']
							), 
							"id = '" . $row['contact_id'] . "'"
						);
						if ($debug) { print '<div>updated: ' . @mysql_affected_rows() . '</div>'; }
					}
				}
				// ------ Company ------------
				// if ($debug) { print '<div>--- Company ---</div>'; }
				$sql = "
				SELECT _company.contact_id, _company.display_name 
				FROM Contact__item _contact LEFT JOIN Company__item _company
				ON _contact.id = _company.contact_id
				WHERE " . ($blank_names_only ? "_contact.display_name = '' AND" : "") . " _company.primary_record = 1 
				";
				if ($debug) { print '<div>sql: ' . $sql . '</div>'; }
				$result = @mysql_query($sql);
				while ($row = @mysql_fetch_assoc($result)) {
					if ($debug) { print '<div>row</div>'; print_r($row); print '<hr>'; }
					if ($row['contact_id'] && $row['display_name']) {
						// $update_sql = "
						// UPDATE Contact__item SET display_name = '" . $row['display_name'] . "' WHERE id = '" . $row['contact_id'] . "'
						// ";
						// if ($debug) { print '<div>update_sql: ' . $update_sql . '</div>'; }
						// $update_result = @mysql_query($update_sql);
						$update_result = $this->db->update(
							'Contact__item', 
							array(
								'display_name' => $row['display_name']
							), 
							"id = '" . $row['contact_id'] . "'"
						);
						if ($debug) { print '<div>updated: ' . @mysql_affected_rows() . '</div>'; }
					}
				}
			}
			return $count;
		}
		// if ($debug) { print '<br></p>'; }
		return;
	}
	
	/**
	 * Populates display_name if empty, from Person or Company record
	 * @author Phil Calder
	 */
	function _cleanupDataAddressDisplayNames() {
		$debug = false;
		// if ($debug) { print '<p>--- ' . $this->getModuleName() . ' - _cleanupDataAddressDisplayNames ---<br>'; }
		// $num_rows = false;
		$sql = "
		SELECT count(*) 
		FROM Contact__item
		WHERE active=1 AND ( (addrpost1_displayname = '') OR (addrstreet1_displayname = '') )
		";
		// if ($debug) { print '<div>sql: ' . $sql . '</div>'; }
		$result = @mysql_query($sql);
		$row = @mysql_fetch_assoc($result);
		if (is_array($row)) {
			$count = current($row);
			// if ($debug) { print '<div>count: ' . $count . '</div>'; }
			if ($count > 0) {
				// ------ Person ------------
				// if ($debug) { print '<div>--- Person ---</div>'; }
				$sql = "
				SELECT id   
				FROM Contact__item 
				WHERE active=1 AND ( (addrpost1_d = '') OR (addrstreet1_d = '') ) 
				";
				// if ($debug) { print '<div>sql: ' . $sql . '</div>'; }
				$result = @mysql_query($sql);
				while ($row = @mysql_fetch_assoc($result)) {
					// if ($debug) { print '<div>row</div>'; print_r($row); print '<hr>'; }
					if ($row['id']) {
						// if ($debug) { print '<div>updating postal and physical address display names for contact: ' . $row['id'] . '</div>'; }
						
						$ph_result = $this->updatePhysicalAddressDisplayName($row['id']);
						$ph_rows = @mysql_affected_rows();
						$po_result = $this->updatePostalAddressDisplayName($row['id']);
						$po_rows = @mysql_affected_rows();
						
						// if ($debug) { print '<div>updated physical address: ' . $ph_rows . ' (rows affected)</div>'; }
						// if ($debug) { print '<div>updated postal address: ' . $po_rows . ' (rows affected)</div>'; }
					}
				}
			}
			return $count;
		}
		// if ($debug) { print '<br></p>'; }
		return;
	}
	
	/**
	* Returns the given contact. Results are cached and reused.
	 *
	 * @param integer $id
	 * @param boolean $refresh Bypass the cache. Default false
	 * @return mixed false or the given contact
	 */
	function getContact($id, $refresh = false) {
		// print '<div>getContact(' . $id . ') refresh: ' . ($refresh ? 'true' : 'false') . '</div>';
		if (!$refresh && isset($this->contacts[$id]) && is_array($this->contacts[$id])) {
			// print '<div>getContact(' . $id . ') cached - returning</div>';
			return $this->contacts[$id];
		}
		
		if (!is_object($this->db_functions)) {
			$this->db_functions =& $this->getDatabaseTable('item');
		}
		// print '<div>' . get_class($this) . '::getContact(' . $id . ') calling getItem</div>';
		// Similar to setContactCache
		$this->contacts[$id] = $this->db_functions->getItem($id, false, false, $refresh);
		return $this->contacts[$id];
	}
	
	/**
	 * Adds the given contact to the contact cache
	 *
	 * @param integer $id
	 * @return mixed false or the given contact
	 */
	function setContactCache($id, $item) {
		if ($id && is_array($item)) {
			$this->contacts[$id] = $item;
		}
	}
	
	/**
	 * Adds the given contact to the contact cache
	 *
	 * @param integer $id
	 * @return mixed false or the given contact
	 */
	function unsetContactCacheFor($id) {
		if ($id && is_array($this->contacts)) {
			bcrm_unset($this->contacts, $id);
		}
	}
	
	/**
	 * Returns the main email address for a given contact
	 *
	 * @param integer $contact_id
	 * @return mixed false or the contacts main email address
	 */
	function getEmailAddressFor($id, $as_array = true, $email_number = false) {
		$email_number = (int)$email_number;
		// print '<div>' . get_class($this) . '::getEmailAddressFor(' . $id . ') as_array: ' . ($as_array ? 'true' : 'false') . ' email_number: ' . $email_number . '</div>';
		$contact = $this->getContact($id);
		// TODO - return email2 or email3 if email1 is blank
		if (is_array($contact)) {
			if (isset($email_number) && ($email_number > 0) && ($email_number <= 3)) {
				$prefix = 'email' . $email_number . '_';
			} else if (isset($this->contacts[$id]['email1_content']) && $this->contacts[$id]['email1_content']) {
				$prefix = 'email1_';
			} else if (isset($this->contacts[$id]['email2_content']) && $this->contacts[$id]['email2_content']) {
				$prefix = 'email2_';
			} else if (isset($this->contacts[$id]['email3_content']) && $this->contacts[$id]['email3_content']) {
				$prefix = 'email3_';
			}
			// print '<div>prefix: ' . $prefix . '</div>';
			if ($as_array) {
				return array(
					// 'contact_id' => $this->contacts[$id], 
					'contact_id' => $id, 
					'label'      => $this->contacts[$id][$prefix . 'label'], 
					'content'    => $this->contacts[$id][$prefix . 'content'], 
					'name'       => $this->contacts[$id][$prefix . 'name'], 
					'subscribed' => $this->contacts[$id][$prefix . 'subscribed'], 
					'valid'    => $this->contacts[$id][$prefix . 'valid'], 
				);
			} else {
				return $this->contacts[$id][$prefix . 'content'];
			}
		}
		return false;
	}
	
	function getMatchingEmailAddressesDetails($address) {
		// print '<div>' . get_class($this) . '::getMatchingEmailAddressesDetails(' . $address . ')</div>';
		if (!is_object($this->db_functions)) {
			$this->db_functions =& $this->getDatabaseTable('item');
		}
		$this->db_functions->setDesignTimeFilters(
			array(
				'email1_content' => array('where' => '( (email1_content = "' . $address . '") ||  (email2_content = "' . $address . '") || (email3_content = "' . $address . '"))') 
			)
		);
		$contacts = $this->db_functions->getItems();
		$addresses = array();
		if (is_array($contacts)) {
			foreach ($contacts as $k => $v) {
				$this->setContactCache($k, $v);
				$addresses[] = $this->getEmailAddressFor($k, true);
			}
		}
		$this->db_functions->resetDesignTimeFilters('email1_content');
		
		// print '<div>getMatchingEmailAddressesDetails</div>'; print_r($addresses); print '<hr>';
		return $addresses;
	}
	
	function getDefaultContactType() {
		// 0 = person
		// 1 = company
		
		if (isset($this->default_contact_type)) {
			// print '<div>getDefaultContactType: ' . $this->default_contact_type . '</div>';
			return $this->default_contact_type;
		}
		
		global $SERVICES;
		$SERVICES->getService('Preferences');
		return $SERVICES->preferences->getUserPref('contactNewContactType', '0');
	}
	
	/**
	 *
	 * @param integer id The contact id
	 * @return array Contains 3 keys with boolean values: is_person, is_company, is_account
	 */
	function getContactType($id) {
		// print '<div>getContactType(' . $id . ')</div>';
		if (!$id) {
			$default_type = $this->getDefaultContactType();
			// print '<div>default_type: ' . $default_type . '</div>';
			$type = array(
				'is_company' => ($default_type ? 1 : 0),
				'is_person' => ($default_type ? 0 : 1),
				'is_account' => 1
			);
			// print '<div>return a</div>';
			return $type;
		}
		
		$contact = $this->getContact($id);
		// print '<div>getContactType - getContact(' . $id . '):</div>'; print_r($contact); print '<hr>';
		$type = array(
			'is_company' => 0,
			'is_person' => 0,
			'is_account' => 0
		);
		
		if ($contact === false) { // Does not exist or has been deleted
			// print '<div>return b</div>';
			$default_type = $this->getDefaultContactType();
			// print '<div>default_type: ' . $default_type . '</div>';
			$type = array(
				'is_company' => ($default_type ? 1 : 0),
				'is_person' => ($default_type ? 0 : 1),
				'is_account' => 1
			);
			return $type;
		} else {
			$contact_company = $contact['contact_company'];
		}
		
		if ( ($contact_company == $id) || ($contact_company == -1)) {
			$type['is_company'] = 1;
			$type['is_account'] = 1;
		} else if ( ($contact_company == 0) || ($contact_company != $id) ) {
			$type['is_person'] = 1;
			if ($contact_company == $id) {
				$type['is_account'] = 1;
			}
		}
		// print '<div>getContactType(' . $id . ') returning:</div>'; print_r($type); print '<hr />';
		return $type;
	}
	
	/**
	 *
	 * @param integer id The contact id
	 * @return boolean true if this is a company, or false if it is not.
	 */
	function isCompany($id, $item = false) {
		// print '<div>isCompany id=' . $id . '</div>'; print_r($item); print '<hr>';
		if (is_array($item) && isset($item['contact_company']) ) {
			if ($item['contact_company'] == $id) {
				// print '<div>isCompany return true (' . $id . ') [id matches contact_company]</div>';
				return true;
			}
			// print '<div>isCompany return false (' . $id . ') [contact_company set but does not match]</div>';
			return false;
		}	
		// $is_company = $this->db->quickGet(
			// 'count(*)', 
			// 'Contact__item', 
			// "Contact__item.id='$id' AND active=1 AND (Contact__item.contact_company = Contact__item.id) "
		// );
		// return $is_company;
		$type = $this->getContactType($id);
		// print '<div>isCompany = getContactType(' . $id . ') [is_company: ' . $type['is_company'] . ']</div>'; print_r($type); //exit();
		// print '<div>isCompany return ' . ($type['is_company'] ? 'yes' : 'no') . ' (id: ' . $id . ') [ based on type[is_company] ]</div>'; print_r($type); 
		return $type['is_company'];
	}
	
	/**
	 *
	 * @param integer id The contact id
	 * @return boolean true if this is a person, or false if it is not.
	 */
	function isPerson($id, $item = false) {
		// print '<div>isPerson</div>'; print_r($item); print '<hr>';
		if (is_array($item) && isset($item['contact_company']) ) {
			if ( ($item['contact_company'] == 0) || ($item['contact_company'] != $id) ) {
				return true;
			}
			return false;
		}
		// $is_person = $this->db->quickGet(
			// 'count(*)', 
			// 'Contact__item', 
			// "Contact__item.id='$id' AND active=1 AND ( (Contact__item.contact_company = 0) OR ( (Contact__item.contact_company <> 0) AND (Contact__item.contact_company <> Contact__item.id)) ) "
		// );
		// return $is_person;
		$type = $this->getContactType($id);
		return $type['is_person'];
	}
	
	/**
	 *
	 * @param integer id The contact id
	 * @return boolean true if this is an account, or false if it is not.
	 */
	function isAccount($id, $item = false) {
		return true; // Phil 20070424 All Contacts are accounts
		if (is_array($item) && isset($item['contact_company']) ) {
			if ( ($item['contact_company'] == 0) || ($item['contact_company'] == $id) ) {
				return true;
			}
			return false;
		}
		if ($id) {
			// Phil 20060609 Possible future change to where clause
			// future: "Contact__item.id='$id' AND active=1 AND ( ((Contact__item.contact_company = 0) OR (Contact__item.contact_company = Contact__item.id)) OR (Contact__item.contact_account = Contact__item.id) ) "
			// existing: "Contact__item.id='$id' AND active=1 AND ( (Contact__item.contact_company = 0) OR (Contact__item.contact_company = Contact__item.id)) "
			// $is_account = $this->db->quickGet(
				// 'count(*)', 
				// 'Contact__item', 
				// "Contact__item.id='$id' AND active=1 AND ( (Contact__item.contact_company = 0) OR (Contact__item.contact_company = Contact__item.id)) "
			// );
			$type = $this->getContactType($id);
			$is_account = $type['is_account'];
		} else {
			global $SERVICES;
			$is_account = 1; // $SERVICES->config->lookup('modules.Contact.file_set.item.default_is_account');	
		}
		$is_account = ($is_account ? true : false);
		// print '<div>isAccount(' . $id . ') returning ' . $is_account . ' [' . ($is_account ? 'yes' : 'no') . ']</div>';
		return $is_account;
	}
	
	/**
	 * @return mixed false, or the id for the given contacts company
	 */
	function getCompanyIdFor($id) {
		if ($this->isPerson($id)) {
			// $contact_company = $this->db->quickGet(
				// 'contact_company', 
				// 'Contact__item', 
				// "id = '$id' AND active='1'"
			// );
			// return $contact_company;
			$contact = $this->getContact($id);
			return $contact['contact_company'];
		}	
		return false;
	}
	
	/**
	 * @param string $contact_id The contact id to filter on
	 * @return mixed false or an array containing the Person record
	 */
	function getContactPersonFor($contact_id, $contact_person = false, $item = false) {
		// print '<div>getContactPersonFor(' . $contact_id . ', ' . ($contact_person ? $contact_person : 'false') . ', [item])</div>'; print_r($item); print '<hr>';
		if ($this->isCompany($contact_id, $item)) {
			if (!$contact_person) { 
				if (is_array($item) && isset($item['Company__item.contact_person']) ) {
					$contact_person = $item['Company__item.contact_person'];
				} else {
					// $contact_person = $this->db->quickGet(
						// 'contact_person', 
						// 'Company__item', 
						// "Company__item.contact_id = '$contact_id' AND primary_record='1' AND active='1'"
					// );
					$contact = $this->getContact($contact_id);
					// print '<div>getContactPersonFor(' . $contact_id . ') contact:</div>'; print_r($contact); print '<hr>';
					$contact_person = (isset($contact['contact_person']) ? $contact['contact_person'] : $contact['_Company__item_contact_person']);
					// print '<div>getContactPersonFor(' . $contact_id . ') contact_person: ' . $contact_person . '</div>';
				}
			}
			if ($contact_person) {
				$person = $this->getContact($contact_person);
				// print '<div>person:</div>'; print_r($person); print '<div>-----</div>';
				if ($this->db->hasError()) {
					$this->db->printError();
				}
				if (is_array($person)) {
					$result = true;
				} else {
					$result = false;
				}
				// print '<div>result: ' . ($result ? 'true' : 'false'). '</div>';
				return $result;
			}
		}
		return false;
	}
	
	/**
	 * 
	 * 
	 * @param string $id The contact id to filter on
	 * @return mixed false or an array containing the Person record
	 */
	function getContactAccountFor($id, $contact_account = false, $item = false) {
		// print '<div>getContactAccountFor</div>'; print_r($item); print '<hr>';
		if ($this->isPerson($id, $item)) {
			if (!$contact_account) { 
				if (is_array($item) && isset($item['contact_company']) ) {
					$contact_account = $item['contact_company'];
				} else {
					// $contact_account = $this->db->quickGet(
						// 'contact_account', 
						// 'Contact__item', 
						// "Contact__item.id = '$id' AND active='1'"
					// );
					$contact = $this->getContact($id);
					$contact_account = $contact['contact_company'];
				}
			}
			if ($contact_account) {
				// TODO Use Company__item database table getItem
				// print '<div>contact_account: ' . $contact_account . '</div>';
				$result = $this->db->quickGet(
					'*', 
					'Company__item', 
					"Company__item.contact_id='$contact_account' AND Company__item.primary_record='1' AND Company__item.active='1'"
				);
				if ($this->db->hasError()) {
					$this->db->printError();
				}
				// print_r($result); print '<div>-----</div>';
				return $result;
			}
		}
		return false;
	}
	
	/**
	 * For contacts that are companies, will return an array of sub contact ids
	 * 
	 * @param string $contact_id The contact id to filter on
	 * @return mixed false or an array or sub-contact ids
	 */
	function getSubContacts($contact_id) {
		if ($this->isCompany($contact_id)) {
			$items = array();
			// TODO Use Contact__item database table getItems
			// Add results to cache: $this->contacts
			$result = $this->db->select(
				'id', 
				'Contact__item', 
				'( (Contact__item.contact_company = "' . $contact_id . '") AND (Contact__item.id <> "' . $contact_id . '") and active=1)'
			);
			while ($row = $this->db->getRow($result)) {
				$items[$row['id']] = $row['id'];
			}
			// print '<div>sub contacts of ' . $contact_id . '</div>'; print_r($items); print '<hr>';
			return $items;
		}
		return false;
	}
	
	/**
	 * Updates the Company contact_person field if applicable
	 * 
	 * Scenarios:
	 * This is a Company 
	 * - check there is an active contact_person (provided the company has sub-contacts)
	 * This is a Person 
	 * - check that its (Optional) Company has a contact_person
	 * - check there are no other Companies using this Person as their contact_person
	 *
	 */
	function updateContactPerson($contact_id) {
		if ($this->isCompany($contact_id)) {
			$contact_person = $this->getContactPersonFor($contact_id);
			// print '<div>company: ' . $contact_id . ' contact_person:</div>'; print_r($contact_person); print '<hr>';
			if ($contact_person === false) {
				// print '<div>company: ' . $contact_id . ' contact_person is false</div>';
				$sub_contacts = $this->getSubContacts($contact_id);
				// print '<div>company: ' . $contact_id . ' sub_contacts:</div>'; print_r($sub_contacts); print '<hr>';
				if (is_array($sub_contacts) && count($sub_contacts)) {
					$contact_person = current($sub_contacts);
					// TODO use Contact__item database table setItem
					$result = $this->db->update(
						'Company__item', 
						array(
							'contact_person' => $contact_person, 
						), 
						"contact_id ='$contact_id'"
					);
					// print '<div>returning result:</div>'; print_r($result);
					return $result;	
				} else {
					$result = $this->db->update(
						'Company__item', 
						array(
							'contact_person' => 0, 
						), 
						"contact_id ='$contact_id'"
					);
					// print '<div>unset contact_person for ' . $contact_id . '</div>';
					return false;	
				}
			}
		} else {
			$contact_company = $this->getCompanyIdFor($contact_id);
			// print '<div>Person: ' . $contact_id . '</div>';
			// print '<div>Company: ' . $contact_company . '</div>';
			
			// Lots of checks here, using recursion
			if ($contact_company && ($contact_company != $contact_id) && ($this->isCompany($contact_company)) ) {
				// print '<div>company: ' . $contact_company . ', contact: ' . $contact_id . '</div>';
				return $this->updateContactPerson($contact_company);
			}
		}
		// print '<div>returning true</div>';
		return true;
	}
	
	/**
	 * Checks there is a company item linked to the contact_id param 
	 * and updates the contact_company field for this contact
	 */
	function updateContactCompany($contact_id, $contact_company = false) {
		// print '<div>updateContactCompany(' . $contact_id . ', ' . $contact_company . ')</div>'; 
		$contact = $this->getContact($contact_id, true); // Ensure we get a fresh copy of this contact record
		$retval = '';
		if ($contact_company || $this->isCompany($contact_id)) {
			if ($this->db->quickGet(
				'count(*)', 
				'Company__item', 
				"contact_id='$contact_id'"
			)) {
				// print '<div>setting contact_company=' . $contact_id . ' for id=' . $contact_id . '</div>'; 
				// TODO Should use db_functions setItem
				$retval = $this->db->update(
					'Contact__item', 
					array(
						'contact_company' => $contact_id, 
					), 
					"id ='$contact_id'"
				);
				$this->unsetContactCacheFor($contact_id);
			} else {
				// print '<div>NOTICE: This is a company but cant find a Company__item record for contact_id: ' . $contact_id . '</div>';
			}
		} else {
			// Get the contact_company field for this contact, check it is active, unset it if it is not
			// $contact = $this->getContact($contact_id, true); // Done above
			// print '<div>contact record for this person ' . $contact_id . '</div>'; print_r($contact); print '<hr>';
			if (isset($contact['contact_company']) && $contact['contact_company']) {
				$company = $this->getContact($contact['contact_company']);
				if ($company) {
					return true;
				} else { // unset the contact_company field
					$retval = $this->db->update(
						'Contact__item', 
						array(
							'contact_company' => 0, 
						), 
						"id ='$contact_id'"
					);
					$this->unsetContactCacheFor($contact_id);
				}
			}
		}
		// print '<div>returning=' . $retval . '</div>'; 
		return $retval;
	}
	
	/**
	 * @deprecated version 5
	 */
	function updateContactAccount($contact_id) {
		return false;
	}
	
	/**
	 * Update the display name for the given contact.
	 * Bases the name on either supplied values or from database.
	 */
	function updateContactDisplayName($contact_id, $company_name = false, $person_name = false) {
		// print '<div>updateContactDisplayName - ' . $contact_id . ' company_name: ' . $company_name . ' person_name: ' . $person_name . '</div>';
		$display_name = '';
		if ($contact_id) {
			$is_company = $is_person = false;
			$this->updateContactCompany($contact_id);
			
			if (($is_company = $this->isCompany($contact_id)) && empty($company_name)) {
				// TODO use Company__item db functions getItem
				$company_name = $this->db->quickGet(
					'Company__item.display_name', 
					'Company__item',  
					"Company__item.contact_id = '$contact_id' AND Company__item.primary_record = 1 AND Company__item.active = 1"
				);
				$person_name = false; // Dont want person name as part of company name
				// print '<div>isCompany - ' . $contact_id . ' name: ' . $company_name . '</div>'; 
			} else if (($is_person = $this->isPerson($contact_id)) && empty($person_name)) {
				// TODO use Person__item db functions getItem
				$person_name = $this->db->quickGet(
					'Person__item.display_name', 
					'Person__item',  
					"Person__item.contact_id = '$contact_id' AND Person__item.primary_record = 1 AND Person__item.active = 1"
				);
				// print '<div>isPerson - ' . $contact_id . ' name: ' . $person_name . '</div>';
			}
			$separator = ':';
			// $display_name = $company_name . $separator . ' ' . $person_name;
			// $display_name = trim($display_name, ' ' . $separator);
			
			$display_name = false;
			if ( $is_company && ($company_name !== false) ) {
				$display_name = $company_name;
			} else if ( $is_person && ($person_name !== false) ) {
				$display_name = $person_name;
			}
			// print '<div>display_name: ' . $display_name . '</div>';
			if ($display_name) {
				// TODO Should use db_functions setItem
				$this->db->update(
					'Contact__item', 
					array(
						'display_name' => $display_name, 
					), 
					"id ='$contact_id'"
				);
				$this->unsetContactCacheFor($contact_id);
			}
		}
		return $display_name;
	}
	
	/**
	 * Sets the last_update AND last_reach fields for the given contact
	 *
	 * @param string $contact_id The contact to update
	 * @param integer $timestamp The last_update timestamp
	 * @return mixed The update return value
	 */
	function updateLastUpdate($contact_id, $timestamp) {
		$retval = false;
		if ($timestamp) {
			$retval = $this->db->update(
				'Contact__item', 
				array(
					'last_update' => $timestamp, 
				), 
				"id ='$contact_id' AND `last_update` < '$timestamp'"
			);
			// $this->unsetContactCacheFor($contact_id); // Necessary?
		}
		return $retval;
	}
	
	/**
	 * Sets the last_reach field for the given contact
	 *
	 * @param string $contact_id The contact to update
	 * @param integer $timestamp The last_reach timestamp
	 * @return mixed The update return value
	 */
	function updateLastReach($contact_id, $timestamp) {
		$retval = false;
		if ($timestamp) {
			$retval = $this->db->update(
				'Contact__item', 
				array(
					'last_reach' => $timestamp, 
				), 
				"id ='$contact_id' AND `last_reach` < '$timestamp'"
			);
			// $this->unsetContactCacheFor($contact_id); // Necessary?
		}
		return $retval;
	}
	
	function getDuplicatesQueryLimit() {
		if ($this->duplicates_query_limit === false) {
			// TODO: user pref lookup: paging list size
			$this->duplicates_query_limit = 'LIMIT 0, 1000';
		}
		return $this->duplicates_query_limit;
	}
	
	function getDuplicatesViewFields() {
		if ($this->duplicates_view_fields === false) {
			// TODO: get field list for Contact__item data option: 'duplicates_view'
			// make sure 'id' (and 'is_duplicate_checked') are in the list
			$this->duplicates_view_fields = 'id,is_duplicate_checked,display_name,email1_content,phone1_content,last_update';
		}
		return $this->duplicates_view_fields;
	}
	
	/**
	 * Performs a contact search based on defined criteria.
	 *
	 * @param integer $id The contact id to find duplicates for
	 * @param boolean $id_only If true, query will only return the id of the potential duplicates. Otherwise returns all fields in the 'duplicate_view' data option. 
	 * @return mixed false or an array of possible duplicate contacts
	 */
	function hasDuplicates($id, $id_only = false) {
		global $SERVICES;
		//echo 'here';
		if ($this->isDuplicateChecked($id)) {
			// print '<div>already duplicate checked ' . $id . ' [' . $this->contacts[$id]['is_duplicate_checked'] . ']</div>';
			return false;
		}
		//		else {
		//			print '<div>not duplicate checked (or we believe there are duplicates) id:' . $id . ' [' . $this->contacts[$id]['is_duplicate_checked'] . ']</div>';
		//		}
		
		$result = false;
		$contact = $this->getContact($id);
		// print_r($contact); print '<hr>';
		// Match source field (this contact) with destination (from db) field
		$criteria = array(
			array('s' => 'display_name', 'd' => 'display_name'), 
			
			array('s' => 'email1_content', 'd' => 'email1_content'), 
			array('s' => 'email1_content', 'd' => 'email2_content'), 
			array('s' => 'email1_content', 'd' => 'email3_content'), 
			
			array('s' => 'email2_content', 'd' => 'email1_content'), 
			array('s' => 'email2_content', 'd' => 'email2_content'), 
			array('s' => 'email2_content', 'd' => 'email3_content'), 
			
			array('s' => 'email3_content', 'd' => 'email1_content'), 
			array('s' => 'email3_content', 'd' => 'email2_content'), 
			array('s' => 'email3_content', 'd' => 'email3_content'), 
			
			//too many false positives
			//			array('s' => 'phone1_content', 'd' => 'phone1_content'), 
			//			array('s' => 'phone1_content', 'd' => 'phone2_content'), 
			//			
			//			array('s' => 'phone2_content', 'd' => 'phone1_content'), 
			//			array('s' => 'phone2_content', 'd' => 'phone2_content'), 
			
			// array('s' => 'addrpost1_postcode', 'd' => 'addrstreet1_postcode') // Too ambiguous
		);
		
		$extra_where = array();
		foreach ($criteria as $k => $v) {
			if (is_array($v) && isset($v['s']) && isset($v['d']) && isset($contact[$v['s']]) && $contact[$v['s']]) {
				$extra_where[] = '(`' . $v['d'] . '` = \'' . addslashes($contact[$v['s']]) . '\')';
			}
		}
		// print_r($extra_where); print '<hr>';
		if (count($extra_where)) {
			$extra_where = ' (' . implode(' OR ', $extra_where) . ') ';
			
			// Phil 20070528 in some case we only need the id field here, 
			// on the contact view screen we need all fields included in the duplicate_view data option
			if ($id_only === true) {
				$fields = 'id,is_duplicate_checked';
			} else {
				$fields = (string)$this->getDuplicatesViewFields();
			}
			$table = 'Contact__item';
			
			
			// $where = '`id` <> ' . $id . ' AND `active`=1 AND `display_name` = \'' . $display_name . '\'';
			$where = '`id` <> ' . $id . ' 
					AND `active` = 1
					'; 
			
			if ($this->isCompany($id)) {
				//echo 'isCompany';
				//exclude 'dup hits' for people that belong got this company based on matching address fields
				$where .= ' AND `contact_company` <> ' . $id . '';
			} 
			else 
			{ 
				//echo 'is Person';
				//echo $this->contact_company;
				//exclude a company record 'dup hit' based on matching address fields (todo: allow dup hit on display_name
				$where .= ' AND `id` <> ' . $contact['contact_company'] . '';
				//$where .= ' AND `id` <> 1';
			}
		
			$where .= '	AND ' . $extra_where;
			
			
			//print '<div>WHERE ' . $where . '</div>';
			$result = $this->db->quickGetAllRows($fields, $table, $where, false, false, $this->getDuplicatesQueryLimit());
			
			// Either set this contact as duplicate checked, or set all its potential duplicates as not duplicate checked
			if (!$result) {
				// print '<div>no result for ' . $id . '</div>';
				$this->setIsDuplicateChecked($id, 1); // So we dont bother searching this item next time
			} else {
				// print '<div>result for ' . $id . '  ' . count($result) . '</div>'; // print_r($result);
				// $this->setIsDuplicateChecked($id, 2); // see below
				if (is_array($result)) {
					$ids = array();
					$ids[] = $id; // So we know this contact has duplicates
					foreach ($result as $k => $v) {
						if (isset($v['id']) && $v['id'] && isset($v['is_duplicate_checked']) && ($v['is_duplicate_checked'] != 2)) {
							$ids[] = $v['id'];
						}
					}
					// print '<div>matching ids:</div>'; print_r($ids);
					if (count($ids)) {
						$ids_string = '`id` IN (' . implode(',', $ids) . ')';
						// print '<div>ids string: ' . $ids_string . '</div>';
						$this->db->update('Contact__item', array('is_duplicate_checked'=>2), 'active=1 AND ' . $ids_string);
					}
				}
			}
		}
		return $result;
	}
	
	/**
	 * @param integer $id The contact id
	 * @return integer $is_duplicate_checked - whether the given contact has been checked for duplicates.
	 */
	function isDuplicateChecked($id) {
		// if (!is_object($this->db_functions)) {
			// $this->db_functions =& $this->getDatabaseTable('item');
		// }
		// $contact = $this->db_functions->getItem($id);
		$contact = $this->getContact($id);
		return (isset($contact['is_duplicate_checked']) && ((int)$contact['is_duplicate_checked'] === 1) ? true : false);
	}
	
	/**
	 * Sets the 'item' field 'is_duplicate_checked' to 'val'
	 *
	 * @param integer $id The contact id
	 * @param integer $val Optional (defaults to 1) value to set
	 */
	function setIsDuplicateChecked($id, $val = 1) {
		if (!is_object($this->db_functions)) {
			$this->db_functions =& $this->getDatabaseTable('item');
		}
		$item = array(
			'id'=>$id,
			'is_duplicate_checked'=>$val
		);
		$this->db_functions->setItem($item);
		
		if (isset($this->contacts) && isset($this->contacts[$id]) && is_array($this->contacts[$id])) { //  && isset($this->contacts[$id]['is_duplicate_checked'])) {
			// print '<div>setting duplicate checked value ' . $val . ' for contact ' . $id . '</div>';	
			$this->contacts[$id]['is_duplicate_checked'] = $val;
		}
	}
	
	/**
	 * @param boolean $all Whether to check all contacts (true), or just those that have not been checked (false - default)
	 */
	function runDuplicateCheck($all = false) {
		// Set max_limit to paging_max_list_size (eg 1000)
		// TODO - add a time limit, similar to the Search module, and ideally a memory_limit test.
		$this->setOutput();
		$max_limit = 100;
		if (is_object($this->output)) {
			$max_limit = max ($max_limit, (int)$this->output->paging_max_list_size);
		}
		$limit = 'LIMIT 0, ' . $max_limit;
		
		$where = 'active=1';
		if (!$all) {
			$where .= ' AND is_duplicate_checked=0';
		}
		//error_reporting(E_ALL^E_NOTICE); // DEBUG
		$result = $this->db->select('id', 'Contact__item', $where, false, false, $limit);
		if ($result) {
			$ids = array();
			while ($row = $this->db->getRow($result)) {
				// print '<div>checking contact ' . $row['id'] . '</div>';
				// hasDuplicates will change the is_duplicate_checked' status of all contacts that are potential duplicates
				$this->hasDuplicates($row['id'], true); // We only need the id field here
				// print '<div>id: ' . $row['id'] . ' memory: ' . memory_get_usage() . '</div>';
			}
		}
	}
	
	// ----- Contact data - set and get -----
	
	/**
	 * Takes the specified name fields and formats as a 'display name' based on user preference
	 *
	 * @param array $name_fields An array containing field names (keys) and values
	 * @return string $name
	 * @deprecated version 5
	 */
	function formatName($name_fields) {
		return false;
	}
	
	/**
	 * Returns the display name for the given contact
	 */
	function getName($id) {
		global $L;
		$name = 'display_name';
		// if (isset($this->contacts[$id]) && isset($this->contacts[$id][$name]) && $this->contacts[$id][$name]) {
			// // print '<div>Contact::getName(' . $id . ') = cached "' . $this->contacts[$id][$name] . '"</div>';
			// return $this->contacts[$id][$name];
		// }
		$contact = $this->getContact($id);
		// print '<div>getName(' . $id . ')</div>'; print_r($contact); print '<hr>';
		$display_name = ( (isset($contact['display_name']) && $contact['display_name']) ? $contact['display_name'] : $L['contactNoName']);
		$display_name =  trim($display_name);
		
		// print '<div>Contact::getName(' . $id . ') = "' . $display_name . '</div>';
		return $display_name;
	}
	
	/** 
	 * Calculate and update a postal or physical address
	 */
	function updatePostalAddressDisplayName($contact_id) {
		$display_name = $this->getPostalAddressDisplayName($contact_id);
		// print '<div>contact: ' . $contact_id . ' postal address display_name: <br><strong>' . $display_name . '</strong><br></div>';
		return $this->db->update(
			'Contact__item', 
			array(
				'addrpost1_displayname' => $display_name, 
			), 
			"id ='$contact_id'"
		);
	 }
	 
	 /**
	 * @return array of arrays with keys: 'field_key' and 'separator'
	 * @author Phil Calder
	 */
	function getPostalAddressDisplayNameFields() {
		return (array)$this->addrpost_name_fields;	
	}
	 
	 /**
	 * @author Phil Calder
	 */
	function getPostalAddressDisplayName($id) {
		
		$item = $this->getContact($id, true);
		$display_name = '';
		
		$prefix = $this->getModuleName() . '__item.'; // Phil 20050922 Handles foreign field naming, eg $item[module__table.field]
		// print_r($item); print '<hr>';
		foreach ($this->getPostalAddressDisplayNameFields() as $k => $v) {
			// print '<div>item field_key: ' . $item[$v['field_key']] . ' field: ' . $k . ' value:</div>'; print_r($v);
			$field = (isset($item[$v['field_key']]) ? $item[$v['field_key']] : ($item[$prefix . $v['field_key']])); 
			// $display_name .= (isset($item[$v['field_key']]) && $item[$v['field_key']] ? ($item[$v['field_key']] . $v['separator'] . '') : ''); 	
			$display_name .= (isset($field) && $field ? ($field . $v['separator'] . '') : ''); 
		}
		
		// foreach ($this->address_fields as $k => $v) {
		foreach ($this->getPostalAddressDisplayNameFields() as $k => $v) {
			$display_name = trim($display_name, $v['separator'] . ' '); 	
		}
		// print '<div>display_name: ' . $display_name . '</div>'; exit();
		return $display_name;
	}
	
	// --
	/** 
	 * Calculate and update a physical address
	 */
	function updatePhysicalAddressDisplayName($contact_id) {
		$display_name = $this->getPhysicalAddressDisplayName($contact_id);
		// print '<div>contact: ' . $contact_id . ' Physical address display_name: <br><strong>' . $display_name . '</strong><br></div>';
		
		return $this->db->update(
			'Contact__item', 
			array(
				'addrstreet1_displayname' => $display_name, 
			), 
			"id ='$contact_id'"
		);
	 }
	 
	 /**
	 * @return array of arrays with keys: 'field_key' and 'separator'
	 * @author Phil Calder
	 */
	function getPhysicalAddressDisplayNameFields() {
		return (array)$this->addrstreet_name_fields;	
	}
	 
	 /**
	 * @author Phil Calder
	 */
	function getPhysicalAddressDisplayName($id) {
		
		$item = $this->getContact($id, true);
		$display_name = '';
		
		$prefix = $this->getModuleName() . '__item.'; // Phil 20050922 Handles foreign field naming, eg $item[module__table.field]
		
		foreach ($this->getPhysicalAddressDisplayNameFields() as $k => $v) {
			$field = (isset($item[$v['field_key']]) ? $item[$v['field_key']] : ($item[$prefix . $v['field_key']])); 
			// $display_name .= (isset($item[$v['field_key']]) && $item[$v['field_key']] ? ($item[$v['field_key']] . $v['separator'] . '') : ''); 	
			$display_name .= (isset($field) && $field ? ($field . $v['separator'] . '') : ''); 
		}
		
		// foreach ($this->address_fields as $k => $v) {
		foreach ($this->getPhysicalAddressDisplayNameFields() as $k => $v) {
			$display_name = trim($display_name, $v['separator'] . ' '); 	
		}
		
		return $display_name;
	}
	// --
	
	/**
	 * @deprecated version 5
	 */
	function getSecondaryFieldSettings() {
		return false;
	}
	
	/**
	 * @deprecated version 5
	 */
	function getSecondaryItemsFor($contact_id, $field, $module, $table = 'item', $limit_count = 5) {
		return false;
	}
	
	/**
	 * @deprecated version 5
	 */
	function getSecondaryItemFor($contact_id, $field, $module, $table = 'item', $offset = false) {
		return false;
	}
	
	// eg get primary email address for a contact
	// Phil 20060328
	function getPrimaryItemFor($contact_id, $module, $display_name_only = false, $table = 'item', $one = true, $offset = false) {
		global $SERVICES;
		$item = false;
		if (is_object($mod =& $SERVICES->modules->getModule($module))) {
			if (is_object($db_functions =& $mod->getDatabaseTable($table))) {
				$item = $db_functions->getPrimaryRecord($contact_id, $one, $offset);
				if (($item !== false) && $display_name_only) {
					$item = $db_functions->getItemDisplayName($item['id']);
				}
			}
		}
		return $item;
	}
	
	// eg get primary email address for a contact
	// Phil 20060328
	function getPrimaryItemDisplayNameFor($contact_id, $module, $table = 'item') {
		return $this->getPrimaryItemFor($contact_id, $module, true, $table);
	}
	
	
	/**
	 * Useful for WebForms
	 *
	 * @param array $item An array of fields for a new contact
	 * @return mixed false or the new contact id
	 * @access private
	 * @todo Implement for version 4
	 */
	function addQuickContact($item = array()) {
		if (sizeof($item) && ($db_functions =& $this->getDatabaseTable('item')) ) {
			bcrm_unset($item, 'id');
			$item['is_indexed'] = 0;
			// $item['display_name'] = $this->formatName($item);
			return $db_functions->setItem($item);
		}
		return false;
	}
	
	/**
	 * Called by Company and Person modules
	 */
	function deleteItem($id) { 
		if (!is_object($this->db_functions)) {
			$this->db_functions =& $this->getDatabaseTable('item');
		}
		if ($this->isPerson($id)) {
			// print '<div>deleteItem(' . $id . ') - calling deletePerson(' . $id . ')</div>';
			$this->deletePerson($id);
		}
		if ($this->isCompany($id)) {
			// print '<div>deleteItem(' . $id . ') - calling deleteCompany(' . $id . ')</div>';
			$this->deleteCompany($id);
		}
		// if ($this->isAccount($id)) {
			// // print '<div>deleteItem(' . $id . ') - calling deleteAccount(' . $id . ')</div>';
			// $this->deleteAccount($id);
		// }
		// print '<p>delete contact item ' . $id . '</p>';
		$item = $this->db_functions->getItem($this->delete);
		$this->db_functions->deleteItem($id, $item);
		$this->cascadeDelete($id);
	}
	
	/**
	 * Performs cascading delete for the given contact
	 */
	function cascadeDelete($id) {
		global $SERVICES;
		$arr = $SERVICES->config->lookup('modules.Contact.cascading_delete');
		if (is_array($arr)) {
			// print_r($arr); print '<hr>';
			foreach ($arr as $k => $v) {
				$mod =& $SERVICES->modules->getModule($v['module']);
				$func = $v['function'];
				if ($func && $mod && method_exists($mod , $func)) {
					$mod->$func($id);
				}
			}
		}
	}
	
	/**
	 * Called when a contact is deleted
	 * This will 'clean up' any items directly linked to this contact (eg Person, Company, and/or Account records)
	 */
	function crmCascadingDelete($contact_id) {
		// delete the Person attached to this contact
		if ($this->isPerson($contact_id)) {
			// print '<p>This contact is a Person</p>';
			$this->deletePerson($contact_id);
		}
		// delete the Company attached to this contact
		if ($this->isCompany($contact_id)) {
			// print '<p>This contact is a Company</p>';
			$this->deleteCompany($contact_id);
		} 
		// delete the Account attached to this contact
		// if ($this->isAccount($contact_id)) {
			// // print '<p>This contact is an Account</p>';
			// $this->deleteAccount($contact_id);
		// } 
	}
	
	/**
	 * Passes this request to the Person module
	 */
	function deletePerson($contact_id) {
		global $SERVICES;
		$SERVICES->getService('Modules');
		$person =& $SERVICES->modules->getModule('Person');
		$person->deletePersonByContactId($contact_id);
	}
	
	/**
	 * Passes this request to the Company module
	 */
	function deleteCompany($contact_id) {
		global $SERVICES;
		$SERVICES->getService('Modules');
		$person =& $SERVICES->modules->getModule('Company');
		$person->deleteCompanyByContactId($contact_id);
	}
	
	/**
	 * @deprecated version 5
	 */
	function deleteAccount($contact_id) {
		return true;
		// global $SERVICES;
		// $SERVICES->getService('Modules');
		// $account =& $SERVICES->modules->getModule('Accounts');
		// $account->deleteAccountByContactId($contact_id);
	}
	
	function getNewAccountLink($url_only = false) {
		return $this->getNewCompanyLink($url_only);
	}
	
	function getNewCompanyLink($url_only = false) {
		$this->setOutput();
		global $L, $SERVICES;
		$url = $SERVICES->config->lookup('modules.Contact.functions.new');
		$url = $this->getModulePath() . str_replace('%contact_type%', '1', $url);
		if ($url_only) {
			return $url;	
		}
		return array(
			'href' => $url, 
			'text' => $L['contactCompanyTitleNew_itemedit'],
			'icon' => 'company_new.png'
		);
		// return $this->output->getLinkHref($link_array);
	}
	
	function getNewPersonLink($url_only = false, $contact_company = false) {
		$this->setOutput();
		global $L, $SERVICES;
		$url = $SERVICES->config->lookup('modules.Contact.functions.new');
		$url = $this->getModulePath() . str_replace('%contact_type%', '0', $url);
		if ($contact_company) {
			$url .= '&contact_company=' . $contact_company;
		}
		if ($url_only) {
			return $url;	
		}
		return array(
			'href' => $url, 
			'text' => $L['contactPersonTitleNew_itemedit'],
			'icon' => 'person_new.png'
		);
		// return $this->output->getLinkHref($link_array);
	}
	
	/**
	 * @deprecated version 5
	 */
	function getShowAllAddressesLink($show_all) {
		return false;
	}
	
	function getContactDeleteLink($url_only = false) {
		$this->setOutput();
		global $L;
		// TODO use a config lookup
		$url =  '../../modules/Contact/edit.php?delete=%id%';
		if ($url_only) {
			return $url;	
		}
		return $this->output->getLinkHref( 
			array(
				'href' => $url, 
				'text' => $L['LinkDelete']
			) 
		);
	}
	
	/**
	 * @deprecated version 5
	 */
	function getContactChangeCompanyLink($url_only = false) {
		return false;
	}

	/** 
	 * @deprecated version 5
	 */
	function getExtendedCustomDataDefinition() {
		return false;
	}
	
	/**
	 * Data definition created on the fly for this modules Custom Fields
	 * 
	 * Used by the custom field view and edit pieces (contact view page)
	 *
	 * @param string $data_option
	 * @param mixed $contact_id Optional integer, defaults to false
	 * @return array data definition
	 */
	function getCustomDataDefinition($data_option, $contact_id = false, $include_display_name = false) {
		global $SERVICES, $L;
		$dd_service =& $SERVICES->getService('DataDefinition');
		// if (!is_array($data_definition=$this->getExtendedCustomDataDefinition())) {
			// $data_definition = array();
			// $data_definition['fields'] = $dd_service->getCustomFields('Contact__item');
		// }
		$data_definition = array();
		$data_definition['fields'] = $dd_service->getCustomFields('Contact__item');
		
		// Add the display name field (alters the id field as a read only contact link)
		if ($include_display_name) {
			$data_definition['fields']['id'] = array(
				'label'     => $L['Contact'], 
				'field_key' => 'id', 
				'type'      => 'contact', 
				'value'     => $contact_id, 
				'read_only' => 1
			);
		}
		
		if ( !is_array($data_definition['fields']) || !count($data_definition['fields'])) {
			$this->has_custom_fields = false;
		} else {
			$this->has_custom_fields = true;
		}
		$data_definition['data_options'] = $dd_service->getOptions();
		$include_keys = array_keys($data_definition['fields']);
		
		if ($contact_id) {
			// print '<div>contact_id=' . $contact_id . ', include_keys</div>'; print_r($include_keys); 
			if ($this->isCompany($contact_id)) {
				// print '<div>is_company</div>';
				// Remove Person__item* fields
				$needle = 'Person__item';
				$len = strlen($needle);
				foreach ($include_keys as $k => $v) {
					$pos = strpos($v, $needle);
					if ( ($pos !== false) && (substr($v, 0, $len) == $needle) ) {
						// print '<div>unset=' . $v . '</div>';
						bcrm_unset($include_keys, $k);
					}
				}
			} else if ($this->isPerson($contact_id)) {
				// print '<div>is_person</div>';
				// Remove Company__item* fields
				$needle = 'Company__item';
				$len = strlen($needle);
				foreach ($include_keys as $k => $v) {
					$pos = strpos($v, $needle);
					if ( ($pos !== false) && (substr($v, 0, $len) == $needle) ) {
						// print '<div>unset=' . $v . '</div>';
						bcrm_unset($include_keys, $k);
					}
				}
				// Phil - not needed in version 5
				// if (!$this->isAccount($contact_id)) {
					// print '<div>NOT account</div>';
					// $needle = 'Accounts__item';
					// $len = strlen($needle);
					// foreach ($include_keys as $k => $v) {
						// $pos = strpos($v, $needle);
						// if ( ($pos !== false) && (substr($v, 0, $len) == $needle) ) {
							// // print '<div>unset=' . $v . '</div>';
							// bcrm_unset($include_keys, $k);
						// }
					// }
				// }
			}
			// print '<hr>';
		}
		// print '<div>after=</div>'; print_r($include_keys); print '<hr>';
		$data_definition['data_options']['custom'] = array(
			'method' => 'include',
			'values' => $include_keys, 
			'options' => array(
				'dropdown_values' => 1, 
				'exclude_calculated'=>0, 
				'exclude_custom'=>0, 
				'exclude_foreign'=>0, 
				'exclude_hidden'=>0, 
				'no_trim'=>1
			)
		);
		$dd = getWebMATObject(
			'WebMATDataDictionary', 
			'Contact', // $this->getModuleName(), 
			array(
				'data_definition' => $data_definition, 
				'data_option' => 'custom' // $data_option
			)
		);
		if (!$this->has_custom_fields || !is_object($dd)) {
			return array();
		} 
		// print '<div>data definition (and options)</div>'; print_r($dd); // print_r($data_definition['data_options']); exit();
		return $dd;
	}
	
	function beforeDatabaseTables($data_definition) {
		// print '<div>beforeDatabaseTables [' . $this->data_option_flag . ']</div>';
		if (isset($this->data_option_flag) && $this->data_option_flag) {	
			global $SERVICES;
			if (substr($this->data_option_flag, 0, strlen('public_')) == 'public_') {
				$this->data_option_flag = substr($this->data_option_flag, strlen('public_'));
			} //else if (substr($this->data_option_flag, 0, strlen('webform')) == 'webform') {
				//$this->data_option_flag = substr($this->data_option_flag, strlen('webform'));
				//print '<div>started with webform: [' . $this->data_option_flag . ']</div>';
			//}
			if (! ($filename = $this->getBeforeDatabaseTablesFileName()) ) {
				// print '<div>no getBeforeDatabaseTablesFileName [' . $this->data_option_flag . ']</div>';
				// includeModule('Contact', 'inc/contact_edit_data_definition.inc');
				$filename = $SERVICES->config->lookup('modules.basedir') . '/Contact/inc/contact_' . $this->data_option_flag . '_data_definition.inc';
			}
			// Phil - will have to use 'require' for now
			if (file_exists($filename) && is_readable($filename)) {
				// print '<div>exists [' . $filename . ']</div>';
				@require_once($filename);
			}
		}
		if (is_array($data_definition)) {
			// print '<div>(Contact) beforeDatabaseTables</div>'; print_r($data_definition); print '<hr>';
			return $data_definition;
		}
		return false;
	}
	
	/**
	 * Gets all non-indexed items and indexes them
	 *
	 * @deprecated version 4.5
	 */
	function indexNewForSearch() {
	}
}
?>