<?php
/**
 *
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Documents
 * @author Phil Calder
 *
 */

class DocumentsItemWebMATAdminNestedDropdown extends WebMATAdminNestedDropdown {
	
	/**
	 * Override field definition - parent id is compulsary (ie folders are all sub-folders of 'Home')
	 */
	function getFormFields($item) {
		$fields = parent::getFormFields($item);
		
		foreach ($fields as $k => $v) {
			if (is_array($v) && ($v['field_key'] == 'parent_id')) {
				$fields[$k]['notnull'] = 1;
				break;
			}
		}
		
		return $fields;
	}
	
	
	/**
	 * Displays a tabluar list of data for a dropdown.
	 * 
	 * changed to remove the delete link for the top level folder
	 * 
	 * @param array $link_array the current row_array
	 * @param string $id the current item id
	 * @return array the row_array with the links appended
	 */
	function getEditDeleteLinks($row_array, $id) {
		global $L, $PHP_SELF;
		
		$row_array[] = $this->output->getLinkHref(
			array(
				'href' => $PHP_SELF . '?id=-1&parent_id=' .$id, 
				'text' => $L['LinkNew']
			) 
		) . '&nbsp;&nbsp;';
		
		$row_array[] = $this->output->getLinkHref( 
			array(
				'href' => $PHP_SELF . '?id=' . $id, 
				'text' => $L['LinkEdit']
			) 
		);
		
		if ($id == 1) {
			$row_array[] = '';
		} else {
			$row_array[] = $this->output->getLinkDelete($PHP_SELF . '?delete=' . $id);
		}
		return $row_array;
		
	}
}
?>