<?php
/**
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Documents
 */
 
class DocumentsVersionWebMATOpenFile extends WebMATOpenFile {
	
	/* ---cecil:
		get file info in two ways:
	
			1.  by version id
			2.  by item id
	
	*/

	function getFileInfo() {
		global $SERVICES;
		
		if ($this->form_values['id']) {
			return parent::getFileInfo();
		}
		
		if ($item_id = $this->form_values['item_id']) {
			$this->db_functions->setMasterIds($item_id);
			$parent_item = $this->db_functions->getParentItems();
			$item = $this->db_functions->getItem($parent_item['version_id']);
			$mime_type_info = $this->dropdown->getValue($parent_item['mime_type_id']);
			$file_info['mime_type'] = $mime_type_info['name'];
			$file_info['file_name'] = $item['file_name'];
			
			//print_r($parent_item);echo'<hr>';print_r($item);
			// Phil, just testing, never used // $file_info['filename'] = trim($item['file_name'] . '.' . $item['file_extension'], '. ');
			// print '<div>DEBUG WebMATStandardOpenFile::getFileInfo</div>'; print_r($file_info); print '<hr>';
			return $file_info;
		}
	}
	/* ---cecil:
		get file info in two ways:
	
			1.  by version id
			2.  by item id
	
	*/
	
	function getFileForBrowser($download = false) {
		global $SERVICES;
		if ($this->use_database) {
			$file_info = $this->getFileInfo();
		} else {
			$file_info = false;
		}
		$version_id = $this->form_values['id'];
		$item_id = $this->form_values['item_id'];
		
		if (!$version_id   && $item_id) {
			
			$this->db_functions->setMasterIds($item_id);
			$parent_item = $this->db_functions->getParentItems();
			$version_id = $parent_item['version_id'];
		}
		
		// print '<div>DEBUG WebMATStandardOpenFile, download: ' . $download .', use_database: ' . $this->use_database . ', file_info:</div>'; print_r($file_info); print '<hr>'; exit();
		
		//TODO restore this when module is renamed from Documents to Files
		//$SERVICES->filesystem->getFileForBrowser($version_id, strtolower($this->module_name), $this->master_dir, $this->sub_dir, $file_info, $download);
		$SERVICES->filesystem->getFileForBrowser($version_id, 'files', $this->master_dir, $this->sub_dir, $file_info, $download);
		if ($SERVICES->filesystem->hasError()) {
			quickpage($SERVICES->filesystem->printError());
		}
	}
	
		
}


?>