<?php
require_once("../../prepend.inc");

/**
 * User Preferences.
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Front
 */


$ua =& $SERVICES->getService('Authentication');
if (!empty($user_id) && ($user_id != $USER['user_id'])) { // Can edit another users prefs only if you have admin rights to UserAdmin module
	$ua->adminRestrict('UserAdmin');
}
$SERVICES->getService('Language');
$SERVICES->getService('Preferences');
$SERVICES->language->getLanguage('Front');

	
function getPref($key) {
	global $SERVICES, $user_id, $ua;
	// -- Phil 20040721
	if (!empty($user_id) && ($user_id != $USER['user_id']) && ($ua->adminAccess($USER['user_id'], 'UserAdmin') )) {
		return $SERVICES->preferences->getUserPref($key, '', $user_id);
	}
	return $SERVICES->preferences->getUserPref($key);
}

function dropDown($data){
	$width = '200';
	if ($data['name'] == 'data[cfgTimeOffsetHours]') {  //special case for timezone; long drop down; hack until we rewrite using output class
		$width = '420';
	}
	
	$html = '<select name="'.$data['name'].'" style="width:' . $width . 'px;">';
	if (sizeof($data['type']) > 0) {
		foreach($data['type'] as $k => $v) {
			$html .= '<option value="'.$k.'"'.($data['value'] === strval($k) ? ' selected' : '').'>'.$v.'</option>';
		}
	}	
	
	$html .= '</select>';
	$content = '<td nowrap>'.$data['label'].': </td><td>'.$html.'</td>';
	if ($data['name'] == 'data[cfgTimeOffsetHours]') {  //special case for timezone; long drop down; hack until we rewrite using output class
		$content = '<td nowrap>'.$data['label'].': </td></tr><tr><td colspan="2" align="right">'.$html.'</td>';
	}
	return $content;
}

function formEvents($item) {
	$attr = "";
	foreach ($item as $k => $v) {
			if (substr($k, 0, 2) == 'on') { $attr .= " $k = '$v'"; }
	}
	return $attr;
}


// type name value size maxlength label
function formInput($item) {
	switch ($item['type']) {
	case "text":
		$ro = bcrm_htmlspecialchars($item['value']);
		$rw = "<input" . formEvents($item) . " class = 'input_extras' size = '" . $item['size'] . "' maxlength = '" . $item['maxlength'] . "'type = 'text' name = '" . $item['name'] . "' value = '" . bcrm_htmlspecialchars($item['value']) . "'>";
	break;
	case "textarea":
		$ro = bcrm_htmlspecialchars($item['value']);
		$rw = "<textarea cols = '48' rows = '5' name = '" . $item['name'] . "'>" . bcrm_htmlspecialchars($item['value']) . "</textarea>";
	break;
	case "money":
		$ro = "$" . sprintf("%01.2f", $item['value']);
		$rw = "$<input" . formEvents($item) . " class = 'input_extras' type = 'text' name = '" . $item['name'] . "' size = '" . $item['size'] . "' value = '" . sprintf("%01.2f", $item['value']) . "'>";
	break;
	case "percent":
		$ro = $item['value'] . "%";
		$rw = "<input" . formEvents($item) . " class = 'input_extras' type = 'text' name = '" . $item['name'] . "' size = '" . $item['size'] . "' value = '" . bcrm_htmlspecialchars($item['value']) . "'>%";
	break;
	case "timestamp":
		$ro = strftime("%d %B %Y", $item['value']);
		$rw = "<input" . formEvents($item) . " class = 'input_extras' type = 'text' name = '" . $item['name'] . "' size = '" . $item['size'] . "' value = '" . strftime("%d %B %Y", $item['value']) . "'>";
	break;
	default:
		$ro = isset($item['type'][$item['value']]) ? $item['type'][$item['value']] : "";
		$rw = "<select" . formEvents($item) . " style='width:200px;' name = '" . $item['name'] . "'".(isset($item['javascript']) ? $item['javascript'] : '').">";
		foreach ($item['type'] as $k => $v) {
				$rw .= "<option value = '$k'" . (($item['value'] == $k) ? " selected" : "") . ">$v</option>\n";
		}
		$rw .= "</select>";
	break;
	}
	return (isset($item['label']) ? "<td nowrap>" . $item['label'] . ":</td><td>" : "<td>") . (isset($item['ro']) ? $ro : $rw) . "</td>\n";
}

	
function doSubmit() {
	global $SERVICES, $ua, $USER, $PHP_SELF, $USER, $close_window, $target, $user_id;
	//check for submit
	if (isset($_POST['submit'])) {
		$data = $_POST['data'];
		
		//loop through all pref names
		foreach($data as $pref => $val) {
			// Need to know if language pref has changed (see below)
			if ( ($pref == 'cfgLanguage') && ($USER['user_id'] == $user_id) && ($val != $SERVICES->preferences->getUserPref('cfgLanguage'))) {
				$refresh = true;
			}
			$SERVICES->preferences->setUserPref($pref, $val, $user_id); // user_id - Phil 20040721
		}
		// Need to refresh the entire browser when language or contact frame width has been changed
		if (isset($refresh) && $refresh) {
			print("
			<script type=\"text/javascript\" language=\"JavaScript\">\n<!--\n
			parent.location.replace('../../');
			</script>
			");
			//MCR 20060503 for clean url, was: parent.location.replace('../../index.php');
			
			
		} //changed MCR 20040626 /index.php to ../../index.php
		if(!$close_window){
			// Lastly return to the main admin page
			header('location:../Admin/index.php');
			exit();
		} else {
			$target = base64_decode($target);
			if ($target) {	
				if ($target == 'parent') { // reload the parent frame
					print("<script type=\"text/javascript\" language=\"JavaScript\">\n<!--\nwindow.opener.parent.location.reload();\nwindow.close();\n//-->\n</script>");
				} else { // replace the page with target
					print("<script type=\"text/javascript\" language=\"JavaScript\">\n<!--\nwindow.opener.location.replace('" . $target . "');\nwindow.close();\n//-->\n</script>");
				}
			} else { // reload the page
				print("<script type=\"text/javascript\" language=\"JavaScript\">\n<!--\nwindow.opener.location.reload();\nwindow.close();\n//-->\n</script>");
			}
		}
		exit();
	}
}


function main() {
	global $SERVICES, $L, $PHP_SELF, $USER, $skinname, $ua, $prefs_inc, $target, $user_id;
	$skin = $USER['skin_web_path'];
	$output =& $SERVICES->getService('Output'); // Even if not used, prevents overriding of Output class as modules are created.
	
	// Phil 20060131 Load a single module,or all modules
	if (isset($_GET['module']) && $_GET['module']) {
		$links = $SERVICES->config->lookup('modules.Front.prefslink.' . $_GET['module']);
	} else {
		// Make sure classes are loaded.
		$links = $SERVICES->config->lookup('modules.Front.prefslink');
	}
	$links = (array)$links;
	
	foreach ($links as $k => $v) {
		if ((isset($v['module'])) && !$ua->readAccess($USER['user_id'], $v['module']) ) {
			bcrm_unset($links, $k);	
		}
	}
	
	if (isset($links['file'])) {
		$links = array($links);
	}
	
	foreach ($links as $k => $link) {
		$sortarray[] = (isset($link['priority']) ? $link['priority'] : '');
		// Phil 20050405
		$link['file'] = basename($link['file']); // Phil 20050405 - we now have a modules_custom dir as well as a modules dir
		if (file_exists('../../modules/' . $link['module'] . '/' . $link['file'])) {
			$link['file'] = '../../modules/' . $link['module'] . '/' . $link['file'];
		} else if (file_exists('../../modules_custom/' . $link['module'] . '/' . $link['file'])) {
			$link['file'] = '../../modules_custom/' . $link['module'] . '/' . $link['file'];
		}
		$links[$k]['file'] = $link['file'];
		// print '<div>Front/preferences.php link:</div>'; print_r($link); print '<hr>';
	}
	
	array_multisort($sortarray,$links);
	
	$content = '';
	//$content .= '  <table cellpadding="2" cellspacing="0" border="0" width="500">';
	$content .= '<form action="' . $PHP_SELF . '" method="POST">';
	if (!empty($user_id) && ($ua->writeAccess($USER['user_id'], 'UserAdmin') )) { // Phil 20040721
		$content .= '<input type="hidden" name="user_id" value="' . $user_id . '">';
	}
	
	$content .= '<input type="hidden" name="target" value="' . $target . '">';
	// $content .= '    <tr>';
	// $content .= '      <td colspan=3 class=titleCell><strong>' . $L['SetUserPreference'] . '</strong></td>';
	// $content .= '    </tr>';
	
	if (!empty($user_id) && ($ua->writeAccess($USER['user_id'], 'UserAdmin') )) { // Phil 20040721
		//$content .= '    <tr>';
		//$content .= '      <td colspan=2><strong>' . $L['frontLabelPreferencesFor'] . ': </strong>' . $ua->users->getUsername($user_id) . '</td>';
		//$content .= '    </tr>';
		$content .= '      <div style="padding:10px;"><h2>' . $L['frontLabelPreferencesFor'] . ': ' . $ua->users->getUsername($user_id) . '</h2></div>';
		
		$page_title_suffix = ' - ' . $L['frontLabelPreferencesFor'] . ': ' . $ua->users->getUsername($user_id);
	} else {
		$page_title_suffix = '';
	}
	
	//$content .= '</table>'; 
	
	if ($prefs_inc) {
		$content .= '		<input type="hidden" name="close_window" value="1">';
	}
	
	$pref_rows = array();
	
	foreach ($links as $k => $link) {
		if ($prefs_inc && is_array($prefs_inc)) {
			foreach ($prefs_inc as $p) {
				// Always include the Front module prefs, and the module for this preference
				if ( ($link['module'] == 'Front') || (substr(strtolower($p), 0, strlen($link['module'])) == strtolower($link['module'])) ) {
					@include_once($link['file']);
				}
			}
		} else {
			@include($link['file']);
		}
	}
	
	// print count($pref_rows) . '<hr>';
	// Phil 20060131
	if (!count($pref_rows)) {
		$content = $L['frontLabelNoPreferences'] . '<br>
		<a href="javascript:history.go(-1)">' . $L['frontBack'] . '</a>';
		quickPage($content);
		exit();
	}
	
	$tabs_content = '';
	$tabs = array();
	$active_tab = false;
	
	// Phil 20070524 Splitting preferences into 2 tabsets
	$tabs_1_content = '';
	$tabs_1 = array();
	$active_tab_1 = false;
	
	if (count($pref_rows) > 10) {
	
		$tabs_1_modules = array(
			'Front',
			'Admin',
			'UserAdmin', 
			'Contact',
			'Company', 
			'Person',
			'ContactImport',
			'ContactRelationship', 
			'ClientLoginManager', 
			'SystemBookmarks', 
			
		);
		foreach ($tabs_1_modules as $k => $v) {
			$tabs_1[$v] = false;
		}
	} else {
		$tabs_1_modules = array();
	}
	
	
	//now loop through array
	foreach($pref_rows as $module => $prefs) {
		// print '<div>prefs module: ' . $module . '</div>';
		// Check if the privilege to this module is there
		if ($ua->writeAccess($USER['user_id'], $module)) {
			
			$current_tab_content = '
			<div id="tab' . $module . '" class="tab-content">
			<table cellpadding="2" cellspacing="3" border="0">
			';
			
			$SERVICES->language->getLanguage($module);
			$module_conf = $SERVICES->config->lookup("modules.$module");
			$module_label = $L[$module_conf['label']];
				
			//if (!$prefs_inc) {
				//$current_tab_content .= '<tr><td><b>'.$module_label.'</b></td></tr>';
			//}
		
			foreach($prefs as $pref_name => $pref_row) {
				if (!$SERVICES->preferences->isBlockedPref($pref_name) && (!$prefs_inc || in_array($pref_name, $prefs_inc))) {	
					$current_tab_content .= '<tr>' . $pref_row . '</tr>';
				}
			}
			
			$current_tab_content .= '
			</table>
			</div>
			';
			
			if (in_array($module, $tabs_1_modules)) {
				$tabs_1_content .= $current_tab_content;
				if (!$active_tab_1) {
					$active_tab_1 = 'tab' . $module;
				}
				$tabs_1[$module] = array('id' => 'tab' . $module, 'title' => $module_label);
				
			} else {
				$tabs_content .= $current_tab_content;
				if (!$active_tab) {
					$active_tab = 'tab' . $module;
				}
				$tabs[$module] = array('id' => 'tab' . $module, 'title' => $module_label);
				
			}
			
		}
	}
	
	
	if (count($tabs_1)) {
		$content .= '
	<div id="settingsTabs_1">
	' 
	. $tabs_1_content 
	. '
	</div>
	';
	}
	
	if (count($tabs)) {
		$content .= '
	<div style="padding:10px"></div>
	<div id="settingsTabs">
	'
	. $tabs_content
	. '
	</div>
	';
	}
	
	$output->initExt();
	
	if (count($tabs_1)) {
		$output->initTabs('settingsTabs_1');
		foreach ($tabs_1 as $tab) {
			if ($tab) {
				$output->addTab($tab, 'settingsTabs_1');
			}
		}
		$output->setFirstTab($active_tab_1, 'settingsTabs_1');
	}
	if (count($tabs)) {
		$output->initTabs('settingsTabs');
		foreach ($tabs as $tab) {
			if ($tab) {
				$output->addTab($tab, 'settingsTabs');
			}
		}
		$output->setFirstTab($active_tab, 'settingsTabs');
	}
	
	$content .= '
	<div style="padding-left:20px;padding-top:30px;"><input type="submit" name="submit" value=" ' . $L['ButtonSubmit'] . ' "></div>
	</form>
	';
	
	// Phil - instanciated above // $output =& $SERVICES->getService('Output');
	
	// $window_layout = '<table border=0 cellpadding=0 cellspacing=0 class="contentTable" align="center">';
	// $window_layout .= '<tr><td>'. $content . '</td></tr></table>';
	$title = $L['SetUserPreference'] . $page_title_suffix;
	
	
	// Phil 20060131 Mimics WebMATList
	//$window_layout = $output->getBeginTable('mainTbl', true);
	$window_layout .= $output->getTitleRow($title, array('bookmark'=>'off'));
	//$padding = true;
	//$window_layout .= $output->getBeginRow('', true) . '<td id="bodyCell"' . ($padding ? 'style="padding: 10px"' : '') . '>';
	$window_layout .= $content;
	//$window_layout .= '</td>' . $output->getEndRow(true);
	//$window_layout .= $output->getEndTable(true);
	
	$output->addToBody( $window_layout);
	if ($prefs_inc) {
		$output->setGraphicBlockSwitch(false);
	}
	$output->display();
	exit();
}

doSubmit();
main();

?>