<?php
/**
 * Contains the User Preferences name and details
 *
 * Use this file to set up Company / User Preferences which are configured from 
 * Admin. This file is included by Front/preferences.php for User Preferences 
 * and UserAdmin/preferences.php for Company Preferences.
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Front
 */

//this files wil be included by /Front/preferences.php accessed under Admin
//which will create a form for setting system-wide UserPrefs
global $L, $USER;

$ua =& $SERVICES->getService('Authentication');

$SERVICES->getService('Modules'); 
$SERVICES->getService('Preferences'); 
$SERVICES->getService('Config');

$front =& $SERVICES->modules->getModules('Front');

$SERVICES->getService('Language');
$SERVICES->language->getLanguage('Front');

// --------------------------------------------------------------
$front_rows = array();


// -- Language --

$cur_lang = $SERVICES->preferences->getUserPref('cfgLanguage');

$languages = array('' => '');

$standard_dirname = $dirname = $SERVICES->config->lookup('site.langdir');
if ( ($dir = @opendir( $dirname )) !== false) {
	while ($name = readdir($dir)) {
		if ($name != '.' && $name != '..' && $name != 'custom' && is_dir($dirname . '/' . $name)) {
			$languages[$name] = $name; // Give language a default title (incase $L['LanguageName'] doesnt exist)
			if (is_readable($dirname . '/' . $name . '/_Global.inc')) {
				bcrm_unset($L, 'LanguageName'); // incase $L['LanguageName'] doesnt exist for this language
				include($dirname . '/' . $name . '/_Global.inc');
				$languages[$name] = $L['LanguageName'] . ' (' . $languages[$name] . ')';
			}
		}
	}
}
$dirname = $SERVICES->config->lookup('site.customlangdir');
if ( ($dir = @opendir( $dirname )) !== false) {
	while ($name = readdir($dir)) {
		if ($name != '.' && $name != '..' && $name != 'custom' && is_dir($dirname . '/' . $name)) {
			$languages[$name] = $name; // Give language a default title (incase $L['LanguageName'] doesnt exist)
			if (is_readable($dirname . '/' . $name . '/_Global.inc')) {
				bcrm_unset($L, 'LanguageName'); // incase $L['LanguageName'] doesnt exist for this language
				include($dirname . '/' . $name . '/_Global.inc');
				$languages[$name] = $L['LanguageName'] . ' (' . $languages[$name] . ')';
			}
		}
	}
}

// Read current language file (to over write the last language file that was included)
@include($standard_dirname . '/en/_Global.inc');

if (is_readable($standard_dirname . '/' . $cur_lang . '/_Global.inc')) {
	include($standard_dirname . '/' . $cur_lang . '/_Global.inc');
}

$language_select_html = dropDown(
	array(
		'type' => $languages, 
		'name' => "data[cfgLanguage]", 
		'value' => getPref('cfgLanguage'), 
		'size' => 32, 
		'label' => '' . $L['frontLanguage'] . ''
	)
);

$front_rows['cfgLanguage'] = $language_select_html;

// --


// -- time zone - offset from server time --

$time_zones = array(
	'' => '',
	'-12' => $L['frontTimezoneGMT-12'],
	'-11' => $L['frontTimezoneGMT-11'],
	'-10' => $L['frontTimezoneGMT-10'],
	'-9' => $L['frontTimezoneGMT-9'],
	'-8' => $L['frontTimezoneGMT-8'],
	'-7' => $L['frontTimezoneGMT-7'],
	'-6' => $L['frontTimezoneGMT-6'],
	'-5' => $L['frontTimezoneGMT-5'],
	'-4' => $L['frontTimezoneGMT-4'],
	'-3' => $L['frontTimezoneGMT-3'],
	'-2' => $L['frontTimezoneGMT-2'],
	'-1' => $L['frontTimezoneGMT-1'],
	'0' => $L['frontTimezoneGMT'],
	'1' => $L['frontTimezoneGMT+1'],
	'2' => $L['frontTimezoneGMT+2'],
	'3' => $L['frontTimezoneGMT+3'],
	'4' => $L['frontTimezoneGMT+4'],
	'5' => $L['frontTimezoneGMT+5'],
	'5.5' => $L['frontTimezoneGMT+5.5'],
	'6' => $L['frontTimezoneGMT+6'],
	'7' => $L['frontTimezoneGMT+7'],
	'8' => $L['frontTimezoneGMT+8'],
	'9' => $L['frontTimezoneGMT+9'],
	'9.5' => $L['frontTimezoneGMT+9.5'],
	'10' => $L['frontTimezoneGMT+10'],
	'11' => $L['frontTimezoneGMT+11'],
	'12' => $L['frontTimezoneGMT+12'],
	'13' => $L['frontTimezoneGMT+13']
);
						
$time_select_html = dropDown(
	array(
		'type' => $time_zones, 
		'name' => "data[cfgTimeOffsetHours]", 
		'value' => getPref('cfgTimeOffsetHours'), 
		'size' => 48, 
		'label' => '' . $L['frontTimeZone'] . ''
	)
);

$front_rows['cfgTimeOffsetHours'] = $time_select_html;

// --

// -- Long Date Format --

$long_date_format = getPref('cfgLongDateFormat') ;
$time_format = getPref('cfgTimeFormat') ;
	
// Make a SHORT date format Selector:	
$short_date_formats = array(
	'' => '',
	'd/m/Y' => '01 12 2003  (d/m/Y)',
	'j/m/Y' => '1 12 2003  (j/m/Y)',
	'm/d/Y' => '12 01 2003  (m/d/Y)',
	'm/j/Y' => '12 1 2003  (m/j/Y)',
	'Y/m/d' => '1999 12 25  (Y/m/d)',
	'Y/d/m' => '1999 25 12  (Y/d/m)'
);

$short_date_format_select_html = dropDown(
	array(
		'type' => $short_date_formats, 
		'name' => "data[cfgShortDateFormat]", 
		'value' => getPref('cfgShortDateFormat'), 
		'size' => 32, 
		'label' => '' . $L['frontShortDateFormat'] . ''
	)
);

$front_rows['cfgShortDateFormat'] = $short_date_format_select_html;


// Make a date separator
$date_separator = array(
	'' => '',
	'/' => '/',
	'-' => '-',
	':' => ':',
	'.' => ':'
);

$date_separator_select_html = dropDown(
	array(
		'type' => $date_separator, 
		'name' => "data[cfgDateSeparator]", 
		'value' => getPref('cfgDateSeparator'), 
		'size' => 1, 
		'label' => '' . $L['frontDateSeparator'] . ''
	)
);

$front_rows['cfgDateSeparator'] = $date_separator_select_html;


// Make a LONG date format Selector:	
$long_date_formats = array(
	'' => '',
	'j/M/Y'     =>  $L['frontLongDateFormatjMY'],   //'25 Dec 1999',
	'j/F/Y'     =>  $L['frontLongDateFormatjFY'],   //'25 December 1999',
	'jS/F/Y'    =>  $L['frontLongDateFormatjSFY'],  //'25th December 1999',
	'M/j/Y'     =>  $L['frontLongDateFormatMjY'],   //'Dec 25 1999',
	'F/j/Y'     =>  $L['frontLongDateFormatFjY'],   //'December 25 1999',
	'F/jS/Y'    =>  $L['frontLongDateFormatFjSY'],  //'December 25th 1999',
	'l,/jS/F/Y' =>  $L['frontLongDateFormatljSFY'], //'Friday, 25th December 1999',
	'l,/F/jS/Y' =>  $L['frontLongDateFormatlFjSY'], //'Friday, December 25th 1999'
);

$long_date_format_select_html = dropDown(
	array(
		'type' => $long_date_formats, 
		'name' => "data[cfgLongDateFormat]", 
		'value' => getPref('cfgLongDateFormat'), 
		'size' => 32, 
		'label' => '' . $L['frontLongDateFormat'] . ''
	)
);

$front_rows['cfgLongDateFormat'] = $long_date_format_select_html;



// Make a time format Selector:	
$time_formats = array(
	'' => '',
	'H:i' => '23 59'
);

$time_format_select_html = dropDown(
	array(
		'type' => $time_formats, 
		'name' => "data[cfgTimeFormat]", 
		'value' => getPref('cfgTimeFormat'), 
		'size' => 32, 
		'label' => '' . $L['frontTimeFormat'] . ''
	)
);

$front_rows['cfgTimeFormat'] = $time_format_select_html;


// Make a time separator
$time_separator = array(
	'' => '',
	':' => ':',
	'/' => '/',
	'-' => '-'
);


$time_separator_select_html = dropDown(
	array(
		'type' => $time_separator, 
		'name' => "data[cfgTimeSeparator]", 
		'value' => getPref('cfgTimeSeparator'), 
		'size' => 1, 
		'label' => '' . $L['frontTimeSeparator'] . ''
	)
);

$front_rows['cfgTimeSeparator'] = $time_separator_select_html;

// --

$number_formats = array (
	'' => '',
	'normal' => '1,234.56',
	'francais' => '1 234,56',
);

$front_rows['frontNumberFormat'] = dropDown(
	array(
		'type' => $number_formats, 
		'name' => "data[frontNumberFormat]", 
		'value' => getPref('frontNumberFormat'), 
		'size' => 32, 
		'label' => $L['frontNumberFormat']
	)
);

// --

$currency_formats = array(
	'' => '',
	'CAD' => $L['frontCurrencyFormatCAD'],
	'EUR' => $L['frontCurrencyFormatEUR'],
	'GBP' => $L['frontCurrencyFormatGBP'],
	'NZD' => $L['frontCurrencyFormatNZD'],
	'PNL' => $L['frontCurrencyFormatPNL'],
	'RUR' => $L['frontCurrencyFormatRUR'],
	'USD' => $L['frontCurrencyFormatUSD']
);

$front_rows['frontCurrencyFormat'] = dropDown(
	array(
		'type' => $currency_formats, 
		'name' => "data[frontCurrencyFormat]", 
		'value' => getPref('frontCurrencyFormat'), 
		'size' => 32, 
		'label' => $L['frontCurrencyFormat']
	)
);

// --

// Make a Skin Selector:	

$SERVICES->getService('Screen');
$default_skins = $SERVICES->screen->getSkins();
if (is_array($default_skins)) {
	$skins = array();

	foreach ($default_skins as $k => $v) {
		$skins[$k] = $SERVICES->language->getLanguageText(trim($v['name']), 'Front');
	}

	$default_skin_select_html = dropDown(
		array(
			'type' => $skins, 
			'name' => "data[userDefaultSkin]", 
			'value' => getPref('userDefaultSkin'), 
			'size' => 32, 
			'label' => '' . $L['frontDefaultSkinForNewUsers'] . ''
		)
	);

	$front_rows['userDefaultSkin'] = $default_skin_select_html;
}
// --

// -- Index List Size --

$options1 = array(
	'10' => '10', 
	'20' => '20', 
	'30' => '30', 
	'40' => '40', 
	'50' => '50', 
	'60' => '60', 
	'70' => '70', 
	'80' => '80', 
	'90' => '90', 
	'100' => '100', 
	'All' => $L['ListAll']
);

$front_rows['cfgIndexListSize'] = dropDown(
	array(
		'type' => $options1, 
		'name' => "data[cfgIndexListSize]", 
		'value' => getPref('cfgIndexListSize'), 
		'size' => 32, 
		'label' => $L['IndexListSize']
	)
);

// -- List Detail Length --
$options2 = array(
	'10' => '10', 
	'15' => '15', 
	'20' => '20', 
	'25' => '25', 
	'30' => '30', 
	'35' => '35', 
	'40' => '40', 
	'45' => '45', 
	'50' => '50', 
	'100' => '100', 
	'All' => $L['ListAll']
);

$front_rows['cfgListDetailLength'] = dropDown(
	array(
		'type' => $options2, 
		'name' => "data[cfgListDetailLength]", 
		'value' => getPref('cfgListDetailLength'), 
		'size' => 32, 
		'label' => $L['ListDetailLength']
	)
);
//

// -- Last Viewed Row User Preference --

$last_viewed_modules = array(
	''  => '',
	'1' => $L['frontLastViewedAllModules'],
	'2' => $L['frontLastViewedContactModules'],
	'3' => $L['frontLastViewedNone']
);

$front_rows['lastViewedScope'] = dropDown(
	array(
		'type' => $last_viewed_modules, 
		'name' => "data[lastViewedScope]", 
		'value' => getPref('lastViewedScope'), 
		'size' => 48, 
		'label' => '' . $L['frontLastViewedRowModules'] . ''
	)
);


$options1 = array(
	'5' => '5', 
	'7' => '7', 
	'10' => '10', 
	'12' => '12', 
	'15' => '15', 
	'20' => '20', 
	'25' => '25', 
	'30' => '30', 
	'35' => '35', 
	'40' => '40', 
	'45' => '45', 
	'50' => '50', 
	'100' => '100', 
);

$front_rows['lastViewedListSize'] = dropDown(
	array(
		'type' => $options1, 
		'name' => "data[lastViewedListSize]", 
		'value' => getPref('lastViewedListSize'), 
		'size' => 48, 
		'label' => '' . $L['frontLastViewedListSize'] . ''
	)
);




// -- List Date Offset --
$options3 = array(
	'1' => '1', 
	'2' => '2', 
	'3' => '3', 
	'4' => '4', 
	'5' => '5', 
	'6' => '6', 
	'7' => '7', 
	'14' => '14', 
	'21' => '21', 
	'30' => '30', 
	'60' => '60', 
	'90' => '90'
);

$front_rows['cfgListDateOffset'] = dropDown(
	array(
		'type' => $options3, 
		'name' => "data[cfgListDateOffset]", 
		'value' => getPref('cfgListDateOffset'), 
		'size' => 32, 
		'label' => $L['ListDateOffset']
	)
);

// Refresh Interval
$refresh_options = array(
	'' => '',
	'0' => $L['frontManualRefreshOnly'],
	'120' => '2 ' . $L['MinutesFull'],
	'180' => '3 ' . $L['MinutesFull'],
	'240' => '4 ' . $L['MinutesFull'],
	'300' => '5 ' . $L['MinutesFull'],
	'600' => '10 ' . $L['MinutesFull'],
	'900' => '15 ' . $L['MinutesFull'],
	'1800' => '30 ' . $L['MinutesFull']
);

$refresh_options_select_html = dropDown(
	array(
		'type' => $refresh_options, 
		'name' => "data[frontRefresh]", 
		'value' => getPref('frontRefresh'), 
		'size' => 32, 
		'label' => '' . $L['frontRefreshInterval'] . ''
	)
);

	
$front_rows['frontRefresh'] = $refresh_options_select_html;

// --
// Display menu alerts for 'Other' modules (not in the users menu setup)
$boolean_options = array(
	'' => '',
	'0' => $L['No'],
	'1' => $L['Yes']
);

$refresh_options_select_html = dropDown(
	array(
		'type' => $boolean_options, 
		'name' => "data[frontMenuDisplayOtherAlerts]", 
		'value' => getPref('frontMenuDisplayOtherAlerts'), 
		'size' => 32, 
		'label' => '' . $L['frontMenuDisplayOtherAlerts'] . ''
	)
);

	
$front_rows['frontMenuDisplayOtherAlerts'] = $refresh_options_select_html;

// --

// $amount_display = array(
	// '' => '',
	// '15' => '15',
	// '20' => '20',
	// '30' => '30',
	// '50' => '50'
// );
// 
// $front_rows['frontDesktopDescriptionLength'] = dropDown(
	// array(
		// 'type' => $amount_display, 
		// 'name' => "data[frontDesktopDescriptionLength]", 
		// 'value' => getPref('frontDesktopDescriptionLength'), 
		// 'size' => 32, 
		// 'label' => $L['frontDesktopDescriptionLength']
	// )
// );

// --

// $row_cols = array(
	// '' => '',
	// '1' => '1',
	// '2' => '2',
	// '3' => '3',
	// '4' => '4', 
	// '5' => '5', 
	// '6' => '6', 
	// '7' => '7', 
	// '8' => '8', 
	// '9' => '9', 
	// '10' => '10'
// );
// 
// $front_rows['frontDesktopNumRowItems'] = dropDown(
	// array(
		// 'type' => $row_cols, 
		// 'name' => "data[frontDesktopNumRowItems]", 
		// 'value' => getPref('frontDesktopNumRowItems'), 
		// 'size' => 32, 
		// 'label' => $L['frontDesktopNumRowItems']
	// )
// );


// Default paging list size
$paging_list_size = array(
	'' => '',
	'5' => '5',
	'10' => '10',
	'20' => '20',
	'30' => '30',
	'50' => '50',
	'100' => '100',
	'All' => $L['ListAll']
);

$front_rows['frontDefaultListSize'] = dropDown(
	array(
		'type' => $paging_list_size, 
		'name' => "data[frontDefaultListSize]", 
		'value' => getPref('frontDefaultListSize'), 
		'size' => 32, 
		'label' => '' . $L['frontDefaultListSize'] . ''
	)
);


// frontDashboardshowLinkImages
// $front_rows['frontDashboardshowLinkImages'] = dropDown(
	// array(
		// 'type' => array($L['Yes'],$L['No']), 
		// 'name' => "data[frontDashboardshowLinkImages]", 
		// 'value' => getPref('frontDashboardshowLinkImages'), 
		// 'size' => 32, 
		// 'label' => $L['frontDashboardshowLinkImages']
	// )
// );
//

// -------

// Phil 20070524 Moved default permissions to Admin prefs


//add cal rows array to global prefs_rows array
$pref_rows['Front'] = $front_rows; 
?>