<?php
/**
 * The data definition for the item table
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Logger
 */

// Add data definition fields from database (standard and custom fields)
global $SERVICES;
$SERVICES->getService('DataDefinition');

$data_definition = array (
	'fields' => array(
		'version_from' => array('label' => 'Version From', 'field_key' => 'version_from', 'type' => 'dropdown', 'notnull' => 1, 'priority_edit' => 100, 'field_priority' => 100),
		'version_to' => array('label' => 'Version To', 'field_key' => 'version_to', 'type' => 'dropdown', 'notnull' => 1, 'priority_edit' => 110, 'field_priority' => 110),
		'id' => array('label' => 'Number', 'field_key' => 'id', 'type' => 'text', 'notnull' => 1, 'priority_edit' => 120, 'field_priority' => 120),
		'timestamp' => array('label' => 'Date And Time', 'field_key' => 'timestamp', 'type' => 'date_time', 'notnull' => 1, 'priority_edit' => 130, 'field_priority' => 130),
		'user_id' => array('label' => 'User', 'field_key' => 'user_id', 'type' => 'dropdown', 'notnull' => 1,  'dropdown_values'=>'__USERSALL__', 'priority_edit' => 135, 'field_priority' => 135),
		'facility' => array('label' => 'Facility', 'field_key' => 'facility', 'type' => 'text', 'notnull' => 1, 'priority_edit' => 140, 'field_priority' => 140),
		'priority' => array('label' => 'Priority', 'field_key' => 'priority', 'type' => 'long_text', 'notnull' => 1, 'priority_edit' => 150, 'field_priority' => 150),
		'message' => array('label' => 'Message', 'field_key' => 'message', 'type' => 'long_text', 'notnull' => 1, 'priority_edit' => 160, 'field_priority' => 160),
		'page' => array('label' => 'Page', 'field_key' => 'page', 'type' => 'text', 'notnull' => 1, 'priority_edit' => 170, 'field_priority' => 170),
	),
	'data_options' => array(
		'errors_list'  => array (
			'method' => 'include',
			'values' => array('id', 'timestamp', 'facility', 'user_id',  'message', 'page'), // Phil 20060706 removed priority
			'options' => array('exclude_hidden' => 0, 'dropdown_values' => 1, 'no_trim'=>1)
		),
	),

);	
?>