<?php
/** 
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 */

/**
 * Used to display info from the module in a contact view
 *
 * @package Mail
 */
class MailItemWebMATContactView extends WebMATContactView {
	
	/**
	 * Returns only the view link
	 * @author Phil Calder
	 */
	function getTableLinks($item) {
		return (array)$this->getViewLink($item['id']);
	}
	
	function getHeaderLinks() {
		// Overrides function in WebMATExpandableList
		if (isset($this->header_links) && $this->header_links) {
			$content = $this->header_links;
		} else {
			$content = array();
			if ($bookmark = $this->getBookmarkLinkLink()) {
				$content[] = $bookmark;
			}
			
			if ($all = $this->getAllLink()) {
				$content[] = $all;
			}
			
			if ($new = $this->getNewLink()) {
				// $new = $this->getNewFromTemplateLink() . $new;
				$content[] = $new;
			}
			
			if ($new_from_template = $this->getNewFromTemplateLink()) {
				$content[] = $new_from_template;
			}
			
		}
		
		if (is_array($content)) {
			//return implode($this->getMenuSeparator(), $content);
			return implode('', $content);
		} 
		
		return $content;
	}
	
	/**
	 * @author Phil Calder
	 */
	function getNewFromTemplateLink() {
		global $L;
		$id = $this->form_values['contact_id'];
		
		// $this->output->req_contactMenu_js = true;
		$mail_template_menu_link = '';
		// $mail_template_menu_link = $this->output->getLinkHref(
			// array(
				// 'href' => 'javascript:mailNewFromTemplateMenu(\'' . 'mtrMen' . $id . '\',\'' . $id . '\');',
				// 'img' => $this->output->getFlagMenu('mtrMen' . $id),
				// 'tag_extras' => ' onMouseOut="hM(\'contactMen\')" '
			// ),
			// false // no language text check
		// );
		$template_text_link = ' <a href="../../modules/Mail/template_menu.php?page=1&contact_id=' . $id . '">' . $L['mailSentStatusDropdownTemplates'] . '</a>'; // TODO: use a function / config lookup here
		return ($mail_template_menu_link . $template_text_link);
	}
	
	/**
	 * There is no 'edit' link for this module.
	 */
	function getEditLink($id = '') {
		// $img = $this->output->getImageTag('icons_dash/blank.gif', '', 'width="16" height="16"');
		// 
		// return $img;
		return '';
	}
	
	// Phil 20070212 Removed
	// function countItems() {
		// $count = '';
		// 
		// if (isset($this->mod) && is_object($this->mod)) {
			// $this->setPieceFilter();
			// // print '<div>[Mail ext] ' . get_class($this) . '::countItems mod: ' . $this->getModuleName() . '</div>';
			// $count = $this->db_functions->countItems();
			// // print '<div>mod: ' . $this->mod->getModuleName() . ', contact_id: ' . $this->getContactId() . ' countItems: ' . $count . '</div>';
			// // print '<p>count items: ' . $count . '</p>';
		// }
		// 
		// return $count;	
	// }
	
	/**
	 * Sets the order by (sorting) fields
	 * @author Phil Calder
	 */
	function beforeGetItems(&$sort, &$limit) {
		$sort = array(
			'field' => 'id', 
			'order' => 'DESC'
		);
	}
}
?>