<?php
/**
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Mail
 */

class MailItemWebMATBookmarkDashboard extends WebMATBookmarkDashboard {
	
	
	function init($module, $data_option) {
		
		parent::init($module, $data_option);
		
		$this->setHeaderLinks($this->getCheckLink() . $this->getBookmarkLinkLink() . $this->getNewLink());
		$this->mod->checkMailOverdueAccounts();
	}
	
	/**
	 * Sets the design time filter used to display the dashboard piece
	 */
	function setPieceFilter() {
		if (isset($this->db_functions) || (isset($this->mod) && is_object($this->mod))) {
			global $USER, $SERVICES;
			$module_name = $this->mod->getModuleName();
			if (!isset($this->db_functions)) {
				$this->db_functions =& $this->mod->getDatabaseTable('item');
			}
			if (!$this->dashboard_bookmark) {
				$table_name = $this->db_functions->getTableName();
				
				$system_bookmarks_mod =& $SERVICES->modules->getModule('SystemBookmarks');
				
				$this->dashboard_bookmark = $system_bookmarks_mod->getDesktopBookmark($module_name, $table_name);
			}
			if ($bookmark = $this->dashboard_bookmark) {
				if ($bookmark['extra_values']['filters']['dtf']) {
					$this->db_functions->resetDesignTimeFilters();
					$this->db_functions->setDesignTimeFilters($bookmark['extra_values']['filters']['dtf']);
				}
				if ($bookmark['extra_values']['filters']['filter_info']) {
					$this->db_functions->setFilter($bookmark['extra_values']['filters']['filter_info']);
				}
				if ($bookmark['extra_values']['sort']['field']) {
					$field = $bookmark['extra_values']['sort']['field'];
					if ($bookmark['extra_values']['sort']['order']) {
						$order = strtoupper($bookmark['extra_values']['sort']['order']);
					} else {
						$order = 'DESC';
					}
					$this->setSortField($field, $order);
				}
				
			} else {
				$this->db_functions->resetDesignTimeFilters();
				//$this->db_functions->setDesignTimeFilters( array('user_id' => $USER['user_id']) );
				$this->db_functions->setDesignTimeFilters( array('sent_status' => 'mailInbox', 'is_trash' => 0, 'active' => 1) );
			}
			//$this->db_functions->setDesignTimeFilters(array('is_opened'=>0,'sent_status' => 'mailInbox', 'is_trash' => 0, 'active' => 1));
			//$this->setSortField('date', 'DESC');
		}
	}
	
	function getCheckLink() {		
		global $L, $SERVICES;
		$SERVICES->getService('Preferences');
		//$refresh = $SERVICES->preferences->getUserPref('mailRefresh');
		// if ($refresh) {
			// $label = 'Automatically check mail every ' . $refresh/60 . ' ' . $L['MinutesFull'];
		// } else {
			// $label = 'Automatic mail checking disabled';
		// }
		$label = 'Check Mail Now';
		
		$href = '../Mail/check_email.php';
		
		$img = $this->output->getImageTag('icons_dash/mail_check.gif', $label, 'width="16" height="16"');
		// title = user pref for mail checking
		return $this->output->getLinkHref(array('href'=>$href, 'text'=>$img, 'title' => $label), false);
		//return $this->output->getLinkAll($link_href);
	
	}
}


?>