<?php
/**
 * The EMail-Merge Single edit class
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Mail
 * @author Phil Calder
 */

includeModule('Mail', 'inc/edit_edit.inc');

/**
 * The EMail-Merge Single edit class
 *
 * Used for sending a single message during an Email-merge. 
 * 
 * @author Phil Calder
 */
class MailMailMergeSingleEditWebMATEdit extends MailEditWebMATEdit {
	/**
	 * Does nothing (ie we dont redirect back from this class)
	 */
	function redirectBack($id = '') {
	}
	
	/**
	 * Prevent class from returning to list page during an Email-merge
	 *
	 * @return boolean true
	 */
	function getShowSentItemConfirmation() {
		return true;
	}
	
	/**
	 * Empty function
	 */
	function setupVerifyLeavingJavascript() {
	}
	
	/**
	 * Sets the return string variable for display pages
	 *
	 * @param boolean $return_string 
	 * @author Phil Calder
	 */
	function setReturnString($return_string = false) {
		$this->return_string = true;
	}
	
	/**
	 * Sets the return string variable for display pages to true
	 *
	 * @param boolean $return_string 
	 * @author Phil Calder
	 */
	function getReturnString($return_string = false) {
		$this->return_string = true;
		return true;
	}
	
	function main($return_string = true) {
		$this->return_string = true;
		return parent::main(true);
	}
	
	function getHash() {
		return $this->hash;
	}
	
}

?>