<?php
/**
 * The custom edit class for the Mail module
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Mail
 * @author Phil Calder, Simon Cook, Brenton LeTrabb
 */
 
includeModule('Mail', 'inc/item_edit.inc');
// print __FILE__ . '<hr>';
/**
 * The custom edit class for the Mail module
 * 
 * @package Mail
 * @author Phil Calder, Simon Cook, Brenton LeTrabb
 */
class MailPublicMailerWebMATEdit extends MailItemWebMATEdit {
	
	function beforeForm(&$id, &$item, &$error_msg) {
		// $this->setupAttachmentJavascript($item);
	}

	/**
	 * Disabled
	 */
	function getActionLinksContent() {
		return false;
	}
	
	/**
	 * Sets up the initial attachments for the email, should it be required
	 *
	 * @param array $item
	 * @param string $decoded_mail mime decoded_mail content (optional)
	 */
	function setInitialAttachments(&$item, $decoded_mail = false) {
		// print '<div>setInitialAttachments</div>'; 
		parent::setInitialAttachments($item, $decoded_mail);
		if (isset($this->include_attachments) && is_array($this->include_attachments)) {
			foreach ($this->include_attachments as $k => $v) {
				if (is_array($v)) {
					// print '<div>add session attachment:</div>'; print_r($v); print '<hr>';
					$_SESSION[$item['hash']]['strings'][] = $v;
				}
			}
		}
	}
	
	/**
	 * Disabled
	 *
	 * @param array $item
	 * @param bool $warning_message Defaulted to true, if it is true, it'll exit the script and display a message
	 */
	function checkoutMessage(&$item, $warning_message = true) {
	}

	/**
	 * disabled
	 *
	 * @param array $item
	 */
	function checkinMessage(&$item) {
	}
	
	/*
	 * Operations before we actually write to the db, included in here is sending
	 */
	// function beforeDBWrite(&$item, &$fields, &$error_msg) {
		// global $L, $SERVICES;
		// //echo 'fvhash' . $this->form_values['hash'] . '<br>';
		// //echo 'hash' . $item['hash'] . '<br>';
		// //echo 'SESShash' . $_SESSION[$item['hash']] . '<br>';
		// //print_r($_SESSION[$item['hash']]);
		// //$item['hash'] will be unset as message is sent
		// $temp['hash'] = $item['hash'];
		// 
		// //save item in case we have to return to form
		// //because $item gets processed
		// $original_item = $item;
		// 
		// // if we're doing a spell check, this function will redirect us there, thus ignoring the rest of this function
		// 
		// // if ($this->form_values['submitSpellCheck']) {
		// // 	$this->doSpellcheck($item);
		// // 	return;
		// // }
		// 
		// // setup so we know which account to use. - will exit out if none found
		// print '<div>get send account...</div>';
		// $sending_account = $this->getSendAccount($item);
		// print_r($sending_account); print '<hr>';
		// 
		// // Phil 20060714 Adding checks to ensure we are allowed to use 
		// // the transport method for this send account
		// $this->isTransportMethodAllowed($sending_account['transport_method'], $item);
		// 
		// // we may need to use this to update it later on.
		// // in some cases (like sending a drafted email), they should be appropriate
		// if ($item['parent_id']) {
			// $this->parent_item['id'] = $item['parent_id'];
		// } else if ($this->form_values['id']) {
			// // use the form_value var, and not item, cause for some reason, it's not set.
			// $this->parent_item['id'] = $this->form_values['id'];
		// }
		// 
		// // remove slashes from address fields
		// $item['recipient'] = stripslashes($item['recipient']);
		// $item['cc'] = stripslashes($item['cc']);
		// $item['bcc'] = stripslashes($item['bcc']);
// 
		// // add sender to item
		// $item['sender'] = $sending_account['from_name'] . ' <' . $sending_account['email_address'] . '>';
		// $item['send_account_id'] = $item['send_account'];
		// 
		// print '<div>call configureMailer(item, sending_account):</div>'; print_r($item); print_r($sending_account); print '<hr>';
		// // get $this->mailer ready for sending.
		// $this->configureMailer($item, $sending_account);
// 
		// // get the addresses the message will be sent to.
		// $this->recipient_addresses = $this->fillEmailMessage($item);
			// 
		// // now comes the main portion where we actually do some sending! (if applicable)
		// if ($this->form_values['submitSend']) {
			// // extra header info (thread_id) - maybe future stuff
			// //$extra_header = array('label' => 'BCRM-Thread-ID', 'value' => 2);
			// if ($_SESSION[$temp_hash]['sent']) {
				// //already sent, make notification
				// quickPage($L['mailAlreadySent'] . '<br> <br> ' . $this->output->getLinkBack($_SESSION['return_page']));
				// exit();
				// // return false;
				// // TODO add link to a 'resend' option
			// }
// 
			// // *SEND* the email
			// $this->msg = $this->doSend();
			// // $this->msg returned false, meaning there was an error, what was the problem?
			// if (!$this->msg && (!isset($this->return_string) || !$this->return_string)) { // Phil 20050506 - same as main - can return message as string OR display and exit
				// //Output::validateFields  $error_msg[$v['field_key']] = $validated['error'];
				// $this->description_message = $this->mailer->getError();
				// $this->description_status = 'error';
				// 
				// //$this->main( $item['id'], $temp_item, $error_msg);
				// //$error_msg['recipient'] = $this->mailer->getError();
				// //TODO all fields; loop
				// foreach ($original_item as $k => $v) {
					// $original_item[$k] = stripslashes($original_item[$k]); 
				// }
				// 
				// // $original_item['recipient'] = stripslashes($original_item['recipient']);
				// // $original_item['cc'] = stripslashes($original_item['cc']);
				// // $original_item['bcc'] = stripslashes($original_item['bcc']);
				// // $original_item['message_body'] = stripslashes($original_item['message_body']);
				// // $original_item['sig'] = stripslashes($original_item['sig']);
				// 
				// $this->main( $item['id'], $original_item, $error_msg);
				// 
				// //quickPage($this->mailer->ErrorInfo . '<br> <br> ' . $this->output->getLinkBack());
				// //can get parts and do something: retry option
				// exit();
				// 
			// } else {
				// //MCR 20051026
				// if ($temp_hash) {
					// //required to garbage collect on _SESSION
					// bcrm_unset($_SESSION, $temp_hash);
					// $_SESSION[$temp_hash]['sent'] = true;   //used as a 'sent' marker to prevent double-clicks / double sends
				// }
			// }
			// 
			// // track who actually sent it
			// global $USER;
			// $item['sent_by_user_id'] = $USER['id'];
			// 
			// // here we check if we've just sent a template, if so, we actually want to keep the template, so we unset the id
			// // (as opposed to a draft where we actually send the draft.)
			// if ($item['sent_status'] == 'mailTemplates') {
				// bcrm_unset($item, 'id');				
			// }
			// 
			// // made it this far, so set the status
			// $item['sent_status'] = 'mailSent';
			// $item['action_required'] = 0; // why should there be an action on a sent item?
// 
		// } else {
			// // probably going in as a template or draft
			// $this->msg = $this->mailer->buildMessage();
			// 
			// // set some status
			// if ($this->form_values['submitSaveDraft']) {
				// $item['sent_status'] = 'mailDraft';
			// } else if ($this->form_values['submitSaveTemplate']) {
				// $item['sent_status'] = 'mailTemplates';
			// }
		// }
		// 
		// // If the send was successful above, we will continue on through here, otherwise, this doesn't even get executed
		// 
		// // strip content component out of $item for writing to DB - since they don't exist in the db
		// bcrm_unset($item, 'content');
		// bcrm_unset($item, 'signature');
		// bcrm_unset($item, 'send_account');
// 
		// // some final items to set.
		// $item['date'] = time();
		// $item['is_opened'] = 1;
		// 
		// // defaults?
		// $item['view_group_id'] = $sending_account['message_view_group_id'];
		// $item['edit_group_id'] =  $sending_account['message_edit_group_id'];
		// $item['owner_group_id'] =  $sending_account['message_owner_group_id'];
		// $item['admin_group_id'] =  $sending_account['message_admin_group_id'];
	// }
	
	/*
	 * @author Phil Calder
	 */
	// function isTransportMethodAllowed($transport_method, $item) {
		// // print '<div>transport_method: ' . $transport_method . '</div>';
		// $is_enabled = $this->mod->isTransportMethodEnabled($transport_method);
		// if ($is_enabled) {
			// return true;
		// }
		// 
		// // set description message, status, then call main
		// global $L;
		// $this->description_status = 'error';
		// $this->description_message = $L['mailSmtpAccountTransportMethodNotAllowed'] . ': ';
		// 
		// switch ($transport_method) {
			// case 1:
				// $this->description_message .= $L['mailSMTPDropdownPHPMail'];
			// break;
			// case 2:
				// $this->description_message .= $L['mailSMTPDropdownSendmail'];
				// 
			// break;
			// case 3:
				// $this->description_message .= $L['mailSMTPDropdownSMTP'];
			// break;
			// case 4:
				// $this->description_message .= $L['mailSMTPDropdownSMTPAuthenticated'];
			// break;
			// default:
				// $this->description_message .= $L['mailSMTPDropdownUnknownTransportMethod'];
			// break;	
		// }
		// 
		// $this->main($item['id'], $item, $error_msg);
		// exit();
	// }

	/*
	 * Sets up to get ready for sending an email
	 *
	 * @param array $item
	 *
	 * @return array Returns an array of emails that the message will be sent to
	 */
	// function fillEmailMessage(&$item) {
		// $include_signature = !$this->form_values['submitSaveDraft'] && !$this->form_values['submitSaveTemplate'];
		// // Write addresses to item_email table <-- afterDBWrite
		// return $this->mailer->fillEmailMessage($item, $include_signature);
	// }
	
	/**
	 * Displays message and exits
	 *
	 * Overridden to NOT display link to create account
	 * @author Phil Calder
	 */
	function displayNoSendAccountMessage() {
		global $L;
		quickPage($L['mailNoAccount']);
		exit();
	}
	
	/**
	 * Displays message and exits
	 *
	 * Override to prevent the script exiting
	 * @author Phil Calder
	 */
	function displaySendSuccessMessage($success_msg, $content = '') {
		// quickPage($success_msg . '<br> <br> ' . $content);
		// exit();
		return true;
	}

	/**
	 * Disabled
	 */
	function doSubmitDelete() {
		return false;
	}
  
	/**
	 *Disabled
	 *
	 * @param array $item
	 */
	function doSpellcheck(&$item) {
		return false;
	}
	
	// function isEditable($id, $item = false){
		// if ($id) { // id passed in is for an existing item
			// return $this->db_functions->isEditable($id, $item);
		// }
		// return true;
	// }
}
?>