<?php
require_once("../../prepend.inc");

/**
 * The edit page
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Mail
 */


includeWebMAT('edit.inc');

global $SERVICES;
$SERVICES->getService('FileSystem');
$SERVICES->getService('Preferences');

class MailSpellcheckCustomEdit extends WebMATEdit {
	
	var $pspell_file;
	var $pspell_cfg_handle;
	var $langauge;
	
	function MailSpellcheckCustomEdit ($module, $data_option, $post = false, $get = false, $table_name = false, $language_overwrite = false) {
		
		parent::init($module, $data_option, $post, $get, $table_name, $language_overwrite);
		
		
		$this->setPSpellVars($this->form_values['item']['spelling_lang']);
	}
	
	function setPSpellVars($lang = false) {
		global $USER, $SERVICES;
		//echo $this->language;
		
		if ( ((!$lang)) || (!array_key_exists($lang, $this->lang_names))) {
			if ($SERVICES->preferences->getUserPref('mailSpellcheckLang')) {
				$this->language = $SERVICES->preferences->getUserPref('mailSpellcheckLang');
			} else {
				$this->language = 'en_us';
			}
		} else {
			$this->language = $lang;
		}
		
		$pspell_dir = $SERVICES->filesystem->getDirectoryPath('pspell');
		$this->pspell_file = $pspell_dir . '/' . $USER['id'] . '_' . $this->language . '.pws';
		$spelling = $this->lang_names[$this->language];
		$this->pspell_cfg_handle = pspell_config_create($this->language, $spelling);
	}
	
	var $lang_names = array('' => '',
				'en_uk' => 'English - British',
				'en_us' => 'English - American', 
				'fr' => 'Francais' ,
				'es' => 'Espanol',
				'pl' => 'Polish',
				'it' => 'Italian',
				'nl' => 'Dutch',
				'de' => 'Deutsch',
				'tr' => 'Turkish',
				'da' => 'Danish');
	
	function getSubmitJS() {
		$code = "
		<script type=\"text/javascript\" language=javascript>
		function processClose(){
			if(document.forms['mainform'].elements['item[spelling_subject]'].value != ''){
				window.opener.document.forms['mainform'].elements['item[subject]'].value = '" . $this->form_values['item']['spelling_subject'] . "';
			}
			
			if(document.forms['mainform'].elements['item[spelling_body]'].value != ''){
				window.opener.document.forms['mainform'].elements['item[content]'].value = '" . $this->form_values['item']['spelling_body'] . "';
			}
		}
		</SCRIPT>";
	return $code;
	}
	
	function beforeForm(&$id, &$item, &$error_msg) {
		global $SERVICES, $L, $USER;
		
		$this->output->setWhitespaceCompressionSwitch(false);
		
		//any other processing before the Form is created (ie. adding extra items)
		//print_r($this->form_values);
		if ($this->form_values['item']['spelling_subject']) {
			$_SESSION[$this->form_values['hash']]['subject'] = stripslashes($this->form_values['item']['spelling_subject']);
			$subject = $this->form_values['item']['spelling_subject'];
		} else {
			$subject = $_SESSION[$this->form_values['hash']]['subject'];
		}
		if ($this->form_values['item']['spelling_body']) {
			$_SESSION[$this->form_values['hash']]['content'] = stripslashes($this->form_values['item']['spelling_body']);
			$body = $this->form_values['item']['spelling_body'];
		} else {
			$body = $_SESSION[$this->form_values['hash']]['content'];
		}
		//$item['hash'] = $this->form_values['hash'];
		//print_r($_SESSION[$this->form_values['hash']]);
		// $body = $this->form_values['item']['spelling_body'];
		// $subject = $this->form_values['item']['spelling_subject'];
		// if (!$body) {
			// $body = 'this si a tset body';
		// }
		// if (!$subject) {
			// $subject = 'thsi is a test sujbect';
		// }
		//echo $subject;
		
		
		
		// get first wrong word etcetcetc
		if (function_exists('pspell_config_create') && 
		function_exists('pspell_new_config') && 
		function_exists('pspell_config_ignore') && 
		function_exists('pspell_config_mode') && 
		function_exists('pspell_config_personal') && 
		function_exists('pspell_add_to_personal') && 
		function_exists('pspell_save_wordlist')
		) {
		 // proceed
		} else {
			// pspell not supported (on this server)
			$content = $this->output->getTextRow($L['mailSpellcheckNotSupported']);
			$content .= $this->output->getTextRow('<input type="button" value="' . $L['Back'] . '" onClick="window.close();">');
			quickPage( $content );
			exit();
		}
		
		
		
		$codes = array(
				'en_us' => 'English - American', 
				'en_uk' => 'English - British',
				'fr' => 'Francais' ,
				'es' => 'Espanol',
				'pl' => 'Polish',
				'it' => 'Italian',
				'nl' => 'Dutch',
				'de' => 'Deutsch',
				'tr' => 'Turkish',
				'da' => 'Danish');
			
		if (function_exists('pspell_config_create') && function_exists('pspell_new_config')) {
		
			// add [not installed] message by seeing which languages aspell supports
			// turn errors off because pspell generates Notices if a language not found
			$old_error_reporting = error_reporting(0);
			foreach ($codes as $k => $val) {
				$pspell_cfg_handle = pspell_config_create($k, $val);
				if ((!pspell_new_config($pspell_cfg_handle))) {
					if (! ($k == '')) {
						$codes[$k] = $codes[$k] . ' ' . $L['mailSpellcheckLangNotInstalled'];
						// print '<div>Code: ' . $k . ' for lang: ' . $val . '</div>';
					}
				}	
			}
			error_reporting($old_error_reporting);
		}
		
		$this->dd->changeAttributes(array('field_key' => 'spelling_lang', 'dropdown_values' => $codes, 'tag_extras' => 'onChange="submit()"'));
		//echo 'lala';
		
		$this->setPSpellVars($item['spelling_lang']);
		$spelling = $codes[$this->langauge];
		
		if(!isset($_SESSION[$this->form_values['hash']]['spelling_checking'])) {
			$checking = 'subject';
		} else {
			$checking = $_SESSION[$this->form_values['hash']]['spelling_checking'];
		}
			
		if(!isset($_SESSION[$this->form_values['hash']]['spelling_curloc'])) {
			$curloc = 1;
		} else {
			$curloc = intval($_SESSION[$this->form_values['hash']]['spelling_curloc']);			
		}
		//echo $curloc;
		// Our list of words to exclude from checking
		$exclude = $_SESSION[$this->form_values['hash']]['spelling_exclude'];
		if(!isset($exclude)) {
			$exclude = array('', '<', '>', 'Re:', 'Fw:');
		}
	
		
		$subject = stripslashes($subject);
		$body = stripslashes($body);
		
				
		// pspell generates notices - disable them for now (this code handles them separately);
		$old_error_settings = error_reporting(0);
		
		$pspell_dir = $SERVICES->filesystem->getDirectoryPath('pspell');
		$pspell_file = $pspell_dir . '/' . $USER['id'] . '_' . $this->language . '.pws';
		
		// Initalise the spellchecker
		$pspell_cfg_handle = pspell_config_create($this->language, $spelling);
		
		pspell_config_ignore($pspell_cfg_handle, 0); 
		pspell_config_mode($pspell_cfg_handle, PSPELL_NORMAL);
		
		if (file_exists($pspell_file)) {
			pspell_config_personal($pspell_cfg_handle, $pspell_file);
		}
		
		$pspell_handle = pspell_new_config($pspell_cfg_handle); 
		
		// print '<div>handle: ' . $pspell_handle . '</div>';
		// print '<div>language: ' . $language . '</div>';
		// print '<div>spelling: ' . $spelling . '</div>';
		
		if (!$pspell_handle) {
			// language not supported by pspell (on this server)
			$content = $this->output->getTextRow($L['mailSpellcheckLangNotSupportedByPspell']);
			$content .= $this->output->getUserPrefRow($L['mailSpellcheckLang'], 'mailSpellcheckLang', '', $PHP_SELF);
			quickPage( $content );
			exit();
		}
		
		//print('Subject: ' . nl2br($subject));
		//print('Body: ' . nl2br($body));
		//print('Excluding: ');print_r($exclude);
		//die();
		
		if($checking == 'subject')
			$check_text = $subject;
		else
			$check_text = $body;
			
		// Change the inputs with any new spellings we have
		
		
		$explode_check = explode(' ', str_replace("\n", ' ' , $check_text));
		$curloc--;
		$found_check = true;
			
		while($found_check && $checking != 'done'){
			// Now move onto the next word
			$curloc++;
			$curword = trim($explode_check[$curloc]);
			if(!in_array($curword, $exclude) && ereg('([^a-zA-Z]*)([a-zA-Z]*|.*[a-zA-Z]$)([^a-zA-Z]*)', $curword, $curword_split)){
				$curword = $curword_split[2];
				$found_check = pspell_check($pspell_handle, $curword);
			}
			
			if(in_array($curword, $exclude))
				$found_check = true;
				
			if($curloc == sizeof($explode_check) && $found_check){
				if($checking == 'subject'){
					$check_text = $body;
					$explode_check = explode(' ', str_replace("\n", ' ' , $check_text));
					$checking = 'body';
					$curloc = -1;
				} else {
					$checking = 'done';
				}
			}	
		}
		
		$explode_para = array('');
		if($checking != 'done'){
			// Get the paragraph of the current word - for context
			$explode_check_para = explode("\n" , $check_text);
			foreach($explode_check_para as $paragraph){
				$explode_para = $explode_para_searched = explode(' ' , $paragraph);
				$loc = true;
				while($loc !== false){
					$loc = array_search($explode_check[$curloc], $explode_para_searched);
					if($loc !== false){
						$match_para = true;
						foreach($explode_para as $para_loc => $para_word){
							if($para_word != $explode_check[($curloc-$loc)+$para_loc]){
								$match_para = false;
								$explode_para_searched[$loc] = '';
							}
						}
					}
					if($match_para)
						break;
				}
				if($match_para)
						break;
			}
		} else {
			quickPage('Spellcheck Complete. <br><br><a href="'. $_SESSION[$this->form_values['hash']]['return_script_name'] .'?hash=' . $this->form_values['hash'] . '">'. $L['mailFinished'] .'</a>');
			exit();
			//exit();
		}
		// Get our list of suggestions
		$suggestions = pspell_suggest($pspell_handle, $curword);
		
		// put error reporting settings back the way they were
		error_reporting($old_error_settings);
		
		// assign item variables with content that has been generated?
		
		$_SESSION[$this->form_values['hash']]['spelling_checking'] = $checking;
		//$item['spelling_checking'] = $checking;
		$_SESSION[$this->form_values['hash']]['spelling_curloc'] = $curloc;
		$_SESSION[$this->form_values['hash']]['spelling_curword'] = $curword;
		$_SESSION[$this->form_values['hash']]['spelling_exclude'] = $exclude;
		$item['spelling_lang'] = $this->language;
		$suggestion_array = array();
		foreach ($suggestions as $k => $v) {			
			$suggestion_array[$v] = $v;
			if (!$item['spelling_suggestions']) {
				$item['spelling_suggestions'] = $suggestion_array[$v];
			}
		}
		$this->dd->changeAttributes(array('field_key' => 'spelling_suggestions', 'dropdown_values' => $suggestion_array, 'tag_extras' => 'onChange=document.forms.mainform.elements["item[spelling_new]"].value=this.value;'));
		
		//print_r($suggestions);
		$inc = '';
		foreach($explode_para as $k => $next_word){
			if($loc == $k)
				$inc .= str_replace(bcrm_htmlspecialchars($curword), '<font color="ff0000">'.bcrm_htmlspecialchars($curword).'</font>', bcrm_htmlspecialchars($next_word));
			else
				$inc .= bcrm_htmlspecialchars($next_word);
				
			if($k != sizeof($explode_para))
				$inc .= ' ';
		}
		$item['spelling_word'] = $inc;
		if (isset($suggestions[0])) {
			$item['spelling_new'] = $suggestions[0];
		}
	}
	
	function beforeDBWrite(&$item, &$fields, &$error_msg) {  //passed by reference
		//any other processing before posting to database
		global $USER, $L;
				
		//if ($this->form_values['submit1'] == 'Cancel') {
		if ($this->form_values['submitCancel']) {
			header('Location: edit.php?hash=' . $this->form_values['hash']);
		}
		if ($_SESSION[$this->form_values['hash']]['spelling_checking'] == 'subject') {			
			$check_text = $_SESSION[$this->form_values['hash']]['subject'];
		} else {			
			$check_text = $_SESSION[$this->form_values['hash']]['content'];
		}
		
		//if($this->form_values['submit1'] == 'Change'){
		if($this->form_values['submitChange']){

			$explode_check = explode(' ', str_replace("\n", '??&&**REPLACELINEBREAK**&&?? ' , $check_text));
			//print_r($explode_check);
			$explode_check[$_SESSION[$this->form_values['hash']]['spelling_curloc']] = str_replace($_SESSION[$this->form_values['hash']]['spelling_curword'], $item['spelling_new'], $explode_check[$_SESSION[$this->form_values['hash']]['spelling_curloc']]);
			//print_r($explode_check);
			$check_text = str_replace('??&&**REPLACELINEBREAK**&&?? ', "\n", implode(' ', $explode_check));
			
			if($_SESSION[$this->form_values['hash']]['spelling_checking'] == 'subject')
				$subject = $check_text;
			else
				$body = $check_text;
				 
		} elseif($this->form_values['submitChangeAll']){
			$check_text = str_replace($_SESSION[$this->form_values['hash']]['spelling_curword'], $item['spelling_new'], $check_text);
			
			if($_SESSION[$this->form_values['hash']]['spelling_checking'] == 'subject')
				$subject = $check_text;
			else
				$body = $check_text;
			
		//} elseif( $this->form_values['submit1'] == 'Ignore'){
		} elseif( $this->form_values['submitIgnore']){
			$_SESSION[$this->form_values['hash']]['spelling_curloc']++;
			
		} elseif($this->form_values['submitIgnoreAll']){
			$_SESSION[$this->form_values['hash']]['spelling_exclude'][] = $_SESSION[$this->form_values['hash']]['spelling_curword'];
			$_SESSION[$this->form_values['hash']]['spelling_curloc']++;
			
		}elseif($this->form_values['submitAddToDictionary']){
			if(!file_exists($this->pspell_file)){
				pspell_config_personal($this->pspell_cfg_handle, $this->pspell_file);
				$pspell_handle = pspell_new_config($this->pspell_cfg_handle);
			} else {
				pspell_config_personal($this->pspell_cfg_handle, $this->pspell_file);
			}
			$include_set = '';
			$pspell_handle = pspell_new_config($this->pspell_cfg_handle);
			$spelling_curword = stripslashes($_SESSION[$this->form_values['hash']]['spelling_curword']);
			echo $spelling_curword;
			//$word_pattern = "([^a-zA-Z]*)([a-zA-Z]*|.*[a-zA-Z]$)([^a-zA-Z]*)";
			$word_pattern = '^([a-zA-Z]+)$'; //regular expression for English word
			//echo ('<br>'.ereg($word_pattern, $spelling_curword));
			if (!ereg($word_pattern, $spelling_curword)) {
				quickPage('<font color="red">' . $spelling_curword . '</font> ' . $L['errNotValidWord'] . '<br> <br> <a href="spellcheck.php?hash=' . $this->form_values['hash'] . '">' . $L['Back'] . '</a>');
				exit();
			}
						
			pspell_add_to_personal($pspell_handle, stripslashes($_SESSION[$this->form_values['hash']]['spelling_curword']));
			pspell_save_wordlist($pspell_handle);
			
		} else {
			// Do nothing
		}
		
		if ($subject) {
			$this->form_values['item']['spelling_subject'] = $subject;
		}
		if ($body) {
			$this->form_values['item']['spelling_body'] = $body;
		}
		//echo $body;
		
		
		//print_r($this->form_values);
		$this->main();
		exit();
	}
	
	function getSubmitRow() {
		global $L;
		$content = '
		<tr>
			' . str_repeat('<td>&nbsp;</td>', 2) . '
			<td align="center" colspan="2"><table><tr><td>' . 
			$this->output->getHtmlSubmit($L['mailSpellCheckAddToDictionary'] , 'submitAddToDictionary') . '</td><td>' . 
			$this->output->getHtmlSubmit($L['mailSpellCheckChange'], 'submitChange') . '</td><td>' . 
			$this->output->getHtmlSubmit($L['mailSpellCheckChangeAll'], 'submitChangeAll') . '</td><td>' . 
			$this->output->getHtmlSubmit($L['mailSpellCheckIgnore'] , 'submitIgnore') . '</td><td>' . 
			$this->output->getHtmlSubmit($L['mailSpellCheckIgnoreAll'] , 'submitIgnoreAll'). '</td>'.
		'</tr><tr><td colspan="5" align="right"><br>' . 
			$this->output->getHtmlSubmit($L['mailSpellCheckCancel'] , 'submitCancel') . '</td></tr></table></td>
		</tr>';
		
		return $content;
	}
	
	function run() {
		if (isset($this->form_values['submitAddToDictionary'])
				|| isset($this->form_values['submitChange'])
				|| isset($this->form_values['submitChangeAll'])
				|| isset($this->form_values['submitIgnore'])
				|| isset($this->form_values['submitIgnoreAll'])
				|| isset($this->form_values['submitCancel'])
				
				|| isset($this->form_values['delete'])) {
					
			if ($this->form_values['delete']) {
				$_SESSION['return_page'] = $_SERVER["HTTP_REFERER"];
			}
			$this->submit = 1;
			$this->doSubmit();
		}
		
		//Session set here so that it only happens once per edit
		$_SESSION['return_page'] = $_SERVER["HTTP_REFERER"];
	}
}

$mailSpellcheckCustomEdit = new MailSpellcheckCustomEdit('Mail', 'spellcheck', $_POST, $_GET); 

global $L;
$L['mailTitleNew_itemedit'] = $L['mailTitle_spellcheckedit'];

$mailSpellcheckCustomEdit->run();

$mailSpellcheckCustomEdit->main();

?>
