<?php
/**
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Memo
 */

/**
 * The Memo edit class
 * 
 * @package Memo
 */
class MemoItemWebMATEdit extends WebMATEdit {
	
	function init($module, $data_option, $post, $get, $table_name, $language_overwrite) {
		parent::init($module, $data_option, $post, $get, $table_name, $language_overwrite);
		$this->archive = $this->form_values['archive'];
	}
	
	/**
	 * deletes the item.
	 */
	function afterDelete($item) {
		header('Location: index.php');
		exit();
	}
	
	/**
	 * soft deletes the item.
	 */
	function doSubmitDelete() {
		$this->db_functions->setItemSeenStatus($this->delete, 4);
	}

	/**
	 * @author Bosco 20060327
	 */
	function editTableLinks(& $links, $id, $item) {
		global $USER;
		//this may not needed if the memo has been deleted 05/06/01 Cecil
		if ($id && !$this->db_functions->isActive($id)) {
			bcrm_unset($links, 'memoArchive');
		}
	}
	
	/**
	 * any processing required before adding to the form is created
	 * 
	 * CHANGED to set default values if the memo is an reply
	 */
	function beforeForm(&$id, &$item, &$error_msg) {
		global $SERVICES, $USER,$L;
		if ($this->form_values['reply']) {
			//Syed Bosco 20050718 | Added to check if the user has editable permission
			if(!$this->db_functions->isEditable($this->form_values['reply'],$item)) {
				quickPage($L['errNoPermissions'] . '<br> <br> ' . $this->getLinkReturnPage() );
				exit();
			}			
			$users =& $SERVICES->getService('Users');
			$db_functions =& $this->mod->getDatabaseTable('item');
			
			
			if ($item = $db_functions->getItem($this->form_values['reply'])) { // Sender
				$sender = $users->getPrivateGroup($item['creator_id']);
			}
			
			// Remove new senders private group (to remove from recipients)
			$new_sender = $users->getPrivateGroup($USER['user_id']);
			
			// Original Recipients
			$db_functions =& $this->mod->getDatabaseTable('item_group');
			$reply = $this->db_functions->getItem($this->form_values['reply']);
			$item_groups = $db_functions->getItems('', '', 'item_id=' . $this->form_values['reply']);
			$recipients = array();
			foreach ($item_groups as $k =>$v) {
				if ($v['group_id'] != $new_sender) {
					$recipients[] = $v['group_id'];
				}
			}
			$item['groups'] = $recipients;
			if (!in_array($sender, $item['groups'])) {
				$item['groups'][] = $sender;
			}
			
			$item['subject'] = 'Re: ' . $reply['subject'];
		}
	}
}
?>