<?php
/**
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Memo
 * @author Minggang Chen, Phil Calder
 */

/**
 * The Memo view class
 * 
 * @package Memo
 * @author Minggang Chen, Phil Calder
 *
 */
class MemoItemWebMATView extends WebMATView {
	/**
	 * Adds detail_currency and detail_int1 displays it in the calc field
	 * 
	 * @param array $dd_item the items with dd structure
	 */
	function calculateValues(& $dd_item, $item) {
		global $SERVICES, $L, $USER;
		
		$output =& $SERVICES->getService('Output');
		$unseen_flag = $output->getFlagUnseenByOther();
		//$unseen_flag = $output->getImageTag('img/flag_unread.png', $L[''], 'width="16" height="16" border="0" hspace="1"');
		
		$ua =& $SERVICES->getService('Authentication');
		$all_users = $ua->users->getUsersList();
		$dd_item['creator_id']['value'] = $ua->users->getUsername($item['creator_id']);
		
		$db_functions =& $this->mod->getDatabaseTable('item_seen');
		$recipients = $db_functions->getItems('', '', 'item_id=' . $item['id']);
		if ($recipients) {
			$count = 1;
			// Bosco 20050706 | Added to remove creator name from recipients list
            $recipients_count = count($recipients);

			foreach ($recipients as $k => $v) {
				// Bosco 20050706 | Added condition to remove creator Name from recipients list
				if ($v['user_id'] && !(($recipients_count != 1) && ($v['user_id'] == $item['creator_id']))) {
					if (!$v['seen']) {
						$dd_item['recipients']['value'] .= $unseen_flag . '';
					}
					$dd_item['recipients']['value'] .= $all_users[$v['user_id']]. ', ';
					
					// Add a line break for every 5 recipients
					// Output adds nowrap to the row because of images (the unseen flag)
					if ( $count && ( $count %5 == 0)) { 
						$dd_item['recipients']['value'] .= '<br>';
					}
					$count++;
				}
			}
			$dd_item['recipients']['value'] = trim($dd_item['recipients']['value'], ', ');
		}
	}
	
	function editTableLinks(& $links, $id, $item) {
		global $USER;
		bcrm_unset($links, 'edit');
		if ($this->db_functions->isArchived($id)) {
			bcrm_unset($links, 'memoArchive');
		}
		//this may not needed if the memo has been deleted 05/06/01 Cecil 
		if (!$this->db_functions->isActive($id)) {
			bcrm_unset($links, 'delete');
			bcrm_unset($links, 'memoArchive');
		}
		
		if ($item['creator_id'] == $USER['user_id']) {
			bcrm_unset($links, 'memoReply');
		}
	}
}
?>