<?php
/**
 * The data definition for the item table
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Memo
 */

global $SERVICES, $L;
$SERVICES->getService('Preferences');

$data_definition = array (
	'fields' => array(
		'id' => array('label'=>'', 'field_key'=>'id', 'type'=>'hidden'),
		// Bosco 20050625 | Added regex for client side Validation 
		'subject' => array('label'=>$L['memoSubject'], 'field_key'=>'subject', 'type'=>'text', 'notnull'=>1, 'regex'=>'\\\\S+', 'max_length' => 128, 'display_name' => 1,'priority_edit' => 400),
		'creator_id' => array('label'=>$L['memoSender'], 'field_key'=>'creator_id', 'type'=>'text', 'disable_filter' => 1, 'priority_edit' => 390),
		'groups' => array('label'=>$L['memoSendTo'], 'field_key'=>'groups','type'=>'multi_select', 'dropdown_values'=>'__GROUPS__', 'notnull'=>1, 'size' => 7),
		'recipients' => array('label'=>$L['memoRecipient'], 'field_key'=>'recipients', 'type'=>'text','priority_edit' => 395, 'calculated'=>1),
		'contact_id' => array('label'=>$L['Contact'], 'field_key'=>'contact_id', 'type'=>'contact', 'priority_edit' => 410), 
		'body' => array('label'=>$L['memoMemoBody'], 'field_key'=>'body', 'type'=>'long_text', 'rows' => 15,'priority_edit' => 415),
		'created' => array('label'=>$L['memoDate'], 'field_key'=>'created', 'type'=>'date_time','priority_edit' => 412),
		'last_update' => array('label'=>'', 'field_key'=>'last_update', 'type'=>'hidden'),
	),
	'data_options' => array(
		'edit' => array(
			'method' => 'exclude',
			'values' => array('creator_id', 'created', 'recipients'),
			'options' => array('exclude_hidden' => 1, 'dropdown_values' => 1)
			),
		'list' => array(
			'method' => 'include',
			'values' => array('creator_id', 'created', 'subject', 'recipients', 'contact_id'), 
			'options' => array('exclude_hidden' => 0, 'no_trim'=>1, 'dropdown_values' => 1)
			
		),
		'view' => array(
			'method' => 'include',
			'values' => array('id', 'creator_id', 'created', 'subject', 'recipients', 'body', 'contact_id'),
			'options' => array('exclude_hidden' => 1, 'dropdown_values' => 0)
		),
		'contact_view' => array(
			'method' => 'include',
			'values' => array('created', 'subject'), // , 'contact_id'),
			'options' => array('exclude_hidden' => 0)
			
		),
		'mass_list' => array(
			'method' => 'include',
			'values' => array('subject', 'created'),
			'options' => array('exclude_hidden' => 1, 'dropdown_values' => 0)
		),
		'search' => array(
			'method' => 'include',
			'values' => array('subject', 'body'),
			'options' => array('search_title' => 'title', 'dropdown_values' => 0, 'exclude_calculated' => 1)
		),
		'search_results' => array(
			'method' => 'include',
			'values' => array('contact_id','subject'),
			'options' => array('dropdown_values' => 1)
		), 
		'desktop' => array(
			'method' => 'include',
			'values' => array('contact_id','subject'),
			'options' => array('dropdown_values' => 1)
		),
		'advanced_filter' => array(
			'method' => 'include',
			'values' => array('contact_id','creator_id','subject','created','body'),
			'options' => array('dropdown_values' => 1)
		),
	)
);
?>