<?php
/**
 * Used to display info from the module in a contact view
 * 
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Person
 * @author Phil Calder
 *
 */
class PersonItemWebMATShortView extends WebMATShortView {
	
	var $path_to_module;
	
	var $show_person_contact_view = true;
	
	function PersonItemWebMATShortView($module, $data_option, $post, $get) {
		
		$this->show_person_contact_view = $this->showPersonContactView($get['id']);
		
		$this->original_id = $get['id'];
		
		$get['id'] = $this->getPersonIdFromContact($get['id']);
		
		parent::WebMATShortView($module, $data_option, $post, $get);
	}	
	
	function main($return_string = true) {
		if (!$this->show_person_contact_view) {
			return '';
		}
		return parent::main($return_string);
	}
	
	function showPersonContactView($contact_id) {
		if ($contact_id) {
			
			$contact_db =& $this->getContactModuleTable();
			$contact_item = $contact_db->getItem($contact_id);
			
			if ($contact_item['id'] == $contact_item['contact_company']) {
				return false;
			} else {
				return true;
			}
			
		}
		
		return false;
	}
	
	function getPersonIdFromContact($contact_id) {
		
		global $SERVICES;
		$SERVICES->getService('Modules');
		
		$this->mod =& $SERVICES->modules->getModule('Person');
		
		return $this->mod->getPersonIdFromContact($contact_id);
		/*
		$db_functions =& $person->getDatabaseTable('item');
		$db_functions->setDesignTimeFilters(array('contact_id'=>$contact_id, 'primary_record'=>1));
		$item = $db_functions->getItem(false);
		
		return $item['id'];	
		*/
	}	
	
	function getDisplayName($id) {
		
		$item =  $this->db_functions->getItem($id);
		
		return $item['display_name'];
		
	}
	
	function getMenuItems($id) {
		global $SERVICES;
			
		if ($id && $this->db_functions->isEditable($id)) {
			return trim($this->getEditLink($id) . $this->getMenuSeparator() . $this->getDeleteLink($id), $this->getMenuSeparator());
		} else {
			
			// Display new link only if user has permission to edit the contact
			$contact_db =& $this->getContactModuleTable();
			if ($contact_db->isEditable($this->getContactId())) {
				return $this->getNewLink($this->contact_id);
			}
			
		}

		
		
		return '';
		
	}
	
	function getDeleteLink($id = '') {
		if ($this->isPerson()) {
			// $link_href = '../../modules/Contact/edit.php?delete=' . $this->original_id;
			$contact =& $this->getContactModule();
			$link_href = $contact->getContactDeleteLink(true);
			$link_href = str_replace('%id%', $this->original_id, $contact_delete_url);
			return $this->output->getLinkDelete($link_href);
		}
		return '';
	}
	
	function getEditLink($id = '') {
		if ($this->isPerson()) {
			$link_href = '../../modules/Person/edit.php?id=' . $id;
			return $this->output->getLinkEdit($link_href);
		}
		return '';
	}
	
	function isPerson() {
		if ($this->original_id) { // the id (for the contact) from the query string
			
			// global $SERVICES;
			// $SERVICES->getService('Modules');
			// $contact =& $SERVICES->modules->getModule('Contact');
			$contact =& $this->getContactModule();
			
			return $contact->isPerson($this->original_id);
			
		}
		
		return false;
	}
	
	function getMenuSeparator() {
		
		return '&nbsp;|&nbsp;';
		
	}
	
	function &getContactModule() {
		global $SERVICES;
		$SERVICES->getService('Modules');
		
		$contact =& $SERVICES->modules->getModule('Contact');
		return $contact;
	}
	
	function &getContactModuleTable() {
		// global $SERVICES;
		// $SERVICES->getService('Modules');
		// 
		// $contact =& $SERVICES->modules->getModule('Contact');
		$contact =& $this->getContactModule();
		
		$db_functions =& $contact->getDatabaseTable('item');
		
		return $db_functions;
		
	}
	
	function getNewLink($id = '') {
		
		if ($link = $this->getFileSetHref($this->edit_link)) {
			
			$link_href = $this->getModulePath() . str_replace('%id%', '', (str_replace('%contact_id%', $id, $link)) );
			
			$link_href .= '&contact_view=1';
			
			global $L; // 'New Person'
			$text = $L['personTitleNew_itemedit'];
			
			return $this->output->getLinkNew($link_href, $text);
			;
			
		}
		
		return false;
		
	}

}
?>