<?php
/**
 * Contains the User Preferences name and details
 *
 * Use this file to set up Company / User Preferences which are configured from 
 * Admin. This file is included by Front/preferences.php for User Preferences 
 * and UserAdmin/preferences.php for Company Preferences.
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Search
 */
	
//this files wil be included by /Front/preferences.php accessed under Admin
//which will create a form for setting system-wide UserPrefs
global $SEARCH, $L;

$SERVICES->getService('Modules');

$mod =& $SERVICES->modules->getModule("Search");
	
$prefs_items = array();

// NOTE: be sure to preface any new options here with  $L['searchScope...'] followed by the key
// so the are referred to correctly in results.php line 84
// TODO: call search mod -> getModules to populate search_scope
$scope_options = array(
	'' => '',
	'ContactOnly' => $L['searchScopeContact'],
	'NotMail' => $L['searchScopeNotMail'],
	'All' => $L['searchScopeAll'],
);

$mod->addIndividualModules($scope_options);

$prefs_items['searchScope'] = dropDown(
	array(
		'type' => $scope_options, 
		'name' => "data[searchScope]", 
		'value' => getPref('searchScope'), 
		'size' => 32, 
		'label' => $L['searchStandardSearchScope']
	)
);
//

$type_options = array(
	'' => '',
	'initial' => $L['searchInitialMatch'],
	'contains' => $L['searchContaining']
);

$prefs_items['searchType'] = dropDown(
	array(
		'type' => $type_options, 
		'name' => "data[searchType]", 
		'value' => getPref('searchType'), 
		'size' => 32, 
		'label' => $L['searchType']
	)
);

// 
$results_options = array(
	'' => '',
	'5'  => '5',
	'10' => '10', 
	'15' => '15', 
	'20' => '20', 
	'25' => '25', 
	'30' => '30', 
	'40' => '40', 
	'50' => '50', 
	'75' => '75', 
	'100'=> '100', 
	'All' => $L['ListAll']
);

$prefs_items['searchMaxResultsPerModule'] = dropDown(
	array(
		'type' => $results_options, 
		'name' => "data[searchMaxResultsPerModule]", 
		'value' => getPref('searchMaxResultsPerModule'), 
		'size' => 32, 
		'label' => $L['searchMaxResultsPerModule']
	)
);

// searchIncludeCustomFields
$include_custom = array(
	'' => '',
	'0' => $L['No'],
	'1' => $L['Yes']
);

$prefs_items['searchIncludeCustomFields'] = dropDown(
	array(
		'type' => $include_custom, 
		'name' => "data[searchIncludeCustomFields]", 
		'value' => getPref('searchIncludeCustomFields'), 
		'size' => 32, 
		'label' => $L['searchIncludeCustomFields']
	)
);
//


/* disabled for now
// Make a select for the number of search results to display
$number_search_display = array(
	'' => '',
	'5' => '5',
	'10' => '10',
	'20' => '20',
	'30' => '30',
	'50' => '50',
	'100' => '100',
	'All' => 'All'
);

$prefs_items['searchNumberResultsDisplay'] = dropDown(
	array(
		'type' => $number_search_display, 
		'name' => "data[searchNumberResultsDisplay]", 
		'value' => getPref('searchNumberResultsDisplay'), 
		'size' => 32, 
		'label' => '' . $L['searchNumberOfSearchResultsToDisplay'] . ''
	)
);
*/

//add tasks rows array to global prefs_rows array
$pref_rows['Search'] = $prefs_items; 

?>