<?php
/**
 * The main class for this module
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Tasks
 */

includeModule('Tasks', 'inc/database_tables.inc');

class Tasks extends WebMATModule {
	
	function Tasks() {
		$this->module_name = 'Tasks';
		$this->WebMATModule();
		$this->setSharedVars();
	}
	
	function setSharedVars() {
		global $L;
		//$SERVICES->getService('Language');
		
		$this->shared_vars['alert_in_advance'] = array(
			// '-1' => $L['NoAlert'], // Phil 20050428 removed
			'0' => $L['tasksStartAlertAtStartTime'],
			'300' => '5 ' . $L['Minutes'],
			'600' => '10 ' . $L['Minutes'],
			'900' => '15 ' . $L['Minutes'],
			'1200' => '20 ' . $L['Minutes'],
			'1800' => '30 ' . $L['Minutes'],
			'2700' => '45 ' . $L['Minutes'],
			'3600' => '60 ' . $L['Minutes'],
			'7200'=> '2 ' .  $L['HoursFull'],
			'10800' => '3 ' . $L['HoursFull'],
			'14400' => '4 ' . $L['HoursFull'],
			'18000' => '5 ' . $L['HoursFull'],
			'21600' => '6 ' . $L['HoursFull'],
			'43200' => '12 '. $L['HoursFull'],
			'86400' => '1 ' . $L['DayFull'],
			'172800' => '2 ' . $L['DaysFull'],
			'259200' => '3 ' . $L['DaysFull'],
			'604800' => '7 ' . $L['DaysFull'],
			'1209600' => '14 '. $L['DaysFull']
		);
		
		$this->shared_vars['alert_end'] = array(
			'-1' => $L['tasksStopAlertManualOnly'],
			'60' => $L['tasksStopAlertAtStartTime'],
			'300' => '5 ' . $L['Minutes'],
			'600' => '10 ' . $L['Minutes'],
			'900' => '15 ' . $L['Minutes']
		);
		
	}
	
	function getSharedVars($variable_set) {
		return $this->shared_vars[$variable_set];
	}
	
	/**
	 * @deprecated version 5
	 * @return mixed $links - the parameter unchanged
	 */
	function replaceLinkVariables($id, $item, $links) { 
		// // print '<div>module. id: ' . $id . '</div>'; print_r($item); print_r($links); print '<hr>';
		// if ($id) {
			// foreach ($links as $k => $v) {
				// if (isset($item['priority_id']) && $item['priority_id']) {
					// $links[$k] = str_replace('%priority%', 1 , $v);
				// } else {
					// $links[$k] = str_replace('%priority%', 0 , $v);
				// }
			// }
		// } else {
			// foreach ($links as $k => $v) {
				// if (isset($_GET['priority_id']) && $_GET['priority_id']) {
					// $links[$k] = str_replace('%priority%', 1 , $v);
				// } else {
					// $links[$k] = str_replace('%priority%', 0 , $v);
				// }
			// }
		// }
		return $links;
	}
}
?>