<?php
/**
 * A collection of classes extended from WebMATDatabaseTable
 * 
 * You need an extended class for each table in you module not including the 
 * dropdown tables.
 * 
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package Template
 */

/**
 * This class handles the database functions for the item table
 * 
 * This module is an extend verison of WebMATDatabaseTable with the table_name 
 * set and the alert_where set.
 * 
 * @author Matthew Corich
 */
class itemTemplateDatabaseTable extends WebMATDatabaseTable {
	
	/**
	 * The constructor class for itemTemplateDatabaseTable
	 *
	 * @param string $module_name the module name
	 * @param array $data_definition the data definition
	 */
	function itemTemplateDatabaseTable($module_name, $data_definition) {
		global $USER;
		$this->table_name = 'item';
		$this->WebMATDatabaseTable($module_name, $data_definition); //calls the constructor for WebMATDatabaseTable
	}
	
	/**
	 * Adds detail_currency and detail_int1 displays it in the calc field
	 * 
	 * @param array $dd_item the items with dd structure
	 */
	function calculateValues(& $dd_item, $item) {
		$dd_item['calc']['value'] = $dd_item['detail_currency']['value'] + $dd_item['detail_int1']['value']; 
	}
}
?>