<?php
//error_reporting(0);
error_reporting(E_ALL^E_NOTICE);
// print __FILE__ . '<hr>';
if (isset($bcrm_pub_root)) {
	require_once($bcrm_pub_root . "/public_prepend.inc.php");
} else {
	require_once("./public_prepend.inc.php");
}
/**
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 */
 
// Display category list
// Display category contents
// Display item

/**
 * @author Phil Calder
 */
class WebFormKnowledgeBaseViewer extends BrowserCRMWebForm {
	
	/**
	 * Sets the webform identifier arg
	 */
	function WebFormKnowledgeBaseViewer($args = array()) {
		// Default contact form
		$args['identifier'] = 'webform.kbviewer';
		$this->init($args);
		
		global $SERVICES;
		$SERVICES->getService('Modules');
		// $this->output = $SERVICES->getService('Output');
		$mod = $SERVICES->modules->getModule('KnowledgeBase');
		$this->db_functions = $mod->getDatabaseTable('item');
		
		$this->messages['kbviewer_internal_error'] = 'KnowledgeBase unavailable';
		$this->messages['kbviewer_no_categories'] = 'There are no categories to display';
		$this->messages['kbviewer_list_categories'] = 'Category List';
		$this->messages['kbviewer_category_items'] = 'Category articles';
		
		$this->messages['kbviewer_item_subject'] = 'Subject';
		$this->messages['kbviewer_item_author'] = 'Author';
		$this->messages['kbviewer_item_publish_date'] = 'Published';
		$this->messages['kbviewer_item_last_update'] = 'Updated';
		$this->messages['kbviewer_item_body'] = 'Article';
		$this->messages['kbviewer_item_not_viewable'] = 'This article cannot be displayed';
		
	}
	
	function doDisplay($id = '', $item = '', $error_msg = '') {
		if ($this->isClientLoginRequired()) {
			$this->clientLogin();
		}
		
		if (isset($this->form_values['category']) && $this->form_values['category']) {
			$content = $this->getCategoryItems($this->form_values['category']);
		} else if (isset($this->form_values['id']) && $this->form_values['id']) {
			$content = $this->getItem($this->form_values['id']);
		} else {
			$content = $this->getCategoryList();
		}
		
		$page_content = $this->getViewPage();
		$page_content = str_replace('%content%', $content, $page_content);
		print $page_content;
	}
	
	
	function getCategoryList() {
		$content = '';
		$dropdown = new WebMATDropDown('KnowledgeBase', 'dropdown');
		if (!is_object($dropdown)) {
			return $this->messages['kbviewer_internal_error'];
		}
		$items = $dropdown->getValues(); // TODO - check isViewable
		
		if (is_array($items) && sizeof($items)){
			$title = $this->messages['kbviewer_list_categories'];
			$content .= '<p>' . $title . '</p>';
			$content .= '<ul id="kbviewer_category_list">';
			foreach($items as $k => $v) {
				$label = '<a href="kb.php?category=' . $k . '">' . $v . '</a>';
				$content .= '<li>' . $label . '</li>';
			}
			$content .= '</ul>';
		} else {
			return $this->messages['kbviewer_no_categories'];
		}
		return $content;
		
	}
	
	function getCategoryItems($category = false) {
		$content = '';
		// TODO - check isViewable
		$items = $this->db_functions->getItemsForDropdown($category);
		// print_r($items);
		if (is_array($items) && sizeof($items)){
			$title = $this->messages['kbviewer_category_items'];
			$content .= '<p>' . $title . '</p>';
			
			$content .= '<ul id="kbviewer_category_item_list">';
			foreach($items as $k => $item) {
				$subject = '<a href="kb.php?id=' . $item['id'] . '">' . $item['subject'] . '</a>';
				$content .= '<li>' . $subject . '</li>';
			}
			$content .= '</ul>';
		}
		return $content;
	}
	
	function getItem($id) {
		$content = '';
		$id = (int)$id;
		if ($id) {
			$item = $this->db_functions->getItem(($id));
			if (is_array($item) && sizeof($item)){
				$content .= '<table id="kbviewer_item_tbl" class="kbviewer_item_tbl">';
				
				$content .= '<tr><th>' . $this->messages['kbviewer_item_subject'] . '</th><td>' . $item['subject'] . '</td>';
				
				if (isset($item['author']) && $item['author']) {
					$content .= '<tr><th>' . $this->messages['kbviewer_item_author'] . '</th><td>' . $item['author'] . '</td>';
				}
				if (isset($item['created']) && $item['created']) {
					$content .= '<tr><th>' . $this->messages['kbviewer_item_publish_date'] . '</th><td>' . date("F j, Y, g:i a", $item['created']) . '</td>';
				}
				if (isset($item['last_update']) && $item['last_update']) {
					$content .= '<tr><th>' . $this->messages['kbviewer_item_last_update'] . '</th><td>' . date("F j, Y, g:i a", $item['last_update']) . '</td>';
				}
				
				$content .= '<tr><th>' . $this->messages['kbviewer_item_body'] . '</th><td>' . $item['body'] . '</td>';
				
				$content .= '</table>';
				
				return $content;
			}
		}
		
		return $this->messages['kbviewer_item_not_viewable'];
	}
	
	
	/**
	 * Disabled 
	 *
	 * @return false
	 */
	function doSubmit() {
		return false;
	}
}

$webform = new WebFormKnowledgeBaseViewer();
$webform->main();

?>
