#
# STRUCTURE FOR TABLE: Documents__folder
#

CREATE TABLE `Documents__folder` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(128) NOT NULL default '',
  `parent_id` int(11) NOT NULL default '0',
  `priority` int(3) NOT NULL default '100',
  `active` tinyint(1) NOT NULL default '1',
  `created` int(11) NOT NULL default '0',
  `last_update` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `parent_id` (`parent_id`)
) TYPE=MyISAM;



#
# STRUCTURE FOR TABLE: Documents__item
#

CREATE TABLE `Documents__item` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(128) NOT NULL default '',
  `folder_id` int(11) NOT NULL default '0',
  `owner_group_id` int(11) NOT NULL default '0',
  `contact_id` int(11) NOT NULL default '0',
  `version_id` int(11) NOT NULL default '0',
  `mime_type_id` int(11) NOT NULL default '0',
  `view_group_id` int(11) unsigned NOT NULL default '0',
  `edit_group_id` int(11) unsigned NOT NULL default '0',
  `admin_group_id` int(11) NOT NULL default '0',
  `active` tinyint(1) NOT NULL default '1',
  `created` int(11) NOT NULL default '0',
  `uploaded_on` int(11) NOT NULL default '0',
  `last_update` int(11) NOT NULL default '0',
  `creator_id` int(11) NOT NULL default '0',
  `file_name` varchar(255) NOT NULL default '',
  `file_extension` varchar(16) NOT NULL default '',
  `file_size_bytes` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mime_type_id` (`mime_type_id`),
  KEY `folder_id` (`folder_id`),
  KEY `edit_group_id` (`edit_group_id`),
  KEY `view_group_id` (`view_group_id`),
  KEY `owner_group_id` (`owner_group_id`),
  KEY `admin_group_id` (`admin_group_id`)
) TYPE=MyISAM;

#
# STRUCTURE FOR TABLE: Documents__item_seen
#

CREATE TABLE `Documents__item_seen` (
  `item_id` int(11) NOT NULL default '0',
  `user_id` int(11) NOT NULL default '0',
  `seen` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`item_id`,`user_id`)
) TYPE=MyISAM;

#
# STRUCTURE FOR TABLE: Documents__mime_type
#

CREATE TABLE `Documents__mime_type` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(128) NOT NULL default '',
  `mime_type_category_id` int(11) NOT NULL default '0',
  `priority` int(3) NOT NULL default '100',
  `active` tinyint(1) NOT NULL default '1',
  `created` int(11) NOT NULL default '0',
  `last_update` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

#
# STRUCTURE FOR TABLE: Documents__mime_type_category
#

CREATE TABLE `Documents__mime_type_category` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(128) NOT NULL default '',
  `main_type` varchar(32) NOT NULL default '',
  `view_in_browser` tinyint(1) NOT NULL default '0',
  `priority` int(3) NOT NULL default '100',
  `active` tinyint(1) NOT NULL default '1',
  `created` int(11) NOT NULL default '0',
  `last_update` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

#
# STRUCTURE FOR TABLE: Documents__status
#

CREATE TABLE `Documents__status` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(128) NOT NULL default '',
  `priority` int(3) NOT NULL default '100',
  `active` tinyint(1) NOT NULL default '1',
  `created` int(11) NOT NULL default '0',
  `last_update` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

#
# STRUCTURE FOR TABLE: Documents__version
#

CREATE TABLE `Documents__version` (
  `id` int(11) NOT NULL auto_increment,
  `version` varchar(128) NOT NULL default '0',
  `notes` text NOT NULL,
  `size` int(11) NOT NULL default '0',
  `file_name` varchar(255) NOT NULL default '',
  `item_id` int(11) NOT NULL default '0',
  `mime_type_id` int(11) NOT NULL default '0',
  `status_id` int(11) NOT NULL default '0',
  `active` tinyint(1) NOT NULL default '1',
  `created` int(11) NOT NULL default '0',
  `uploaded_on` int(11) NOT NULL default '0',
  `last_update` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `item_id` (`item_id`),
  KEY `status_id` (`status_id`)
) TYPE=MyISAM;


#
# DATA FIELDS FOR MODULE: Documents
#


#
# DATA OPTIONS FOR MODULE: Documents
#

