#
# STRUCTURE FOR TABLE: System__cookies
#

CREATE TABLE `System__cookies` (
  `id` int(11) NOT NULL auto_increment,
  `random_id` varchar(128) NOT NULL default '',
  `username` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `random_id` (`random_id`,`username`)
) TYPE=MyISAM;



#
# STRUCTURE FOR TABLE: System__dashboard_dropdown
#

CREATE TABLE `System__dashboard_dropdown` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(64) NOT NULL default '',
  `priority` int(3) NOT NULL default '100',
  `active` tinyint(1) NOT NULL default '1',
  `user_id` int(11) NOT NULL default '0',
  `no_alerts` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `active_user_id` (`active`,`user_id`)
) TYPE=MyISAM;

#
# STRUCTURE FOR TABLE: System__default_modules
#

CREATE TABLE `System__default_modules` (
  `name` varchar(32) NOT NULL default '',
  `def_admin_privs` tinyint(4) NOT NULL default '7',
  `def_everyone_privs` tinyint(4) NOT NULL default '3',
  `for_new_install` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`name`),
  KEY `for_new_install` (`for_new_install`)
) TYPE=MyISAM;

#
# STRUCTURE FOR TABLE: System__groups
#

CREATE TABLE `System__groups` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `name` varchar(32) NOT NULL default '',
  `visible` tinyint(4) NOT NULL default '1',
  `editable` tinyint(4) NOT NULL default '0',
  `type` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`)
) TYPE=MyISAM;

#
# STRUCTURE FOR TABLE: System__module_group
#

CREATE TABLE `System__module_group` (
  `module_id` int(11) unsigned NOT NULL default '0',
  `group_id` int(11) unsigned NOT NULL default '0',
  `priv` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`module_id`,`group_id`)
) TYPE=MyISAM PACK_KEYS=0;

#
# STRUCTURE FOR TABLE: System__modules
#

CREATE TABLE `System__modules` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `name` varchar(32) NOT NULL default '',
  `is_custom` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`)
) TYPE=MyISAM;

#
# STRUCTURE FOR TABLE: System__prefs_block
#

CREATE TABLE `System__prefs_block` (
  `pref_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`pref_id`)
) TYPE=MyISAM;

#
# STRUCTURE FOR TABLE: System__prefs_key
#

CREATE TABLE `System__prefs_key` (
  `id` int(11) NOT NULL auto_increment,
  `pref_key` varchar(64) NOT NULL default '',
  `default_value` varchar(64) NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `pref_key` (`pref_key`)
) TYPE=MyISAM;

#
# STRUCTURE FOR TABLE: System__prefs_screen
#

CREATE TABLE `System__prefs_screen` (
  `screen_res_id` int(11) NOT NULL default '0',
  `screen_spot_id` int(11) NOT NULL default '0',
  `value` int(4) NOT NULL default '0',
  PRIMARY KEY  (`screen_res_id`,`screen_spot_id`)
) TYPE=MyISAM;

#
# STRUCTURE FOR TABLE: System__prefs_screen_res
#

CREATE TABLE `System__prefs_screen_res` (
  `id` int(11) NOT NULL auto_increment,
  `screen_res` varchar(255) NOT NULL default '',
  `width` int(11) NOT NULL default '0',
  `height` int(11) NOT NULL default '0',
  `num_nav_links` int(11) NOT NULL default '12',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

#
# STRUCTURE FOR TABLE: System__prefs_screen_spot
#

CREATE TABLE `System__prefs_screen_spot` (
  `id` int(11) NOT NULL auto_increment,
  `page_key` varchar(30) NOT NULL default '',
  `spot_key` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

#
# STRUCTURE FOR TABLE: System__prefs_user
#

CREATE TABLE `System__prefs_user` (
  `user_id` int(11) NOT NULL default '0',
  `pref_id` int(11) NOT NULL default '0',
  `pref_value` text NOT NULL,
  PRIMARY KEY  (`user_id`,`pref_id`)
) TYPE=MyISAM;

#
# STRUCTURE FOR TABLE: System__user_group
#

CREATE TABLE `System__user_group` (
  `user_id` int(11) unsigned NOT NULL default '0',
  `group_id` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`user_id`,`group_id`)
) TYPE=MyISAM;

#
# STRUCTURE FOR TABLE: System__users
#

CREATE TABLE `System__users` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `username` varchar(32) NOT NULL default '',
  `password` varchar(47) NOT NULL default '',
  `last_login` int(11) NOT NULL default '0',
  `last_load` int(11) NOT NULL default '0',
  `skin` varchar(32) NOT NULL default '',
  `screen_res_id` int(11) NOT NULL default '1',
  `contact_id` int(11) unsigned NOT NULL default '0',
  `welcome` tinyint(1) NOT NULL default '1',
  `session_id` varchar(32) NOT NULL default '',
  `private_group_id` int(11) NOT NULL default '0',
  `status` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `username` (`username`),
  KEY `password` (`password`),
  KEY `last_load` (`last_load`),
  KEY `last_login` (`last_login`),
  KEY `contact_id` (`contact_id`),
  KEY `private_group_id` (`private_group_id`),
  KEY `session_id` (`session_id`),
  KEY `welcome` (`welcome`),
  KEY `skin` (`skin`),
  KEY `status` (`status`)
) TYPE=MyISAM;

#
# STRUCTURE FOR TABLE: System__version
#

CREATE TABLE `System__version` (
  `version` varchar(10) NOT NULL default ''
) TYPE=MyISAM;


#
# DATA FIELDS FOR MODULE: System
#


#
# DATA OPTIONS FOR MODULE: System
#

