#
# STRUCTURE FOR TABLE: SystemDataDefinition__data_options
#

CREATE TABLE `SystemDataDefinition__data_options` (
  `id` int(11) NOT NULL auto_increment,
  `field_table` varchar(128) NOT NULL default '',
  `type` varchar(32) NOT NULL default '',
  `method` varchar(32) NOT NULL default '',
  `option_values` text NOT NULL,
  `exclude_hidden` tinyint(1) NOT NULL default '0',
  `exclude_calculated` tinyint(1) NOT NULL default '1',
  `dropdown_values` tinyint(1) NOT NULL default '1',
  `no_trim` tinyint(1) NOT NULL default '0',
  `active` tinyint(4) NOT NULL default '1',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `table_type` (`field_table`,`type`),
  KEY `field_table` (`field_table`),
  KEY `active` (`active`),
  KEY `active_table` (`active`,`field_table`(20))
) TYPE=MyISAM;



#
# STRUCTURE FOR TABLE: SystemDataDefinition__fields
#

CREATE TABLE `SystemDataDefinition__fields` (
  `field_id` int(11) NOT NULL auto_increment,
  `field_table` varchar(128) NOT NULL default '',
  `field_is_custom` tinyint(1) NOT NULL default '1',
  `field_key` varchar(64) NOT NULL default '',
  `explanation` text,
  `label` varchar(128) NOT NULL default '',
  `list_label` varchar(128) NOT NULL default '',
  `list_detail_length` int(11) NOT NULL default '0',
  `type` varchar(128) NOT NULL default 'text',
  `dropdown_values` varchar(128) default NULL,
  `config_key` varchar(128) default '',
  `default_value` text,
  `min` int(11) NOT NULL default '0',
  `max` int(11) NOT NULL default '0',
  `maxlength` int(11) NOT NULL default '0',
  `rows` int(11) NOT NULL default '6',
  `width` int(11) NOT NULL default '0',
  `notnull` tinyint(1) NOT NULL default '0',
  `read_only` tinyint(1) NOT NULL default '0',
  `disable_filter` tinyint(1) NOT NULL default '0',
  `csv` tinyint(1) NOT NULL default '0',
  `calculated` tinyint(1) NOT NULL default '0',
  `foreign` tinyint(4) NOT NULL default '0',
  `multi_edit_width` int(11) NOT NULL default '0',
  `field_priority` int(11) NOT NULL default '500',
  `priority_edit` int(11) NOT NULL default '500',
  `hidden` tinyint(4) NOT NULL default '0',
  `display_name` tinyint(1) NOT NULL default '0',
  `display_with_nbsp` tinyint(1) NOT NULL default '0',
  `append_only` tinyint(1) NOT NULL default '0',
  `hide_empty` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`field_id`),
  KEY `notnull` (`notnull`),
  KEY `field_table` (`field_table`)
) TYPE=MyISAM;


#
# DATA FIELDS FOR MODULE: SystemDataDefinition
#


#
# DATA OPTIONS FOR MODULE: SystemDataDefinition
#

