<?php
/**
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package WebMAT
 */

includeWebMAT('expandable_list.inc');
includeWebMAT('pieces_view.inc');
/**
 * Class for displaying content pieces
 * @see WebMATDesktop
 * @abstract
 * @package WebMAT
 * @author Phil Calder
 */
class WebMATStandardDesktopPieces  extends WebMATPieces {
//class WebMATStandardDesktopPieces  extends WebMATExpandableList {
	
	/**
	 * Content consists of a table row with nested content table inside
	 *
	 * The nested table is surrounded by expandable divs.
	 * @return string content for the list page (empty if display mode = 2)
	 * @author Phil Calder
	 */
	function getDisplayContent() {
		// print '<div>' . get_class($this) . ' module: ' . $this->getModuleName() . ' piece: ' . $this->getPieceId() . '</div>';
		$content = '';
		if ($this->getContentDisplayMode() != 2) {
			//do first so that we have flag as to whether there are items or not
			// $piece_content = $this->getTable();
			$piece_content = $this->getDataContent();
			$content .= $this->output->getBeginRow() . $this->output->getBeginCell(2); 

			$content_flag = '';
			if ($this->getContentDisplayMode()) {
				$content_flag = 'openContent';	
				$attribute_flag = 'true';
			} else { 
				$content_flag = 'preContent';	
				$attribute_flag = '';
			}


			$content .= '<div class="' . $content_flag . '" id="' . strtolower($this->getPieceId()) . 'Piece' . '" isOpen="' . $attribute_flag . '"><div class="content">';
			$content .= $this->output->getBeginTable('searchPieceTable'); // using this to set a width (100%)
			$content .= $piece_content;
			$content .= $this->output->getEndTable();
			$content .= '</div></div>'; 
			
			$content .= $this->output->getEndCell() . $this->output->getEndRow(); 
		}

		return $content;
	}


	/**
	 * Gets the header row from the output class
	 * 
	 * Sorting disabled for pieces
	 * @param array $table_lables
	 * @param array $sort (will be ignored by this method)
	 * @return string the header row
	 * @author Phil Calder
	 */
	function getSubTableHeader($table_labels, $sort) {
		$sort = '';
		return parent::getSubTableHeader($table_labels, $sort);
	}
	
	function startDataBlock() {
		return $this->output->startDataBlock();
	}


	function endDataBlock() {
		return $this->output->endDataBlock();
	}

	/**
	 * Over-rides the functionin webmat_expandable_list, we don't want a link.
	 *
	 * @return string The number of items found in parantesis
	 */
	function getItemCounts() {
		return '(' . $this->countItems() . ')';
	}

	/**
	 * Overrides to prevent showing a title row image
	 */
	function getTitleImage() {}
	/**
	 * Overrides to prevent showing an alert image
	 */
	function getAlertLink() {}
	
	/**
	 * Overridden to exclude iterator for certain modules
	 *
	 * @todo Use a config lookup here
	 * @author Phil Calder
	 */
	function useGetItemsIterator() {
		$module_name = $this->getModuleName();
		$no_iterator = array(
			'Memo',
			'Mail',
			'Calendar',
			'Forum'
		);
		if (in_array($module_name, $no_iterator)) {
			return false;
		}
		return parent::useGetItemsIterator();
	}
}

?>