<?php
/**
 * @license http://www.browsercrm.com/licence.php  BrowserCRM Software Licence
 * @copyright Copyright (c) 2003 - 2007 BrowserCRM Limited
 * @link http://www.browsercrm.com/
 * @package WebMAT
 */

includeWebMAT('expandable_list.inc');

/**
 * Class for displaying content pieces
 * @see WebMATDashboard
 * @see WebMATContactView
 * @abstract
 * @package WebMAT
 * @author Phil Calder
 */
class WebMATStandardPieces  extends WebMATExpandableList {
	
	/**
	 * Content consists of a table row with nested content table inside
	 *
	 * The nested table is surrounded by expandable divs.
	 * @return string content for the list page (empty if display mode = 2)
	 * @author Phil Calder
	 */
	function getDisplayContent() {
		$content = '';
		// print '<div>' . get_class($this) . '::getDisplayContent - ' . $this->getPieceId() . '</div>';
		if ($this->getContentDisplayMode() != 2) {
			//do first so that we have flag as to whether there are items or not
			if (isset($this->do_show_items) && $this->do_show_items) {
				$piece_content = $this->getTable();
			} else {
				$piece_content = '';	
			}
			// if (!isset($this->items_count) || !$this->items_count) {
				// $has_items = false;
				// $piece_content = $this->getNoItemsMessage();
			// } else {
				// $has_items = true;
			// }
			$content .= $this->output->getBeginRow() . $this->output->getBeginCell(2); 
			
			$content_flag = '';
			if ($this->getContentDisplayMode()) {
				$content_flag = 'openContent';	
				$attribute_flag = 'true';
			} else { 
				$content_flag = 'preContent';	
				$attribute_flag = '';
			}
			
			$content .= '<div class="' . $content_flag . '" id="' . strtolower($this->getPieceId()) . 'Piece' . '" isOpen="' . $attribute_flag . '"><div class="content">';
			// $content .= $this->output->getBeginTable('pieceContentTable'); // -
			// $content .= $this->output->getBeginTable('contactPieceTable'); // Phil 20050804 - using this to set a width (100%)
			$content .= $this->output->getBeginTable('pieceTbl'); // Phil 20060130
			
			$content .= $piece_content;
			$content .= $this->output->getEndTable();
			$content .= '</div></div>'; 
			
			$content .= $this->output->getEndCell() . $this->output->getEndRow(); 
		}
		
		return $content;
	}
	
	/**
	 * Gets a unique piece identifier to prefix to the html id
	 *
	 * @return string unique piece identifier
	 * @author Matthew Ross
	 *
	 */
	function getHtmlIdPrefix() {
		// print '<div>' . get_class($this) . ' getHtmlIdPrefix = ' . strtolower($this->getPieceId()) . '</div>';
		return strtolower($this->getPieceId());
	}
	
	/**
	 * Gets the header row from the output class
	 * 
	 * Sorting disabled for pieces
	 * @param array $table_lables
	 * @param array $sort (will be ignored by this method)
	 * @return string the header row
	 * @author Phil Calder
	 */
	function getSubTableHeader($table_labels, $sort) {
		$sort = '';
		return parent::getSubTableHeader($table_labels, $sort);
	}
	
	function startDataBlock() {
		return $this->output->startDataBlock();
	}
	
	function endDataBlock() {
		return $this->output->endDataBlock();
	}
}
?>